using AweCoreDemo.Data;
using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;


namespace AweCoreDemo.Controllers.Awesome.AjaxDropdown
{
    public class MealBoundToManyController : Controller
    {
        public IActionResult GetItems(int[] parent, string mealName = "")
        {
            parent = parent ?? new int[] { };

            var meals = Db.Meals
                .Where(o => (parent.Contains(o.Category.Id)) && o.Name.Contains(mealName))
                .ToArray();

            return Json(meals.Select(o => new KeyContent(o.Id, o.Name)));
        }
    }
}