using AweCoreDemo.Data;
using AweCoreDemo.Models;
using AweCoreDemo.Utils;
using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;

namespace AweCoreDemo.Controllers.Awesome.Lookup
{
    public class CategoryLookupController : Controller
    {
        public IActionResult GetItem(int? v)
        {
            Check.NotNull(v, "v");
            var ent = Db.Find<Category>(v) ?? new Category();

            return Json(new KeyContent(ent.Id, ent.Name));
        }

        public IActionResult Search(int page, string search = "")
        {
            var query = Db.Categories.Where(f => f.Name.Contains(search)).AsQueryable();

            var res = AweUtil.BuildList(query, page,
                keyContentFunc: o => new KeyContent(o.Id, o.Name));

            return Json(res);
        }
    }
}