using AweCoreDemo.Data;
using AweCoreDemo.Models;
using AweCoreDemo.Utils;
using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;


namespace AweCoreDemo.Controllers.Awesome.Lookup
{
    public class ChefLookupController : Controller
    {
        public IActionResult GetItem(int? v)
        {
            Check.NotNull(v, "v");
            var o = Db.Find<Chef>(v) ?? new Chef();
            return Json(new KeyContent(o.Id, o.FirstName + " " + o.LastName));
        }

        public IActionResult Search(int page, string search = "")
        {
            const int PageSize = 7;

            var list = Db.Chefs.Where(f => (f.FirstName + " " + f.LastName).Contains(search)).ToList();
            return Json(new AjaxListResult
            {
                Items = list.Skip((page - 1) * PageSize).Take(PageSize).Select(o => new KeyContent(o.Id, o.FullName)),
                More = list.Count() > page * PageSize
            });
        }
    }
}