using AweCoreDemo.Data;
using AweCoreDemo.Models;
using AweCoreDemo.Utils;
using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;

namespace AweCoreDemo.Controllers.Awesome.Lookup
{
    public class MealCustomItemLookupController : Controller
    {
        public IActionResult SearchForm()
        {
            return PartialView();
        }

        public IActionResult GetItem(int? v)
        {
            Check.NotNull(v, "v");
            var ent = Db.Find<Meal>(v);

            return Json(new KeyContent(ent.Id, ent.Name));
        }

        public IActionResult Search(int page, string search = "")
        {
            var query = Db.Meals.Where(f => f.Name.Contains(search)).AsQueryable();

            var res = AweUtil.BuildList(query, page,
                setContentFunc: items => this.RenderPartialView("items", items));

            return Json(res);
        }

        public IActionResult Details(int id)
        {
            return PartialView(Db.Find<Meal>(id) ?? new Meal());
        }
    }
}