using AweCoreDemo.Data;
using AweCoreDemo.Models;
using AweCoreDemo.Utils;
using AweCoreDemo.Utils.Awesome;
using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;

namespace AweCoreDemo.Controllers.Awesome.Lookup
{
    public class MealCustomSearchLookupController : Controller
    {
        public IActionResult SearchForm()
        {
            return PartialView();
        }

        public IActionResult GetItem(int? v)
        {
            Check.NotNull(v, "v");
            var o = Db.Find<Meal>(v) ?? new Meal();

            return Json(new KeyContent(o.Id, o.Name));
        }

        public IActionResult Search(int[] categories, int page, string search = "")
        {
            categories = categories ?? new int[] { };

            var query = Db.Meals.AsQueryable().Filter(search, f => f.Name);
            if (categories.Any())
            {
                query = query.Where(f => categories.Contains(f.Category.Id));
            }

            var res = AweUtil.BuildList(query, page, keyContentFunc: o => new KeyContent(o.Id, o.Name));

            return Json(res);
        }
    }
}