using AweCoreDemo.Data;
using AweCoreDemo.ViewModels.Input;
using Microsoft.AspNetCore.Mvc;


namespace AweCoreDemo.Controllers.Demos.Generic
{
    public class ListBindingController : Controller
    {
        public IActionResult Index()
        {
            return View(new ListBindingInput
            {
                Dinners = (Db.Dinners.Take(3).ToArray())
                .Select(o => new DinnerInput
                {
                    Id = o.Id,
                    Name = o.Name,
                    Date = o.Date,
                    ChefId = o.Chef.Id,
                    MealsIds = o.Meals.Select(m => m.Id)
                }).ToList()
            });
        }

        [HttpPost]
        public IActionResult Index(ListBindingInput input)
        {
            return View(input);
        }
    }
}