using AweCoreDemo.Data;
using AweCoreDemo.Models;
using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;

namespace AweCoreDemo.Controllers.Demos.Grid
{
    public class DragAndDropDemoController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        /*begin*/
        public IActionResult MealsGridSrc(GridParams g, int[] selected)
        {
            selected = selected ?? new int[] { };
            var items = Db.Meals.Where(o => !selected.Contains(o.Id)).AsQueryable();
            return Json(new GridModelBuilder<Meal>(items, g) { Key = "Id" }.Build());
        }

        public IActionResult MealsGridSel(GridParams g, int[] selected)
        {
            selected = selected ?? new int[] { };
            var items = Db.Meals.Where(o => selected.Contains(o.Id)).AsQueryable();
            return Json(new GridModelBuilder<Meal>(items, g) { Key = "Id" }.Build());
        }
        /*end*/
    }

    public class Basket
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Category { get; set; }
        public List<Meal> Items { get; set; }
    }

    public class BasketWithCount
    {
        public int Id { get; set; }
        public Dictionary<Meal, int> Items { get; set; }
    }
}