using AweCoreDemo.Data;
using AweCoreDemo.Models;
using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;

namespace AweCoreDemo.Controllers.Demos.Grid
{
    public class GridAddInfoController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult GetItems(GridParams g, string person = "")
        {
            var data = Db.Lunches.Where(o => o.Person.Contains(person)).AsQueryable();

            var count = data.Count();

            var avgPrice = count > 0 ? (data.Average(o => o.Price)).ToString("N") : string.Empty;

            var gmb = new GridModelBuilder<Lunch>(data.AsQueryable(), g)
            {
                Map = o => new
                {
                    o.Id,
                    o.Person,
                    o.Price,
                    o.Food
                },
                Tag = new { avgPrice, count }
            };

            return Json(gmb.Build());
        }
    }
}