using AweCoreDemo.Data;
using Microsoft.AspNetCore.Mvc;

namespace AweCoreDemo.Controllers.Demos.Grid
{
    public class GridClientDataDemoController : Controller
    {
        public IActionResult Index()
        {
            ViewData["lunches"] =
                (Db.Lunches.Take(300)
            .ToArray())
            .Select(o => new
            {
                o.Id,
                o.Person,
                FoodName = o.Food.Name,
                o.Location,
                o.Price,
                CountryName = o.Country.Name,
                ChefName = o.Chef.FullName,
                o.Date,
                DateStr = o.Date.ToShortDateString()
            });

            ViewData["treeNodes"] = (Db.TreeNodes.ToArray())
                .Select(o => new { o.Id, o.Name, ParentId = o.Parent != null ? o.Parent.Id : 0 });

            return View();
        }
    }
}