using AweCoreDemo.Data;
using AweCoreDemo.Models;
using AweCoreDemo.ViewModels.Input;
using Microsoft.AspNetCore.Mvc;
using Omu.Awem.Utils;

namespace AweCoreDemo.Controllers.Demos.Grid.MasterDetailCrud
{
    public class RestInlController : Controller
    {
        public IActionResult Addresses(int key)
        {
            ViewData["Id"] = key;
            return PartialView();
        }

        [HttpPost]
        public IActionResult Create(RestaurantInput input)
        {
            if (!ModelState.IsValid)
            {
                return Json(ModelState.GetErrorsInline());
            }

            var ent = new Restaurant
            {
                Name = input.Name,
                IsCreated = true
            };

            Db.Add(ent);


            return Json(new { });
        }

        [HttpPost]
        public IActionResult Edit(RestaurantInput input)
        {
            if (!ModelState.IsValid)
            {
                return Json(ModelState.GetErrorsInline());
            }

            var ent = Db.Find<Restaurant>(input.Id);
            ent.Name = input.Name;



            return Json(new { });
        }
    }
}