/// <binding AfterBuild='default' ProjectOpened='default' />
const gulp = require('gulp');
const concat = require('gulp-concat');
const uglify = require('gulp-uglify');
const cssmin = require('gulp-cssmin');

// Define your source files explicitly
const jsFiles = [   
    "wwwroot/js/AwesomeMvc.js",
    "wwwroot/js/awem.js",
    "wwwroot/js/aweUtils.js",
    "wwwroot/js/sidemenu.js",
    "wwwroot/js/signalrSync.js",
    "wwwroot/js/cstorg.js",
    "wwwroot/js/site.js",
    "wwwroot/js/awedict.js",
    "wwwroot/js/aweui.js",
    "wwwroot/js/ovld.js",
    "wwwroot/js/inlVldSummary.js"
    // Add more JS files as needed
];

const cssFiles = [
    'wwwroot/css/site.css',    
    // Add more CSS files as needed
];

// Task to bundle and minify JS files
gulp.task('minify-js', () => {
    return gulp.src(jsFiles)
        .pipe(concat('site.min.js'))
        .pipe(uglify())
        .pipe(gulp.dest('wwwroot/js'));
});

// Task to bundle and minify CSS files
gulp.task('minify-css', () => {
    return gulp.src(cssFiles)
        .pipe(concat('site.min.css'))
        .pipe(cssmin())
        .pipe(gulp.dest('wwwroot/css'));
});

gulp.task('watch-js', function () {
    gulp.watch(jsFiles, gulp.series('minify-js'));
});

// Default task to run both minify-js and minify-css
gulp.task('default', gulp.parallel('minify-js', 'minify-css'));