function gridFilterBuilder() {
    var loop = awef.loop;    

    function apply(opt) {
        var rules = opt.rules;
        var done = {};
        loop(opt.gp.forder, function (name) {
            var rule = rules[name];
            done[name] = 1;

            if (rule) {
                rule();
            }
        });

        // get data for the rest of the rules
        for (var lnam in rules) {
            var lr = rules[lnam];
            if (!done[lnam]) {
                lr();
            }
        }
    }

    function opFunc(opt) {
        var opVal = opt.op;
        var paramVal = opt.paramVal;
        var itmValFunc = opt.itmValFunc;

        if (opVal == '>') return function (item) { return itmValFunc(item) > paramVal; }
        if (opVal == '>=') return function (item) { return itmValFunc(item) >= paramVal; }
        if (opVal == '<') return function (item) { return itmValFunc(item) < paramVal; }
        if (opVal == '<=') return function (item) { return itmValFunc(item) <= paramVal; }
        return function (item) { return awef.seq(itmValFunc(item), paramVal); }
    }

    return {
        apply: apply,
        opFunc: opFunc
    };
}