//import * as jQuery from 'jquery';
//import { awef, awe, awem, aweUtils } from './aweui/all.js';

var sideMenu = function ($) {
    var loop = awef.loop, where = awef.where, select = awef.select;
    var isSelected, getHeight, cancelSync;
    var menu;
    var grid;

    var initf;

    function build(opt) {
        var sctrl;
        var gapi;
        var cont;
        var lastClicked;

        var gid = opt.id;
        grid = $('#' + gid);
        var skey = gid + 'menust';

        isSelected = opt.isSelected;

        getHeight = opt.getHeight || function () {            
            return $(window).height() - 20;
        };

        cancelSync = opt.cancelSync || function () { };

        function init() {
            gapi = grid.data('api');
            cont = grid.find('.awe-content');
            lastClicked = -1;

            sctrl = initMenuSeach();

            setHeight();

            grid.one('awerender', function () {
                if (grid.is(':visible')) {
                    scrollToSel();
                } else {
                    initf = function() { setHeight(); scrollToSel(); };
                }

                cont.on('scroll', function () {
                    sessionStorage && sessionStorage.setItem(skey, cont.scrollTop());
                });
            });
        }

        function initMenuSeach() {
            var txt = $('#' + opt.src + '-awed');
            var valtxt = $('#' + opt.src);

            function onenter(e, item) {
                e.preventDefault();

                if (item.length) {
                    item[0].click();

                    // for <a> inside menu item 
                    var ains = item.find('a');
                    if (ains.length) {
                        ains[0].click();
                    }
                }

                txt.data('noaf', 1);
                txt.trigger('focus');
            }

            function topFunc() {
                $(window).scrollTop($(window).scrollTop() - 10);
            }

            function botFunc() {
                if ((cont.offset().top + cont.height() + 50) > ($(window).scrollTop() + $(window).height())) {
                    $(window).scrollTop($(window).scrollTop() + 10);
                }
            }

            sctrl = awem.slist(cont, { sel: '.awe-row', enter: onenter, fcls: 'awe-selected', sc: 'n', topf: topFunc, botf: botFunc });

            grid.on('click', 'a', function (e) {
                if (!e.ctrlKey) {
                    lastClicked = $(e.target).data('k');
                }
            });

            var keyHandled;

            var go = grid.data('o');

            // using awe.bind instead of .on so that if grid is destroyed the events will unbind
            awe.bind(go, txt, 'keydown', function (e) {
                if (sctrl.keyh(e)) {
                    keyHandled = 1;
                }
            });

            var lastTxtLoadVal = '';
            awe.bind(go, valtxt, 'change', function () {
                if (valtxt.val() == lastTxtLoadVal) { return; }
                gapi.load();
                sctrl.autofocus();
            });

            awe.bind(go, txt, 'keyup', function () {
                if (!keyHandled) {
                    
                    lastTxtLoadVal = valtxt.val();
                    opt.keyupf && opt.keyupf();                    
                    gapi.load();
                    sctrl.autofocus();
                }

                keyHandled = 0;
            });

            awe.bind(go, txt, 'focusin', function () {
                // can't send event data, jquerybug
                if (!txt.data('noaf')) {
                    sctrl.autofocus();
                }

                txt.data('noaf', 0);
            });

            awe.bind(go, txt, 'blur', function () {
                if (txt.data('brf')) {
                    sctrl.remf();
                }
            });

            return sctrl;
        }

        function isScrollVis(elm) {
            var ctop = cont.scrollTop;
            var cbot = ctop + cont.clientHeight;

            var etop = elm.offsetTop;
            var ebot = etop + elm.clientHeight;

            return etop >= ctop && ebot <= cbot;
        }

        function scrollToSel() {
            var menuc = cont;
            var sel = menuc.find('.selected');
            var st = sessionStorage && sessionStorage.getItem(skey);

            if (st) {
                cont.scrollTop(st);
            }

            if (sel.length) {
                if (!st || !isScrollVis(sel[0])) {
                    sctrl.scrollTo(sel);
                }
            } else {
                sctrl.scrollTo(menuc.find('.awe-row'));
            }
        }

        function setHeight() {            
            if (!grid.length) return;
            
            var gridh = getHeight();
            awem.setgh(grid, gridh);
        }

        menu = {
            setHeight: setHeight,
            getLastClicked: function () {
                return lastClicked;
            },
            selectById: function (id) {
                var sel = gapi.select(id);
                if (sel.length) {
                    sel = sel[0];
                    sctrl.focus(sel);

                    sctrl.scrollToFocused();
                }

                // show parent when scroll to the first page item
                if (id === 'p0') {
                    var prev = $(sel).prev();
                    if (prev.length)
                        sctrl.scrollTo(prev);
                }
            },
            init: function() { initf && initf(); }
        };

        if (opt.scrollSync) {
            $(window)
                .on('scroll resize',
                    function (e) {
                        if ($(':focus').is('input') || $(window).width() < 1000) return;

                        if (cancelSync()) return;

                        var docTop = $(document).scrollTop() + 20;

                        $('h2').each(function (i) {
                            var ht = $(this).offset().top;
                            if (ht > docTop) {
                                var res = i;
                                if (i > 0 && ht > docTop + $(window).height() * .7) {
                                    res--;
                                }

                                var lix = menu.getLastClicked();
                                if (lix > 0) {
                                    // if last clicked h2 is about the same height
                                    var lch2 = $('h2').eq(lix);
                                    if (lch2.length) {
                                        var lh2 = $('h2').eq(lix).offset().top;

                                        if (lh2 > ht - 3 && lh2 < ht + 3) {
                                            res = lix;
                                        }
                                    }
                                }

                                menu.selectById('p' + res);
                                return false;
                            }
                        });
                    });

            grid.find('a').click(function () {
                var k = $(this).data('k');
                awe.flash($('h2').eq(k));
            });
        }

        init();

        // in case of awem.rebuildAll
        grid.on('aweinit', init);

        return menu;
    }

    var lnodes = null;
    function getMenuGridFunc(nodesOrXhr) {

        function addParentsTo(res, node, all) {
            if (node.ParentId) {
                var isFound;
                loop(res, function (o) {
                    if (o.Id === node.ParentId) {
                        isFound = true;
                        return false;
                    }
                });

                if (!isFound) {
                    var parent = where(all, function (o) { return o.Id === node.ParentId; })[0];
                    res.push(parent);
                    addParentsTo(res, parent, all);
                }
            }
        }

        function equals(a, b) {
            return new RegExp("^" + a + "$", "i").test(b);
        }

        function buildMenuGridModel(gp) {
            gp.paging = false;
            var search = (gp.search || '').trim();
            
            // find selected
            var selectedItems = where(lnodes, function (o) {
                o.Selected = '';
                
                return (isSelected || function (item) { return false; })(o);
            });

            if (selectedItems.length > 1) {
                var anch = window.location.hash.substring(0);

                var anchsli = where(selectedItems, function (o) {
                    return equals(anch, o.Anchor);
                });

                if (anchsli.length) {
                    selectedItems = anchsli.slice(0);
                }
            }

            if (selectedItems.length) {
                selectedItems[0].Selected = "selected";
                loop(selectedItems, function (item) {
                    addParentsTo(selectedItems, item, lnodes);
                });
            }

            loop(selectedItems, function (o) {
                o.IsNodeSelected = true;
            });

            var words = search.split(" ");

            var regs = select(words, function (w) {
                return new RegExp(w, "i");
            });

            var regsl = regs.length;
            
            var result = where(lnodes, function (node) {
                var matches = 0;
                var s = node.Keywords + ' ' + node.Name;

                loop(regs, function (reg) {
                    reg.test(s) && matches++;
                });

                return regsl === matches && (!node.NoMenu || search);
            });

            var searchResult = result.slice(0);

            loop(searchResult, function (o) {
                addParentsTo(result, o, lnodes);
            });

            var rootNodes = where(result, function (o) { return !o.ParentId; });

            var getChildren = function (node, nodeLevel) {
                return where(result, function (o) { return o.ParentId === node.Id; });
            };

            function makeHeader(info) {
                var isNodeSelected = info.NodeItem.IsNodeSelected;
                var collapsed = !search && !isNodeSelected && info.NodeItem.Collapsed;
                return {
                    Item: info.NodeItem,
                    Collapsed: collapsed,
                    IgnorePersistence: search || isNodeSelected
                };
            }

            return aweUtils.gridModelBuilder({
                key: "Id",
                gp: gp,
                items: rootNodes,
                getChildren: getChildren,
                defaultKeySort: aweUtils.Sort.None,
                makeHeader: makeHeader
            });
        }

        return function (sgp) {
            var gp = aweUtils.getGridParams(sgp);

            if (lnodes) {

                return buildMenuGridModel(gp);
            }

            return $.when(nodesOrXhr).then(function (res) {
                lnodes = res;
                if (lnodes) {
                    return buildMenuGridModel(gp);
                }
            });
        };
    }

    function menutree(o) {
        o.alt = 0; // no alt row css
        var api = o.api;
        // render row
        api.itmf = function (opt) {
            var content = '';
            var itm = opt.itm;
            var cebstr = opt.ceb ? api.ceb(itm.Url) : ''; // always add awe-ceb if url
            content += itm.Name;

            opt.clss += ' mnitm';
            if (opt.ceb && !itm.Url) { // no collapse expand class when url
                opt.clss += ' awe-ceb';
            }

            if (itm.Page) opt.clss += ' pmnitem'; // anchor on this page

            var attr = opt.attr;
            attr += ' class="' + opt.clss + '"';
            var style = opt.style || '';

            if (opt.ind) {
                var pad = opt.ind + .2;
                if (opt.ceb) {
                    pad = pad
                    if (opt.ceb) {
                        pad -= .5;
                    }
                }

                style += 'padding-left:' + pad + 'em;';
            }

            style && (attr += ' style="' + style + '"');
            
            if (itm.Url && opt.ceb) {
                return '<div ' + attr + '>' + cebstr + '<a href="' + itm.Url + '" >' + content + '</a></div>';
            }

            return itm.Url ?
                '<a href="' + itm.Url + '" ' + attr + ' >'+ content + '</a>' :
                '<div ' + attr + '>' + cebstr + content + '</div>';
        };
    }

    return {
        build: build,
        getMenuGridFunc: getMenuGridFunc,
        menutree: menutree
    };
}(jQuery);

//export { sideMenu };