﻿using AweMySql.Models;
using Microsoft.EntityFrameworkCore;
using Omu.AwesomeMvc;

var builder = WebApplication.CreateBuilder(args);
var provider = new AweMetaProvider();

// Add services to the container.
builder.Services
    .AddControllersWithViews(o => o.ModelMetadataDetailsProviders.Add(provider))
    .AddJsonOptions(opt =>
            {
                opt.JsonSerializerOptions.PropertyNamingPolicy = null;
            });

var connectionString = builder.Configuration.GetConnectionString("DefaultConnection");
builder.Services.AddDbContext<MyDbContext>(options => options.UseMySql(connectionString, ServerVersion.AutoDetect(connectionString)));

var app = builder.Build();

// Configure the HTTP request pipeline.
if (!app.Environment.IsDevelopment())
{
    app.UseExceptionHandler("/Home/Error");
}

app.UseStaticFiles();

app.UseRouting();

app.UseAuthorization();

app.MapControllerRoute(
    name: "default",
    pattern: "{controller=Home}/{action=Index}/{id?}");

app.Run();