﻿using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;
using AweRazorPages.Models;
using System.Linq;

namespace AweRazorPages.Controllers
{
    public class MealLookupController : Controller
    {
        public IActionResult GetItem(int? v)
        {
            var o = Db.Meals.SingleOrDefault(f => f.Id == v) ?? new Meal();

            return Json(new KeyContent(o.Id, o.Name));
        }

        public IActionResult Search(string search, int page)
        {
            search = (search ?? "").ToLower().Trim();
            var list = Db.Meals.Where(f => f.Name.ToLower().Contains(search));
            return Json(new AjaxListResult
            {
                Items = list.Skip((page - 1) * 7).Take(7).Select(o => new KeyContent(o.Id, o.Name)),
                More = list.Count() > page * 7
            });
        }
    }
}