﻿using Microsoft.AspNetCore.Mvc;
using Omu.AwesomeMvc;

var builder = WebApplication.CreateBuilder(args);

// Add services to the container.
builder.Services.AddRazorPages();

var provider = new AweMetaProvider();
// for the page where ajax data comes from controllers (Index.cshtml)
builder.Services
    .AddControllers(o =>
    {
        o.ModelMetadataDetailsProviders.Add(provider);        
    });

var app = builder.Build();

app.UseDeveloperExceptionPage();

app.UseStaticFiles();

app.UseRouting();

app.UseAuthorization();

app.MapRazorPages();

app.MapControllerRoute(
    name: "default",
    pattern: "{controller=Home}/{action=Index}/{id?}");

app.Run();