﻿using Microsoft.AspNetCore.Mvc;
using Microsoft.EntityFrameworkCore;
using MinSetupCore.Data;
using Omu.AwesomeMvc;

namespace MinSetupCore.Controllers.Awesome
{
    public class DataController : Controller
    {
        private readonly MyContext mcx;

        public DataController(MyContext mcx)
        {
            this.mcx = mcx;
        }

        public async Task<IActionResult> GetAllMeals()
        {
            var items = await mcx.Meals.ToListAsync();
            
            return Json(items.Select(o => new KeyContent(o.Id, o.Name)));
        }
    }
}