using MinSetupCore.Models;
using Microsoft.EntityFrameworkCore;

namespace MinSetupCore.Data
{
    public class MyContext : DbContext
    {
        public MyContext(DbContextOptions<MyContext> options) : base(options)
        {
        }

        public DbSet<Dinner> Dinners { get; set; }
        public DbSet<Food> Foods { get; set; }
        public DbSet<Meal> Meals { get; set; }
        public DbSet<Category> Categories { get; set; }
        public DbSet<Chef> Chefs { get; set; }
        public DbSet<Country> Countries { get; set; }
        public DbSet<Lunch> Lunches { get; set; }
        public DbSet<TreeNode> TreeNodes { get; set; }
        
        public DbSet<ParentMeal> ParentMeals { get; set; }
        public DbSet<Spreadsheet> Spreadsheets { get; set; }
        public DbSet<Message> Messages { get; set; }
        public DbSet<Restaurant> Restaurants { get; set; }
        public DbSet<RestaurantAddress> RestaurantAddresses { get; set; }        
        public DbSet<Meeting> Meetings { get; set; }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            modelBuilder.Entity<Dinner>()
                .HasMany(o => o.Meals)
                .WithMany(o => o.Dinners);

            modelBuilder.Entity<Dinner>()
                .HasOne(o => o.BonusMeal)
                .WithMany();

            modelBuilder.Entity<Lunch>()
                .HasMany(o => o.Meals)
                .WithMany(o => o.Lunches);

            modelBuilder.Entity<ParentMeal>()
                .HasMany(o => o.Meals1)
                .WithMany();                

            base.OnModelCreating(modelBuilder);
        }
    }
}