﻿Imports System.Web.Mvc
Imports AweWFUtil
Imports Omu.AwesomeWebForms
Imports Omu.SampleData
Imports Omu.SampleData.Model

Namespace Controllers
    Public Class ChefLookupController
        Inherits Controller

        Function GetItem(v As Integer?) As ActionResult
            Check.NotNull(v, "v")
            Dim o = Db.Get(Of Chef)(v)
            If (IsNothing(o)) Then
                o = New Chef()
            End If

            Return Json(New KeyContent(o.Id, o.FirstName + " " + o.LastName))
        End Function

        Function SearchItems(page As Integer) As ActionResult
            Const pageSize = 7
            Dim searchStr = Request("search")
            searchStr = searchStr.ToLowCaseVal().Trim()

            Dim lst = Db.Chefs.Where(Function(f) (f.FirstName + " " + f.LastName).ToLower().Contains(searchStr))
            Dim res = New AjaxListResult With
                    {
                    .Items = lst.Skip((page - 1) * pageSize).Take(pageSize).Select(Function(o) New KeyContent(o.Id, o.FirstName + " " + o.LastName)),
                    .More = lst.Count() > page * pageSize
                    }

            Return Json(res)
        End Function
    End Class
End Namespace