﻿Imports System.Web.Mvc
Imports Omu.AwesomeWebForms
Imports Omu.SampleData
Imports Omu.SampleData.Model

Namespace Controllers

    Public Class DataController
        Inherits Controller

        Function GetCategories(parent As String) As ActionResult
            Dim items = Db.Categories.Select(Function(o) New KeyContent(o.Id, o.Name))
            Return Json(items)
        End Function

        Function GetMeals(parent As String) As ActionResult
            parent = If(parent, String.Empty)

            Dim items = Db.Meals.Where(Function(o) o.Category.Id.ToString() = parent).Select(Function(o) New KeyContent(o.Id, o.Name))
            Return Json(items)
        End Function

        Function GetAllMeals() As ActionResult

            Dim items = Db.Meals.Select(Function(o) New KeyContent(o.Id, o.Name))
            Return Json(items)
        End Function

        'grid
        Function GetLunchGrid(g As GridParams)
            Return Json(New GridModelBuilder(Of Lunch)(Db.Lunches.AsQueryable(), g) _
                           With {
                           .Map = Function(o) New With {
                           o.Id,
                           o.Person,
                           o.Food,
                           o.Location,
                           .Date = o.Date.ToShortDateString(),
                           .CountryName = o.Country.Name,
                           .ChefName = o.Chef.FirstName + " " + o.Chef.LastName}}.Build())
        End Function

        'ajaxlist
        Function GetMealsList(page As Integer)
            Dim pageSize = 5
            Dim items = Db.Meals.Skip((page - 1) * pageSize).Take(pageSize).Select(Function(o) New KeyContent(o.Id, o.Name))
            Return Json(New AjaxListResult With {.Items = items, .More = Db.Meals.Count() > page * pageSize})
        End Function

        'autocomplete
        Function GetMealAuto(v As String)
            v = If(v, String.Empty).ToLower().Trim()

            Dim items = Db.Meals.Where(Function(o) o.Name.ToLower().Contains(v)) _
                    .Take(10) _
                    .Select(Function(o) New KeyContent(o.Id, o.Name)).ToArray()

            Return Json(items)
        End Function

    End Class
End Namespace