﻿Imports System.Web.Mvc
Imports Omu.SampleData.Model
Imports Omu.AwesomeWebForms
Imports Omu.SampleData

Namespace Controllers
    Public Class MealLookupController
        Inherits Controller

        Public Function GetItem(v As Nullable(Of Integer)) As ActionResult
            Dim o = If(Db.Meals.SingleOrDefault(Function(f) f.Id = v), New Meal())
            Return Json(New KeyContent(o.Id, o.Name))
        End Function

        Public Function SearchItems(search As String, page As Integer) As ActionResult
            search = (If(search, "")).ToLower().Trim()
            Dim list = Db.Meals.Where(Function(f) f.Name.ToLower().Contains(search))
            Return Json(New AjaxListResult() With {
                           .Items = list.Skip((page - 1) * 7).Take(7).[Select](Function(o) New KeyContent(o.Id, o.Name)),
                           .More = list.Count() > page * 7
                           })
        End Function

    End Class
End Namespace