﻿Imports System.Web.Mvc
Imports AweWFUtil
Imports Omu.AwesomeWebForms
Imports Omu.SampleData
Imports Omu.SampleData.Model

Namespace Controllers
    Public Class MealsMultiLookupController
        Inherits Controller

        Public Function GetItems(v As Integer()) As ActionResult
            Dim items = New List(Of Meal)()

            If v IsNot Nothing Then
                items.AddRange(v.Select(Function(o) Db.Get(Of Meal)(o)))
            End If

            Return Json(items.Select(Function(meal) New KeyContent(meal.Id, meal.Name)))
        End Function

        Public Function SearchItems(search As String, selected As Integer(), page As Integer) As ActionResult
            Const pageSize = 10
            selected = If(selected, New Integer() {})

            search = search.ToLowCaseVal()

            Dim items = Db.Meals.Where(Function(o) o.Name.ToLower().Contains(search) AndAlso Not selected.Contains(o.Id))
            Return Json(New AjaxListResult With {
                           .Items = items.Skip((page - 1) * pageSize).Take(pageSize).Select(Function(o) New KeyContent(o.Id, o.Name)),
                           .More = items.Count() > page * pageSize
                           })
        End Function

        Public Function SelectedItems(selected As Integer()) As ActionResult
            Dim items = New List(Of Meal)()

            If selected IsNot Nothing Then
                items.AddRange(selected.Select(Function(o) Db.Get(Of Meal)(o)))
            End If

            Return Json(New AjaxListResult With {
                           .Items = items.Select(Function(o) New KeyContent(o.Id, o.Name))
                           })
        End Function
    End Class
End Namespace