﻿<%@ Page Title="Home Page" Language="VB" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default.aspx.vb" Inherits="AweWFVB._Default" %>

<%@ Import Namespace="Omu.SampleData" %>

<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">

    <h1>ASP.net Web-Forms Awesome VB.net Demo</h1>
    <p>
        To learn more about ASP.NET Web-Forms Awesome visit
    <a href="https://www.aspnetawesome.com" title="ASP.NET Awesome Website">aspnetawesome.com</a>.
    The page features videos, samples, and documentation to help you get the most from ASP.NET Web-Forms Awesome.                
    </p>

    <p>
        <a href="<%:ResolveUrl("~/Crud.aspx") %>">Grid Crud Demo</a>
    </p>

    <h3>Cascading DropdownList</h3>
    <% Category.DropdownList(New DropdownListOpt With {.Url = Page.Url().Action("GetCategories", "Data")}) %>
    <awe:ocon runat="server" id="Category" />

    <% Meal.DropdownList(New DropdownListOpt With {.Url = Page.Url().Action("GetMeals", "Data")}.Parent(Category.ClientID)) %>
    <awe:ocon runat="server" id="Meal" />

    <h3>Cascading RadioButtonList</h3>
    <div class="pnl">
        <% Category1.RadioButtonList(New RadioButtonListOpt With {.Url = Page.Url().Action("GetCategories", "Data"), .Value = Db.Categories.First().Id}) %>
        <awe:ocon runat="server" id="Category1" />
    </div>
    <div class="pnl">
        <% Meal1.RadioButtonList(New RadioButtonListOpt With {.Url = Page.Url().Action("GetMeals", "Data")}.Parent(Category1.ClientID)) %>
        <awe:ocon runat="server" id="Meal1" />
    </div>

    <h3>and CheckBoxList</h3>
    <% Meals2.CheckBoxList(New CheckBoxListOpt With {.Url = Page.Url().Action("GetMeals", "Data")}.Parent(Category1.ClientID)) %>
    <awe:ocon runat="server" id="Meals2" />

    <h3>Lookup</h3>
    Note: there is a call in global.asax.vb to VbNetUtil.AdjustLookupActionNames() that changes action names for the lookup and multilookup to avoid conflict with parameter names
    <br />
    <br />
    <% MealLookup.Lookup().Controller("MealLookup") %>
    <awe:ocon runat="server" id="MealLookup" />

    <h3>MultiLookup</h3>
    <% MealMultiLookup.MultiLookup().Controller("MealsMultiLookup") %>
    <awe:ocon runat="server" id="MealMultiLookup" />

    <h3>Combobox</h3>
    <% CategoryCombo.Combobox(New ComboboxOpt With {.Url = Page.Url().Action("GetCategories", "Data")}) %>
    <awe:ocon runat="server" id="CategoryCombo" />

    <h3>Checkbox</h3>
    <label style="margin-right: 1em;">
        <% Chk1.CheckBox(New CheckBoxOpt With {.Value = True}) %>
        <awe:ocon runat="server" id="Chk1" />        
    </label>

    <h3>Toggle</h3>
    <label>
        <% Chk2.Toggle(New ToggleOpt With {.Value = True}) %>
        <awe:ocon runat="server" id="Chk2" />        
    </label>

    <h3>Autocomplete</h3>
    <% MealAuto.Autocomplete().Url(Page.Url().Action("GetMealAuto", "Data")).Placeholder("try o ...") %>
    <awe:ocon runat="server" id="MealAuto" />

    <h3>DatePicker</h3>
    <% Date123.DatePicker() %>
    <awe:ocon runat="server" id="Date123" />

    <h3>TimePicker</h3>
    <% Tmp1.TimePicker(New TimePickerOpt With {.Value = DateTime.UtcNow}) %>
    <awe:ocon runat="server" id="Tmp1" />

    <h3>Textbox</h3>
    <% Name.TextBox().Placeholder("type something") %>
    <awe:ocon runat="server" id="Name" />
    <br />
    <br />
    <% Number.TextBox().Placeholder("numeric").Numeric() %>
    <awe:ocon runat="server" id="Number" />
    <h3>Grid</h3>
    <% LunchGrid.Grid().Url(Page.Url().Action("GetLunchGrid", "Data")).Height(350).Resizable().Reorderable() _
                    .Mod(Function(o) o.PageInfo().PageSize().AutoMiniPager().ColumnsSelector()) _
                    .Columns(
                        New Column() With {.Name = "Id", .Width = 75},
                        New Column() With {.Name = "Person"},
                        New Column() With {.Name = "Food"},
                        New Column() With {.Name = "Location"},
                        New Column() With {.Name = "Date", .Width = 120}.Mod(Function(o) o.Autohide()),
                        New Column() With {.Name = "Country.Name", .Prop = "CountryName", .Header = "Country"},
                        New Column() With {.Name = "Chef.FirstName,Chef.LastName", .Prop = "ChefName", .Header = "Chef"})
    %>
    <awe:ocon runat="server" id="LunchGrid" />

    <h3>AjaxList</h3>
    <% MealsList.AjaxList().Url(Page.Url().Action("GetMealsList", "Data")) %>
    <awe:ocon runat="server" id="MealsList" />

    <h3>Popup</h3>
    <% InitPopup1.InitPopup().Name("popup1").Content("hi") %>
    <awe:ocon runat="server" id="InitPopup1" />
    <% Button1.Button().Text("click me").OnClick(Page.Awe().OpenPopup("popup1")) %>
    <awe:ocon runat="server" id="Button1" />
    <style>
        .pnl {
            display: inline-block;
        }
    </style>
</asp:Content>
