using System;

namespace Omu.Awem.Export
{
    /// <summary>
    /// Grid export column
    /// </summary>
    public class ExpColumn
    {
        private string header;

        /// <summary>
        /// Column Header
        /// </summary>
        public string Header
        {
            get { return header ?? propertyName; }
            set { header = value; }
        }

        private string propertyName;

        private float width = 140f;

        /// <summary>
        /// Column ClientFormat or Bind property value
        /// </summary>
        public string Name
        {
            get { return propertyName; }
            set { propertyName = value; }
        }

        /// <summary>
        /// data property name based on Name which can be Bind or ClientFormat value
        /// </summary>
        public string ModelPropName
        {
            get
            {
                if (propertyName == null) return string.Empty;

                return propertyName.Replace(".", string.Empty).Replace("(", string.Empty).Replace(")", string.Empty);
            }
        }

        /// <summary>
        /// Column width
        /// </summary>
        public float Width
        {
            get { return width; }
            set { width = value; }
        }

        /// <summary>
        /// Column hidden
        /// </summary>
        public bool Hidden { get; set; }

        /// <summary>
        /// function receives row model and ExpColumn Name, must return cell value
        /// </summary>
        public Func<object, string, string> ClientFormatFunc { get; set; }
    }
}