using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using System.Web.Mvc;

using Omu.AwesomeMvc;


namespace AwesomeMvcDemo.Controllers.Awesome.AjaxList
{
    public class DinnersAjaxListController : Controller
    {
        public ActionResult Search(int page, bool isTheadEmpty, int pageSize = 10, string search = "")
        {
            var query = Db.Dinners.Where(o => o.Name.Contains(search))
                         .OrderByDescending(o => o.Id)
                         .AsQueryable();

            var count = query.Count();
            var items = AweUtil.GetPage(query, page, pageSize).ToArray();

            var result = new AjaxListResult
            {
                Content = this.RenderPartialView("ListItems/Dinner", items),
                More = count > page * pageSize
            };

            if (isTheadEmpty) result.Thead = this.RenderPartialView("ListItems/DinnerThead");
            return Json(result);
        }
    }
}