using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Utils.Awesome;
using System.Web.Mvc;

using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Awesome.AjaxList
{
    public class MealsAjaxListController : Controller
    {
        public ActionResult Search(string parent, int? pivot)
        {
            const int PageSize = 5;

            var query = Db.Meals.AsQueryable();

            query = query.Filter(parent, o => o.Name);

            var pageItems = (pivot.HasValue ? query.Where(o => o.Id >= pivot.Value) : query)
                .Take(PageSize + 1)
                .ToArray();

            var isMore = pageItems.Count() > PageSize;

            var result = new AjaxListResult
            {
                Items = pageItems.Take(PageSize).Select(o => new KeyContent(o.Id, o.Name)),
                More = isMore
            };

            if (isMore)
            {
                result.Pivot = pageItems.Last().Id;
            }

            return Json(result);
        }
    }
}