using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using System.Web.Mvc;

using Omu.AwesomeMvc;


namespace AwesomeMvcDemo.Controllers.Awesome.AjaxList
{
    public class MealsApiDemoAjaxListController : Controller
    {
        public ActionResult Search(int page, int pageSize = 5, string meal = "")
        {
            var query = Db.Meals.Where(o => o.Name.Contains(meal)).AsQueryable();

            var count = query.Count();
            var items = AweUtil.GetPage(query, page, pageSize).ToList();

            return Json(new AjaxListResult
            {
                Items = items.Select(o => new KeyContent(o.Id, o.Name)),
                More = count > page * pageSize // bool - show More button or not
            });
        }
    }
}