using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using System.Web.Mvc;

using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Awesome.Grid
{
    public class MessagesGridController : Controller
    {
        public ActionResult GetItems(GridParams g)
        {
            var gmb = new GridModelBuilder<Message>(Db.Messages.AsQueryable(), g)
            {
                Map = o => new
                {
                    o.Id,
                    o.From,
                    o.Subject,
                    DateReceived = o.DateReceived.ToShortDateString(),
                    Body = o.Body.Length < 73 ? o.Body : o.Body.Substring(0, 73),
                    o.IsRead,
                    RowClass = o.IsRead ? "" : "notRead"
                }
            };

            return Json(gmb.Build());
        }
    }
}