using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using AwesomeMvcDemo.Utils;
using System.Web.Mvc;

using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Awesome.Lookup
{
    public class CategoryLookupController : Controller
    {
        public ActionResult GetItem(int? v)
        {
            Check.NotNull(v, "v");
            var ent = Db.Find<Category>(v) ?? new Category();

            return Json(new KeyContent(ent.Id, ent.Name));
        }

        public ActionResult Search(int page, string search = "")
        {
            var query = Db.Categories.Where(f => f.Name.Contains(search)).AsQueryable();

            var res = AweUtil.BuildList(query, page,
                keyContentFunc: o => new KeyContent(o.Id, o.Name));

            return Json(res);
        }
    }
}