using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using AwesomeMvcDemo.Utils;
using System.Web.Mvc;

using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Awesome.Lookup
{
    public class MealCustomItemLookupController : Controller
    {
        public ActionResult SearchForm()
        {
            return PartialView();
        }

        public ActionResult GetItem(int? v)
        {
            Check.NotNull(v, "v");
            var ent = Db.Find<Meal>(v);

            return Json(new KeyContent(ent.Id, ent.Name));
        }

        public ActionResult Search(int page, string search = "")
        {
            var query = Db.Meals.Where(f => f.Name.Contains(search)).AsQueryable();

            var res = AweUtil.BuildList(query, page,
                setContentFunc: items => this.RenderPartialView("items", items));

            return Json(res);
        }

        public ActionResult Details(int id)
        {
            return PartialView(Db.Find<Meal>(id) ?? new Meal());
        }
    }
}