using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using AwesomeMvcDemo.Utils;
using AwesomeMvcDemo.Utils.Awesome;
using System.Web.Mvc;

using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Awesome.Lookup
{
    public class MealLookupController : Controller
    {
        public ActionResult GetItem(int? v)
        {
            Check.NotNull(v, "v");
            var o = Db.Find<Meal>(v) ?? new Meal();

            return Json(new KeyContent(o.Id, o.Name));
        }

        public ActionResult Search(int page, string search = "")
        {
            var query = Db.Meals
                .AsQueryable()
                .Filter(search, o => o.Name);

            var res = AweUtil.BuildList(query, page, keyContentFunc: o => new KeyContent(o.Id, o.Name));

            return Json(res);
        }
    }
}