using System;
using System.Collections.Generic;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using AwesomeMvcDemo.Utils.Awesome;
using System.Web.Mvc;


using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Awesome.MultiLookup
{
    public class MealsCustomItemMultiLookupController : Controller
    {
        public ActionResult SearchForm()
        {
            return PartialView();
        }

        public ActionResult GetItems(int[] v)
        {
            var query = Db.Meals.AsQueryable();

            if (v != null)
            {
                query = query.Where(o => v.Contains(o.Id));
            }

            ViewData["caption"] = true;
            var res = AweUtil.BuildList(
                query,
                setContentFunc: (items) => this.RenderPartialView("items", items));

            return Json(res);

        }

        public ActionResult Search(int[] selected, int page, string search)
        {
            selected = selected ?? new int[] { };

            var query = Db.Meals
                .Where(o => !selected.Contains(o.Id))
                .AsQueryable();

            query = query.Filter(search, o => o.Name);

            var res = AweUtil.BuildList<Meal>(
                query,
                page,
                setContentFunc: (items) => this.RenderPartialView("items", items));

            return Json(res);
        }

        public ActionResult Selected(IEnumerable<int> selected)
        {
            var query = Db.Meals
                .AsQueryable();

            if (selected != null)
            {
                query = query.Where(o => selected.Contains(o.Id));
            }

            var res = AweUtil.BuildList(
                query,
                setContentFunc: (items) => this.RenderPartialView("items", items));

            return Json(res);
        }

        // used by the details button, in items view
        public ActionResult Details(int id)
        {
            return PartialView(Db.Find<Meal>(id));
        }
    }
}