using System;
using System.Collections.Generic;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using AwesomeMvcDemo.Utils.Awesome;
using System.Web.Mvc;


using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Awesome.MultiLookup
{
    public class MealsMultiLookupController : Controller
    {
        public ActionResult GetItems(int[] v)
        {
            var items = new List<Meal>();

            if (v != null)
            {
                items = Db.Meals
                    .Where(o => v.Contains(o.Id)).ToList();
            }

            return Json(items.Select(meal => new KeyContent(meal.Id, meal.Name)));
        }

        public ActionResult Search(int[] selected, int page, string search)
        {
            selected = selected ?? new int[] { };

            var query = Db.Meals.AsQueryable().Filter(search, o => o.Name).Where(o => !selected.Contains(o.Id));

            var res = AweUtil.BuildList(query, page, keyContentFunc: o => new KeyContent(o.Id, o.Name));

            return Json(res);
        }

        public ActionResult Selected(int[] selected)
        {
            var items = new List<Meal>();

            if (selected != null)
            {
                items = Db.Meals
                    .Where(o => selected.Contains(o.Id)).ToList();
            }

            return Json(new AjaxListResult
            {
                Items = items.Select(o => new KeyContent(o.Id, o.Name))
            });
        }
    }
}