using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.ViewModels.Input;
using System.Web.Mvc;



namespace AwesomeMvcDemo.Controllers.Demos.Generic
{
    public class ListBindingController : Controller
    {
        public ActionResult Index()
        {
            return View(new ListBindingInput
            {
                Dinners = (Db.Dinners.Take(3).ToArray())
                .Select(o => new DinnerInput
                {
                    Id = o.Id,
                    Name = o.Name,
                    Date = o.Date,
                    ChefId = o.Chef.Id,
                    MealsIds = o.Meals.Select(m => m.Id)
                }).ToList()
            });
        }

        [HttpPost]
        public ActionResult Index(ListBindingInput input)
        {
            return View(input);
        }
    }
}