using System;
using System.Collections.Generic;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using System.Web.Mvc;

using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Demos.Grid
{
    public class DragAndDropDemoController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        /*begin*/
        public ActionResult MealsGridSrc(GridParams g, int[] selected)
        {
            selected = selected ?? new int[] { };
            var items = Db.Meals.Where(o => !selected.Contains(o.Id)).AsQueryable();
            return Json(new GridModelBuilder<Meal>(items, g) { Key = "Id" }.Build());
        }

        public ActionResult MealsGridSel(GridParams g, int[] selected)
        {
            selected = selected ?? new int[] { };
            var items = Db.Meals.Where(o => selected.Contains(o.Id)).AsQueryable();
            return Json(new GridModelBuilder<Meal>(items, g) { Key = "Id" }.Build());
        }
        /*end*/
    }

    public class Basket
    {
        public int Id { get; set; }
        public string Name { get; set; }
        public string Category { get; set; }
        public List<Meal> Items { get; set; }
    }

    public class BasketWithCount
    {
        public int Id { get; set; }
        public Dictionary<Meal, int> Items { get; set; }
    }
}