using System.Threading.Tasks;
using System;
using System.Linq;
using AwesomeMvcDemo.Data;
using AwesomeMvcDemo.Models;
using System.Web.Mvc;

using Omu.AwesomeMvc;

namespace AwesomeMvcDemo.Controllers.Demos.Grid
{
    public class GridNoRecordsFoundCustomLoadingDemoController : Controller
    {
        public ActionResult Index()
        {
            return View();
        }

        public async Task<ActionResult> GridGetItems(GridParams g, string person = "", string food = "")
        {
            await Task.Delay(2000);

            var query = Db.Lunches
                .Where(o => o.Food.Name.Contains(food) && o.Person.Contains(person))
                .AsQueryable();

            var gmb = new GridModelBuilder<Lunch>(query, g)
            {
                KeyProp = o => o.Id,
                Map = o => new
                {
                    o.Id,
                    o.Person,
                    FoodName = o.Food.Name,
                    o.Location,
                    o.Price,
                    Date = o.Date.ToShortDateString()
                }
            };

            return Json(gmb.Build());
        }
    }
}