using AwesomeMvcDemo.Models;
using System.Linq;

namespace AwesomeMvcDemo.Data
{
    /// <summary>
    /// used to set initial values for helpers
    /// </summary>
    public static class DemoCache
    {
        public static void Init(MyContext mcx)
        {
            Categories = mcx.Categories.ToArray();
            Meals = mcx.Meals.Select(o => new MealDto { 
                Id = o.Id, 
                Name = o.Name, 
                CategoryId = o.Category.Id, 
                CategoryName = o.Category.Name, 
                Description = o.Description,
                ImageName = o.ImageName
            
            }).ToArray();

            Chefs = mcx.Chefs.Select(o => new ChefDto { Id = o.Id }).ToArray();
        }

        public static Category[] Categories { get; set; }

        public static MealDto[] Meals { get; set; }

        public static MealDto[] Meals1 { get { return Meals.Where(o => o.CategoryId == Categories.First().Id).ToArray(); } }

        public static ChefDto[] Chefs { get; set; }
    }

    public class MealDto
    {
        public int Id { get; set; }

        public string Name { get; set; }
        public string Description { get; set; }
        public int CategoryId { get; set; }
        public string CategoryName { get; set; }
        public string ImageName { get; set; }
    }

    public class ChefDto
    {
        public int Id { get; set; }
    }
}