using System;
using System.Web;
using System.Web.Configuration;
using System.Web.Mvc;
using System.Web.Script.Serialization;

namespace AwesomeMvcDemo.Utils
{
    public static class AUtil
    {
        public static string ServerMapPath(this HtmlHelper html)
        {
            return html.ViewContext.HttpContext.Server.MapPath(@"~\");
        }

        public static string CssDir()
        {
            return "~/Content/";
        }

        public static string JsDir()
        {
            return "~/Scripts/";
        }

        public static string JsonEncode(object o)
        {
            return new JavaScriptSerializer().Serialize(o);
        }

        public static bool IsDev()
        {
            var compilationSection = (CompilationSection)System.Configuration.ConfigurationManager.GetSection(@"system.web/compilation");
            return compilationSection.Debug;
        }

        public static bool IsDev(this HtmlHelper html)
        {
            return IsDev();
        }

        public static bool IsAjaxRequest(this HtmlHelper html)
        {
            return html.ViewContext.HttpContext.Request.IsAjaxRequest();
        }

        public static bool IsAjaxRequest(this HttpRequest request)
        {
            if (request == null)
                throw new ArgumentNullException(nameof(request));

            if (request.Headers != null)
                return request.Headers["X-Requested-With"] == "XMLHttpRequest";
            return false;
        }

        public static string IsDevJsVal(this HtmlHelper html)
        {
            var isDev = true;

            return (isDev ? "true" : "false").ToString();
        }
    }
}