﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="AjaxCheckboxListDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.AjaxCheckboxListDemo" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <h1>Multiple selection editors</h1>
    <div class="expl">
        Editors used for multiple selection.
    </div>
    <script>
        var meals = <%=DemoUtils.Encode(Db.Meals.Select(o => new KeyContent(o.Id, o.Name))) %>;
        var categories = <%=DemoUtils.Encode(Db.Categories.Select(o => new KeyContent(o.Id, o.Name))) %>;
    </script>
    <%--begin--%>
    <h2>Cascading CheckboxList using binding to parent</h2>
    <% ParentCategory.AjaxCheckboxList()
                              .Url(Page.Url().Action("GetCategories", "Data")); %>
    <awe:Ocon runat="server" ID="ParentCategory" />

    <% ChildMeals.AjaxCheckboxList()
                              .Parent(ParentCategory.ClientID, "categories")
                              .Url(Page.Url().Action("GetMeals", "Data")); %>
    <awe:Ocon runat="server" ID="ChildMeals" />
    <%--end--%>
    <div class="code">
        <%=Page.Source("AjaxCheckboxListDemo.aspx") %>
        <%=Page.Csource("Awesome/DataController.cs") %>
    </div>

    <h2>Bound to many parents</h2>
    <% CategoriesData.MultiLookup()
              .Controller<CategoriesMultiLookupController>()
              .ClearButton(); %>
    <awe:Ocon runat="server" ID="CategoriesData" />

    <% CategoryData.AjaxRadioList()
              .Url(Page.Url().Action("GetCategories", "Data")); %>
    <awe:Ocon runat="server" ID="CategoryData" />

    <% ChildOfManyMeal.AjaxCheckboxList()
              .Url(Page.Url().Action("GetMeals", "Data"))
              .Parent(CategoriesData.ClientID, "categories")
              .Parent(CategoryData.ClientID, "categories"); %>
    <awe:Ocon runat="server" ID="ChildOfManyMeal" />


    <div class="example">
        <h2>CheckboxList</h2>
        <%--beginochk--%>
        <% CategoriesOchk.CheckBoxList(new CheckBoxListOpt
           {
               SelectAll = true,
               Url = Page.Url().Action("GetCategories", "Data"),
               Value = new[] { Db.Categories[0].Id, Db.Categories[1].Id }               
           }); %>
        <awe:Ocon runat="server" ID="CategoriesOchk" />
        <%--endochk--%>
        <%=Page.Source("AjaxCheckboxListDemo.aspx", "ochk") %>
    </div>

    <div class="example">
        <h3>ButtonGroup</h3>
        <%--beginbg--%>
        <% CategoriesButtonGroup.AjaxCheckboxList()
            .ButtonGroup()
            .Url(Page.Url().Action("GetCategories", "Data")); %>
        <awe:Ocon runat="server" ID="CategoriesButtonGroup" />
        <%--endbg--%>
        <%=Page.Source("AjaxCheckboxListDemo.aspx", "bg") %>
    </div>

    <div class="example">
        <h3>Multiselect</h3>
        <%--beginms--%>
        <% CategoriesMulti.AjaxCheckboxList()
            .Multiselect()
            .Url(Page.Url().Action("GetCategories", "Data")); %>
        <awe:Ocon runat="server" ID="CategoriesMulti" />

        <% AllMealsMulti.AjaxCheckboxList()
            .Multiselect(o => o.NoSelectClose())
            .Parent(CategoriesMulti.ClientID, "categories")
            .Url(Page.Url().Action("GetMeals", "Data")); %>
        <awe:Ocon runat="server" ID="AllMealsMulti" />
        <%--endms--%>
        <br />
        <br />
        <div class="tabs">
            <div data-caption="description" class="expl">Parent and Child with <code>NoSelectClose()</code>, values can be reordered by dragging them</div>
            <div data-caption="page"><%=Page.Source("AjaxCheckboxListDemo.aspx", "ms") %></div>
        </div>
    </div>

    <div class="example">
        <h3>Multiselect with custom item</h3>
        <%--beginmsci--%>
        <% MealsMultiImg.AjaxCheckboxList()
            .Value(new[] { Db.Meals[0].Id, Db.Meals[2].Id, Db.Meals[14].Id })
            .Multiselect(o => o.ItemFunc("site.imgItem").CaptionFunc("aweUtils.imgCaption").NoSelectClose())
            .Url(Page.Url().Action("GetMealsImg", "Data")); %>
        <awe:Ocon runat="server" ID="MealsMultiImg" />
        <%--endmsci--%>
        <br />
        <br />
        <div class="tabs">
            <div data-caption="description" class="expl">defining custom rendering functions for the dropdown list item and selected caption</div>
            <div data-caption="page"><%=Page.Source("AjaxCheckboxListDemo.aspx", "msci") %></div>
            <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs", "img") %> </div>
        </div>
    </div>

    <div class="example">
        <h3>Multiselect Combo</h3>
        <div class="expl">can add values not present in the select list</div>
        <%--begincmb--%>
        <% AllMealsMultiCombo.AjaxCheckboxList()
            .Multiselect(o => o.NoSelectClose().Combo())
            .DataFunc("aweUtils.getItems(meals)"); %>
        <awe:Ocon runat="server" ID="AllMealsMultiCombo" />
        <%--endcmb--%>
        <div data-caption="page"><%=Page.Source("AjaxCheckboxListDemo.aspx", "cmb") %></div>
    </div>

    <div class="example">
        <div class="expl"><code>awem.multiselb</code>, used in grid columns selector mod</div>
        <% CategoriesMulti2.AjaxCheckboxList()
            .Mod("awem.multiselb")
            .Tag(new { NoSelClose = 1, InLabel = "categories" })
            .DataFunc("aweUtils.getItems(categories)"); %>
        <awe:Ocon runat="server" ID="CategoriesMulti2" />
    </div>

    <div class="example">
        <h3>Multiselect, with custom css</h3>
        <% MealsAll.AjaxCheckboxList()
              .Multiselect(o => o.NoSelectClose())
              .CssClass("llist")
              .Value(Db.Meals.Take(5).Select(o => o.Id))
              .Url(Page.Url().Action("GetAllMeals", "Data")); %>
        <awe:Ocon runat="server" ID="MealsAll" />

        <style>
            .llist {
                width: 250px;
            }

                .llist .o-mlti {
                    width: 100%;
                }
        </style>
    </div>

    <div class="example">
        <%--<%=Html.Partial("Demos/RmtSrcGit") %>--%>
    </div>

    <div class="example">
        <h3>Set value from get items call</h3>
        <%--beginsv--%>
        <% CategorySv.AjaxRadioList()
              .Odropdown(o => o.AutoSelectFirst())
              .DataFunc("aweUtils.getItems(categories)"); %>
        <awe:Ocon runat="server" ID="CategorySv" />

        <% MealsSv.AjaxCheckboxList()
              .Parent(CategorySv.ClientID, "categories")
              .Url(Page.Url().Action("GetMealsSetValue", "Data")); %>
        <awe:Ocon runat="server" ID="MealsSv" />
        <%--endsv--%>
        <br />
        <br />
        <% Tabs1.Tabs()
      .Add("description", "setting selected items in the controller by returning <code>AweItems</code> instead of <code>KeyContent[]</code>", "expl")
      .Add("view", Page.Source("AjaxCheckboxListDemo.aspx", "sv"))
      .Add("controller", Page.Csource("Awesome/DataController.cs", "gmsv")); %>
        <awe:Ocon runat="server" ID="Tabs1" />
    </div>

    <div class="example">
        <h3>Using predefined parameters</h3>
        <% 
            var cat1 = Db.Categories[0];
            var cat2 = Db.Categories[1];
        %>
        <div class="expl">
            setting parameter parent = { <%=cat1.Name %>, <%=cat2.Name %> } using .Parameter and .ParameterFunc extensions<br />
        </div>
        <% Meals2.AjaxCheckboxList()
            .Multiselect()
            .Parameter("categories", cat1.Id)
            .ParameterFunc("giveParams")
            .Url(Page.Url().Action("GetMeals", "Data")); %>
        <awe:Ocon runat="server" ID="Meals2" />
        <script>
            function giveParams() {
                return { categories: <%=cat2.Id %> };
            }
        </script>
    </div>

    <div class="example">
        <h3>Events and Api</h3>
        <script>
            $(function () {
                $('#bApi').on('click', function () {
                    eval($('#vs').val());
                });

                $('#<%=ApiMeals.ClientID %>').on('aweload', function (e, data, rd) {
                $('#log').prepend('aweload handled,\n data: ' + JSON.stringify(data) + "\n request data" + JSON.stringify(rd) + '\n\n');
            }).on('awebeginload', function (e, data) {
                $('#log').prepend('awebeginload handled,\n request data: ' + JSON.stringify(data) + '\n\n');
            });
            });
        </script>
        <textarea id="vs" rows="3">
        $('#<%=ApiMeals.ClientID %>').data('api').load({ params:{ categories: <%=cat1.Id %> } });
        // $('#<%=ApiMeals.ClientID %>').data('api').load({ params:{ categories: [<%=cat2.Id %>, <%=cat1.Id %>] } });
    </textarea><br />
        <button type="button" id="bApi" class="awe-btn">Execute</button>

        <% ApiMeals.AjaxCheckboxList().Url(Page.Url().Action("GetMeals", "Data")).Load(false); %>
        <awe:Ocon runat="server" ID="ApiMeals" />
        <br />
        <br />
        <textarea id="log" rows="5" style="width: 100%">logging events</textarea>
    </div>

    <div class="example">
        <h3>Toggle select all</h3>
        <%--begintsa--%>
        <div class="ib">
            <button type="button" class="awe-btn" onclick="toggleChkl('<%=ChklCatAll.ClientID %>')">toggle select all</button>
            <br />
            <br />
            <% ChklCatAll.AjaxCheckboxList().DataFunc("aweUtils.getItems(categories)"); %>
            <awe:Ocon runat="server" ID="ChklCatAll" />
        </div>
        <div class="ib">
            <button type="button" class="awe-btn" onclick="toggleChkl('<%=ChklCatAll2.ClientID %>')">toggle select all</button>
            <br />
            <br />
            <% ChklCatAll2.AjaxCheckboxList().DataFunc("aweUtils.getItems(categories)").Ochk(); %>
            <awe:Ocon runat="server" ID="ChklCatAll2" />
        </div>
        <script>
            function toggleChkl(id) {
                $('#' + id).data('api').toggleSelectAll()
            }
        </script>
        <%--endtsa--%>
        <div class="code">
            <%=Page.Source("AjaxCheckboxListDemo.aspx", "tsa") %>
        </div>
    </div>
</asp:Content>