﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="AjaxDropdownDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.AjaxDropdownDemo" %>
<%@ Import Namespace="AwesomeWebFormsDemo.Controllers.Awesome.AjaxDropdown" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
 <h1>AjaxDropdown</h1>
<div class="expl">
    AjaxDropdown needs an url, js func or controller to get data from, by default convention it
    will look for a controller with the same name as it + "AjaxDropdown"<br />
</div>

<div class="example">
    <h3 data-name="cascade">Cascade using binding to parent </h3>
    <%--begin--%>
    <div class="elabel">Parent Category:</div>
    <% ParentCategory.AjaxDropdown()
           .Url(Page.Url().Action("GetCategories", "Data")); %>
    <awe:Ocon runat="server" ID="ParentCategory" />

    <div class="elabel">Child Meal:</div>
    <% ChildMeal.AjaxDropdown()
           .Parent(ParentCategory.ClientID, "categories")
           .Url(Page.Url().Action("GetMeals", "Data")); %>
    <awe:Ocon runat="server" ID="ChildMeal" />
    <%--end--%>
    <br />
    <div class="tabs code">
        <div data-caption="description" class="expl">
            Binding controls using <code>Parent</code> extension,
            one control can be bound to multiple others, works for all editor helpers.
        </div>
        <div data-caption="page"><%=Page.Source("AjaxDropdownDemo.aspx") %></div>
        <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs") %></div>
    </div>
</div>

<div class="example med">
    <h3>Bound to many parents</h3>

    <%--beginm--%>
    <% Category1.AjaxRadioList().Url(Page.Url().Action("GetCategories", "Data")); %>
    <awe:Ocon runat="server" ID="Category1" />
    +
    <% Categories.AjaxCheckboxList().Url(Page.Url().Action("GetCategories", "Data")); %>
    <awe:Ocon runat="server" ID="Categories" />+
    <% TxtMealName.TextBox().Placeholder("where name contains").CssClass("searchtxt"); %>
    <awe:Ocon runat="server" ID="TxtMealName" />
    =
    <% ChildOfManyMeal.AjaxDropdown()
          .Controller<MealBoundToManyController>()
          .Parent(Category1.ClientID)
          .Parent(Categories.ClientID)
          .Parent(TxtMealName.ClientID, "mealName"); %>
    <awe:Ocon runat="server" ID="ChildOfManyMeal" />
    =
    <% ChildOfManyMealRadioList.AjaxRadioList()
          .Controller<MealBoundToManyController>()
          .Parent(Category1.ClientID)
          .Parent(Categories.ClientID)
          .Parent(TxtMealName.ClientID, "mealName"); %>
    <awe:Ocon runat="server" ID="ChildOfManyMealRadioList" />
    <%--endm--%>
    <div class="code">
        <%=Page.Source("AjaxDropdownDemo.aspx", "m") %>
        parent Category1 and "Categories" are being merged together and received by the controller as int[] parent
        <%=Page.Csource("Awesome/AjaxDropdown/MealBoundToManyController.cs") %>
    </div>
</div>
<div class="example">
    <h2>Set value from get items call</h2>
    <%--beginsv--%>
    <% CategorySv.AjaxDropdown()
          .Url(Page.Url().Action("GetCategories", "Data")); %>
    <awe:Ocon runat="server" ID="CategorySv" />

    <% MealsSv.AjaxDropdown()
          .Parent(CategorySv.ClientID, "categories")
          .Url(Page.Url().Action("GetMealsSetValue2", "Data")); %>
    <awe:Ocon runat="server" ID="MealsSv" />
    <%--endsv--%>

    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("AjaxDropdownDemo.aspx", "sv") %></div>
        <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs", "sv") %></div>
    </div>
</div>

<div class="example">
    <h2>Using enum for dropdown items</h2>
    <%--beginenum--%>
    <% EnumAdd.AjaxDropdown().Url(Page.Url().Action("GetWeatherEnumItems", "Data")); %>
    <awe:Ocon runat="server" ID="EnumAdd" />
    <%--endenum--%>
    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("AjaxDropdownDemo.aspx", "enum") %></div>
        <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs", "enum") %></div>
    </div>
</div>

<div class="example">
    <h2>Using predefined parameters</h2>
    <% 
        var cat1 = Db.Categories[0];
        var cat2 = Db.Categories[1];
     %>
    setting parameter parent = { <%=cat1.Name %>, <%=cat2.Name %> } using .Parameter and .ParameterFunc extensions<br />
    <%--beginp--%>
    <% Meal1.AjaxDropdown()
          .Parameter("categories", cat1.Id)
          .ParameterFunc("giveParams")
          .Url(Page.Url().Action("GetMeals", "Data")); %>
    <awe:Ocon runat="server" ID="Meal1" />
    <script>
        function giveParams() {
            return { categories: <%=cat2.Id %> };
        }
    </script>
    <%--endp--%>
    <div class="code">
        <%=Page.Source("AjaxDropdownDemo.aspx", "p") %>
    </div>
</div>
<div class="example">
    <h3>Events and Api</h3>
    <script>
        $(function () {
            $('#bApi').on('click', function () {
                eval($('#vs').val());
            });

            $('#<%=ApiMeal.ClientID %>').on('aweload', function (e, data, rd) {
                $('#log').prepend('aweload handled,\n data: ' + JSON.stringify(data) + "\n request data" + JSON.stringify(rd) + '\n\n');
            }).on('awebeginload', function (e, data) {
                $('#log').prepend('awebeginload handled,\n request data: ' + JSON.stringify(data) + '\n\n');
            });
        });
    </script>
    call $('#id').data('api').load() to trigger load;<br />

    <br />
    <div class="awe-il">
        <textarea id="vs" cols="70" rows="7">
//click execute to load all meals that contain 'ma'

$('#<%=ApiMeal.ClientID %>').data('api').load({ params:{ text: 'ma' } });

// other things you can try
// $('#<%=ApiMeal.ClientID %>').data('api').load({ params:{ text: 'a' } });
// or just reload
// $('#<%=ApiMeal.ClientID %>').data('api').load();
        </textarea><br />
        <button type="button" id="bApi" class="awe-btn">Execute</button>
    </div>
    <% ApiMeal.AjaxDropdown()
                    .Url(Page.Url().Action("GetItems", "ApiMealAjaxDropdown")); %>
    <awe:Ocon runat="server" ID="ApiMeal" />
    <br />
    <br />
    <textarea id="log" rows="5" style="width: 100%">
        logging events
    </textarea>
</div>
</asp:Content>