﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="AjaxRadioListDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.AjaxRadioListDemo" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">

    <h1>AjaxRadioList and other single select editors</h1>
    <div class="expl">AjaxRadioList needs an url, js func or controller to get data from, it will render a list of radiobuttons</div>

    <div class="example med">
        <h2 data-name="cascade">Cascading Radio button list using binding to Parent</h2>
        <%--begin--%>
        <% ParentCategory.AjaxRadioList()
                   .Url(Page.Url().Action("GetCategories", "Data")); %>
        <awe:Ocon runat="server" ID="ParentCategory" />

        <% ChildMeal.AjaxRadioList()
                      .Url(Page.Url().Action("GetMeals", "Data"))
                      .Parent(ParentCategory.ClientID, "categories"); %>
        <awe:Ocon runat="server" ID="ChildMeal" />
        <%--end--%>
        <div class="tabs code">
            <div data-caption="page"><%=Page.Source("AjaxRadioListDemo.aspx") %></div>
            <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs") %></div>
        </div>
    </div>

    <div class="example med">
        <h2>Bound to many parents</h2>
        <%--begin1--%>
        <% Categories.AjaxCheckboxList().Url(Page.Url().Action("GetCategories", "Data")); %>
        <awe:Ocon runat="server" ID="Categories" />
        <% Category2.AjaxRadioList()
                   .Url(Page.Url().Action("GetCategories", "Data")); %>
        <awe:Ocon runat="server" ID="Category2" />

        <% ChildOfManyMeal.AjaxRadioList()
                   .Url(Page.Url().Action("GetMeals", "Data"))
                   .Parent(Categories.ClientID, "categories")
                   .Parent(Category2.ClientID, "categories"); %>
        <awe:Ocon runat="server" ID="ChildOfManyMeal" />
        <%--end1--%>
        <div class="code">
            <%=Page.Source("AjaxRadioListDemo.aspx", 1) %>
        </div>
    </div>

    <div class="example">
        <h2>Client data</h2>
        <div class="expl">
            Besides remote data using <code>.Url(str)</code>, it can also get data from the client using <code>.DataFunc(jsFunc)</code>, the jsFunc can return the items or a Promise
        </div>
        <%--begincd--%>
        <script>
            var meals = <%=DemoUtils.Encode(Db.Meals.Select(o => new KeyContent(o.Id, o.Name))) %>;
            var categories = <%=DemoUtils.Encode(Db.Categories.Select(o => new KeyContent(o.Id, o.Name))) %>;
            function setCategs() {
                return categories;
            }
        </script>
        <% CatClient1.AjaxRadioList().DataFunc("setCategs"); %>
        <awe:Ocon runat="server" ID="CatClient1" />
        <%--instead of setCategs we can also use aweUtils.getItems(categories)--%>
        <%--endcd--%>

        <div class="code">
            <%=Page.Source("AjaxRadioListDemo.aspx", "cd") %>
        </div>
    </div>
        
    <div class="example">
        <h2>RadioButtonList</h2>
        <%--beginochk--%>
        <% CategoryOchk.RadioButtonList(new RadioButtonListOpt
           {
               Value = Db.Categories[0].Id,
               Url = Page.Url().Action("GetCategories", "Data")               
           }); %>
        <awe:Ocon runat="server" ID="CategoryOchk" />
        <%--can also use .Url(url)--%>
        <%--endochk--%>
        <%=Page.Source("AjaxRadioListDemo.aspx", "ochk") %>
    </div>

    <div class="example">
        <h2>ButtonGroup</h2>
        <%--beginbg--%>
        <% CategoriesButtonGroup.ButtonGroup(new ButtonGroupOpt
           {
               Url = Page.Url().Action("GetCategories", "Data")
           }); %>
        <awe:Ocon runat="server" ID="CategoriesButtonGroup" />
        <%--endbg--%>
        <%=Page.Source("AjaxRadioListDemo.aspx", "bg") %>
    </div>

    <div class="example">
        <h2 data-name="odropdown">DropdownList</h2>
        <%--beginodd--%>
        <% AllMealsOdropdown.DropdownList(new DropdownListOpt
           {               
               Url = Page.Url().Action("GetMealsImg", "Data")
           }); %>
        <awe:Ocon runat="server" ID="AllMealsOdropdown" />
        <%--endodd--%>
        <br />
        <br />
        <div class="tabs">
            <div data-caption="description" class="expl">
                automatically gets search when there are more than 10 items (configurable e.g. <code>.Odropdown(o => o.AutoSearch(5))</code>)<br />
            </div>
            <div data-caption="page"><%=Page.Source("AjaxRadioListDemo.aspx", "odd") %></div>
        </div>
    </div>

    <div class="example">
        <h2>Cascading DropdownLists</h2>
        <%--begincc--%>
        <% CatOdropdown.DropdownList(new DropdownListOpt
           {
               Url = Page.Url().Action("GetCategories", "Data")
           }); %>
        <awe:Ocon runat="server" ID="CatOdropdown" />

        <% MealsOdropdown.DropdownList(new DropdownListOpt
            {
                AutoSelectFirst = true,
                Url = Page.Url().Action("GetMeals", "Data")
            }
           .Parent(CatOdropdown.ClientID, "categories")); %>
        <awe:Ocon runat="server" ID="MealsOdropdown" />
        <%--endcc--%>
        <%=Page.Source("AjaxRadioListDemo.aspx", "cc") %>
    </div>

    <div class="example">
        <h2>Combobox</h2>
        <%--begincx--%>
        <% AllMealsCombo.Combobox(new ComboboxOpt
           {
               Value = "combo value",
               Url = Page.Url().Action("GetMealsImg", "Data")               
           }); %>
        <awe:Ocon runat="server" ID="AllMealsCombo" />
        <%--endcx--%>
        <%=Page.Source("AjaxRadioListDemo.aspx", "cx") %>
    </div>

    <div class="example">
        <h2>Color dropdown</h2>
        <%--begincld--%>
        <% ColorPicker1.AjaxRadioList()
            .ColorDropdown(o => o.AutoSelectFirst()); %>
        <awe:Ocon runat="server" ID="ColorPicker1" />
        <%--endcld--%>
        <%=Page.Source("AjaxRadioListDemo.aspx", "cld") %>
    </div>

    <div class="example">
        <h2 data-name="odropdown">DropdownList with custom item and caption</h2>
        <%--beginoddci--%>
        <% CustomItemOdd.DropdownList(new DropdownListOpt
            {
                Value = Db.Meals[1].Id,
                Url = Page.Url().Action("GetMealsImg", "Data")
            }.ImgItem()); %>
        <awe:Ocon runat="server" ID="CustomItemOdd" />
        <%--endoddci--%>
        <br />
        <br />
        <div class="tabs">
            <div data-caption="description" class="expl">
                Custom js functions are defined for rendering the items and caption of the odropdown.
            </div>
            <div data-caption="page"><%=Page.Source("AjaxRadioListDemo.aspx", "oddci") %></div>
            <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs", "img") %></div>
        </div>
    </div>

    <div class="example">
        <h2>TimePicker</h2>
        <%--begintm--%>
        <% TimePicker1.AjaxRadioList()
            .TimePicker(o => o.Caption("time please").Step(15)); %>
        <awe:Ocon runat="server" ID="TimePicker1" />
        <%--endtm--%>
        <%=Page.Source("AjaxRadioListDemo.aspx", "tm") %>
    </div>

    <div class="example">
        <h2 data-name="oremotesearch">Odropdown with remote search</h2>
        <%--beginrs--%>
        <% RemoteSearchOdropdown.AjaxRadioList()
            .Odropdown(o => o.SearchFunc("aweUtils.osearch", Page.Url().Action("SearchMeals", "Data"), "m1"))
            .Value(197)
            .Url(Page.Url().Action("GetMealsInit", "Data")); %>
        <awe:Ocon runat="server" ID="RemoteSearchOdropdown" />

        <% RemoteSearchCombobox.AjaxRadioList()
            .Combobox(o => o.SearchFunc("aweUtils.osearch", Page.Url().Action("SearchMeals", "Data"), "m1"))
            .Value(197)
            .Url(Page.Url().Action("GetMealsInit", "Data")); %>
        <awe:Ocon runat="server" ID="RemoteSearchCombobox" />
        <span class="hint">try 'o'</span>
        <%--endrs--%>
        <br />
        <br />
        <div class="tabs">
            <div data-caption="description" class="expl">
                Only a few items + the selected one are loaded initially using the url specified in .Url, but when the user types something in the searchbox more items
                are loaded by executing the specified .SearchFunc; the new loaded items will be stored/cached until a load will occur, e.g. when a parent changes it's value the component will load.
                <br />
                Components with the same cache key ("m1", "g") have a shared cache.
            </div>
            <div data-caption="page"><%=Page.Source("AjaxRadioListDemo.aspx", "rs") %></div>
            <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs", "rso") %></div>
        </div>
    </div>

    <div class="example">
        <%--<%=Html.Partial("Demos/RmtSrcGit") %>--%>
    </div>

    <div class="example">
        <%--beginsv--%>
        <h2>Set value from get items call</h2>
        <% CategorySv.AjaxRadioList()
            .Odropdown(o => o.AutoSelectFirst())
            .Url(Page.Url().Action("GetCategories", "Data")); %>
        <awe:Ocon runat="server" ID="CategorySv" />

        <% MealsSv.AjaxRadioList()
            .Parent(CategorySv.ClientID, "categories")
            .Url(Page.Url().Action("GetMealsSetValue2", "Data")); %>
        <awe:Ocon runat="server" ID="MealsSv" />

        <br />
        <br />
        <% OrgsSv.AjaxRadioList()
            .Odropdown()
            .Url(Page.Url().Action("GetOrgSetValue", "Data")); %>
        <awe:Ocon runat="server" ID="OrgsSv" />
        <%--endsv--%>

        <% Tabs1.Tabs()
            .CssClass("code")
            .Add("view", Page.Source("AjaxRadioListDemo.aspx", "sv"))
            .Add("controller", Page.Csource("Awesome/DataController.cs", "sv")); %>
        <awe:Ocon runat="server" ID="Tabs1" />
    </div>

    <div class="example">
        <h2>Using predefined parameters</h2>
        <% 
            var cat1 = Db.Categories[0];
            var cat2 = Db.Categories[1];
        %>
        setting parameter parent = { <%=cat1.Name %>, <%=cat2.Name %> } using .Parameter and .ParameterFunc extensions<br />
        <% Meal1.AjaxRadioList()
            .Odropdown()
            .Parameter("categories", cat1.Id)
            .ParameterFunc("giveParams")
            .Url(Page.Url().Action("GetMeals", "Data")); %>
        <awe:Ocon runat="server" ID="Meal1" />
        <script>
            function giveParams() {
                return { categories: <%=cat2.Id %> };
            }
        </script>
    </div>

    <div class="example">
        <h2>Events and Api</h2>
        <script>
            $(function () {
                $('#bApi').on('click', function () {
                    eval($('#vs').val());
                });

                $('#<%=ApiMeal.ClientID %>').on('aweload', function (e, data, rd) {
                    $('#log').prepend('aweload handled,\n data: ' + JSON.stringify(data) + "\n request data" + JSON.stringify(rd) + '\n\n');
                }).on('awebeginload', function (e, data) {
                    $('#log').prepend('awebeginload handled,\n request data: ' + JSON.stringify(data) + '\n\n');
                });
            });
        </script>

        <div class="awe-il">
            <textarea id="vs" cols="70" rows="3">
                $('#<%=ApiMeal.ClientID %>').data('api').load({ params:{ text: 'ma' } });

            </textarea><br />
            <button type="button" id="bApi" class="awe-btn">Execute</button>
        </div>
        <% ApiMeal.AjaxRadioList()
              .Url(Page.Url().Action("GetItems", "ApiMealAjaxDropdown")); %>
        <awe:Ocon runat="server" ID="ApiMeal" />
        <br />
        <br />
        <textarea id="log" rows="5" style="width: 100%">
            logging events
        </textarea>
    </div>
</asp:Content>