﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="AutocompleteDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.AutocompleteDemo" %>
<%@ Import Namespace="AwesomeWebFormsDemo.Controllers.Awesome.Autocomplete" %>

<%@ Import Namespace="AwesomeWebFormsDemo.Helpers" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
<div class="example">
    <h3>Autocomplete</h3>
    <%--begin--%>
    Meal: <% Meal.Autocomplete()
                .Url(Page.Url().Action("GetItems","MealAutocomplete"))
                .Placeholder("try o"); %>
 <awe:Ocon runat="server" ID="Meal" />
    <%--end--%>
    <br/>
    <br/>
    <div class="tabs">
        <div class="expl" data-caption="description">
            <p>
                Autocomplete needs an url, controller or data function (js func) to get data from, by default convention it
                will look for a controller with the same name as it + "Autocomplete"<br/>
            </p>
            <ul>
                <li>
                    <code>action GetItems</code> - gets the items for the autocomplete, it
                    will receive a <code>v</code> parameter which represents the value of the textbox
                </li>
            </ul>
        </div>
        <div data-caption="page"><%=Page.Source("AutocompleteDemo.aspx") %></div>
        <div data-caption="controller"><%=Page.Csource("Awesome/Autocomplete/MealAutocompleteController.cs") %></div>
    </div>
</div>
<div class="example">
    <h3>Custom Item rendering</h3>
    <%--beginci--%>
    Meal: <% MealImgIt.Autocomplete()
                .ItemFunc("site.imgItem")
                .Url(Page.Url().Action("GetMealsImgAutoc", "Data"))
                .Placeholder("try o"); %>
 <awe:Ocon runat="server" ID="MealImgIt" />
    <%--endci--%>
    <br/>
    <br/>
    <div class="tabs">
        <div data-caption="description" class="expl">
            Achieving custom item rendering by setting <code>ItemFunc</code>,
            we're reusing the site.imgItem used by the imgDropdown but any js function that receives an object (KeyContent inheritant MealDisplay) and returns a string will do.
        </div>
        <div data-caption="page"><%=Page.Source("AutocompleteDemo.aspx", "ci") %></div>
        <div data-caption="controller"><%=Page.Csource("Awesome/DataController.cs", "aimg") %></div>
    </div>
</div>
<div class="example">
    <h3>Storing selected value key in a separate field using .PropId</h3>
    <%--begin1--%>
    <div class="efield">
        <div class="elabel">
            Meal:    
        </div>
         <% Meal3.Autocomplete().PropId(MealKey.ClientID).Controller<MealAutocompleteController>(); %>
         <awe:Ocon runat="server" ID="Meal3" />
    </div>
    <div class="efield">
        <div class="elabel">Key:</div>
        <% MealKey.TextBox(); %>
        <awe:Ocon runat="server" ID="MealKey" /> 
        <div class="awe-il">you can (should) use hidden input instead</div>
    </div>
    <%--end1--%>
    <br />
    <br />
    <div class="tabs">
        <div data-caption="description" class="expl">
            when the user selects a value from the autocomplete lists the PropId will be assigned the key of the selected value, but if the user will type something into the autocomlete after that the propId value will clear
        </div>
        <div data-caption="page">
            <%=Page.Source("AutocompleteDemo.aspx", 1) %>
        </div>
    </div>
</div>
<div class="example">
    <h3>Using DataFunc and ItemFunc</h3>
    <%--begind--%>
    git repo: <% Repo.Autocomplete()
                    .DataFunc("getGit")
                    .ItemFunc("site.gitItem"); %>
 <awe:Ocon runat="server" ID="Repo" />
    <script>
        function getGit(v) {
            return $.get('https://api.github.com/search/repositories', { q: v })
                .then(function (data) {
                    return $.map(data.items,
                        function (item) {
                            return { k: item.id, c: item.full_name, avatar: item.owner.avatar_url, desc: item.description };
                        });
                });
        }        
    </script>
    <%--endd--%>
    <br />
    <br />
    <div class="tabs">
        <div data-caption="description" class="expl">
            using <code>DataFunc</code> to get data from github api, <code>ItemFunc</code> is used to set a custom js function that will render the item
        </div>
        <div data-caption="page">
            <%=Page.Source("AutocompleteDemo.aspx", "d") %>
        </div>
    </div>
</div>
<div class="example">
    <h3>Bound to parents</h3>
    <div class="efield">
        <div class="elabel">
            Parent Categories:
        </div>
        <div class="einput">
            <% CategoriesData.AjaxCheckboxList()
                  .Url(Page.Url().Action("GetCategories", "Data"))
                  .Multiselect(o => o.NoSelectClose())
                  .Value(Db.Categories[0].Id); %>
            <awe:Ocon runat="server" ID="CategoriesData" />
        </div>
    </div>
    <div class="efield">
        <div class="elabel">
            Child Meal:
        </div>
        <div class="einput">
            <% ChildOfManyMeal.Autocomplete()
                  .Controller<MealChildAutocompleteController>()
                  .Parent(CategoriesData.ClientID); %>
            <awe:Ocon runat="server" ID="ChildOfManyMeal" />
        </div>
    </div>
    autcomplete list limited to categories selected in the parent
</div>
<div class="example">
    <h3>Numeric autocomplete</h3>
    <div class="efield">
        <div class="elabel">Prime number:</div>
        <div class="einput">
            <% PrimeNumber.Autocomplete()
                  .Url(Page.Url().Action("GetItems", "PrimesAutocomplete"))
                  .Numeric(true)
                  .Placeholder("type a prime number"); %>
            <awe:Ocon runat="server" ID="PrimeNumber" />
        </div>
    </div>
</div>
<div class="example">
    <% 
        var cat1 = Db.Categories[0];
        var cat2 = Db.Categories[1];
        var cat3 = Db.Categories[2];
     %>
    <h3>Using predefined parameters</h3>
    <div class="efield">
        <div class="elabel">
            Meal2 (parent =
            <%=string.Join(", ", cat1.Name, cat2.Name, cat3.Name) %>):
        </div>
        <div class="einput">
            <% Meal2.Autocomplete()
              .Controller<MealChildAutocompleteController>()
              .Parameter("parent", new[] { cat1.Id, cat2.Id, cat3.Id }); %>
            <awe:Ocon runat="server" ID="Meal2" />
        </div>
    </div>
</div>
    

</asp:Content>