using System.Collections.Generic;
using System.Web.Mvc;
using AwesomeWebFormsDemo.Data;
using AwesomeWebFormsDemo.Models;

namespace AwesomeWebFormsDemo.Controllers.Demos.Grid
{
    public class MailboxDemoController : Controller
    {
        [HttpPost]
        public ActionResult Delete(IEnumerable<int> ids)
        {
            foreach (var id in ids)
            {
                Db.Delete<Message>(id);
            }
            return Json(new { });
        }

        public ActionResult ReadMessage(int id)
        {
            var msg = Db.Get<Message>(id);
            msg.IsRead = true;

            return PartialView(msg);
        }

        [HttpPost]
        public ActionResult MarkRead(int[] ids)
        {
            foreach (var id in ids)
            {
                var msg = Db.Get<Message>(id);
                msg.IsRead = true;                
            }

            return Json(new { });
        }

        [HttpPost]
        public ActionResult MarkUnread(int[] ids)
        {
            foreach (var id in ids)
            {
                var msg = Db.Get<Message>(id);
                msg.IsRead = false;                
            }

            return Json(new { });
        }
    }
}