﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="AwesomeWebFormsDemo._Default" %>

<%@ Import Namespace="AwesomeWebFormsDemo.Controllers.Awesome.Lookup" %>

<%-- the "awe" tag is registered in web.config --%>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <h1 style="font-size: 1.2em;">ASP.net Web-Forms Awesome Controls overview:</h1>
    <div class="expl">
        This is an ASP.net web-forms project .NET Framework 4.5.2, it is using the MVC5 (Microsoft.AspNet.Mvc) nuget package to get json data and html (rendered mvc views) via ajax. 
        Download this demo to see the full source code.
    </div>
    <div class="qo">
        <div class="example cbl">
            <div class="efield">
                <div class="elabel"><a href="<%=ResolveUrl("~/AutocompleteDemo.aspx") %>#Autocomplete">Autocomplete</a></div>
                <div class="einput">
                    <% Meal.Autocomplete(new AutocompleteOpt
                        {
                            ItemFunc = "site.imgItem",
                            Url = Page.Url().Action("GetMealsImgAutoc", "Data"),
                            Placeholder = "try o"
                        }); %>
                    <awe:ocon runat="server" id="Meal" />
                </div>
            </div>
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/DatePickerDemo.aspx") %>">DateTimePicker</a>
                </div>
                <div class="einput">
                    <% Date1.DateTimePicker(new DateTimePickerOpt { Value = DateTime.UtcNow }); %>
                    <awe:ocon runat="server" id="Date1" />
                </div>
            </div>
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/TextBoxDemo.aspx") %>">NumericInput</a>
                </div>
                <div class="einput">
                    <% PriceUSD.NumericInput(
                          new NumericInputOpt
                          {
                              Value = 20,
                              FormatFunc = "aweUtils.prefix('$')",
                              Decimals = 2
                          }); %>
                    <awe:ocon runat="server" id="PriceUSD" />
                </div>
            </div>
        </div>

        <div class="example cbl">
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxRadioListDemo.aspx") %>#odropdown">DropdownList</a>
                </div>
                <div class="einput">
                    <% AllMeals.DropdownList(new DropdownListOpt
                        {
                            AutoSelectFirst = true,
                            Url = Page.Url().Action("GetMealsGroupedImg", "Data"),
                        }.ImgItem()); %>
                    <awe:ocon runat="server" id="AllMeals" />
                </div>
            </div>
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxRadioListDemo.aspx") %>#Combobox">Combobox</a>
                </div>
                <div class="einput">
                    <% AllMealsCombo.Combobox(
                              new ComboboxOpt
                              {
                                  Value = Db.Meals[3].Id,
                                  Url = Page.Url().Action("GetMealsGroupedImg", "Data")
                              }.ImgItem()); %>
                    <awe:ocon runat="server" id="AllMealsCombo" />
                </div>
            </div>
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxRadioListDemo.aspx") %>#oremotesearch">DropdownList remote search</a>
                </div>
                <div class="einput">
                    <% RemoteSearchDd.DropdownList(
                              new DropdownListOpt
                              {
                                  Load = false
                              }
                              .RemoteSearch(Page.Url().Action("SearchMeals", "Data"))); %>
                    <awe:ocon runat="server" id="RemoteSearchDd" />
                </div>
            </div>
        </div>

        <div class="example cbl">
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxRadioListDemo.aspx") %>#ButtonGroup">ButtonGroup</a>
                </div>
                <div class="einput">
                    <% CategoriesButtonGroup.ButtonGroup(
                              new ButtonGroupOpt
                              {
                                  Value = Db.Categories[2].Id,
                                  Url = Page.Url().Action("GetCategories", "Data")
                              }); %>
                    <awe:ocon runat="server" id="CategoriesButtonGroup" />
                </div>
            </div>
            <div class="efield">
                <div class="elabel"><a href="<%=ResolveUrl("~/AjaxDropdownDemo.aspx") %>">AjaxDropdown</a></div>
                <div class="einput">
                    <% Add1.AjaxDropdown()
                              .Url(Page.Url().Action("GetMeals", "Data"))
                              .Parent(CategoriesButtonGroup.ClientID, "categories"); %>
                    <awe:ocon runat="server" id="Add1" />
                </div>
            </div>
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxRadioListDemo.aspx") %>#Odropdown-tree-data-lazy-nodes-remote-search">Tree data, remote search, lazy nodes
                    </a>
                </div>
                <div class="einput">
                    <% RmtLazyTree.DropdownList(new DropdownListOpt
                        {
                            Url = Page.Url().Action("GetTreeNodesLazy", "Data"),
                            CollapseNodes = true,
                            PopupMinWidth = 350,
                        }
                              .RemoteSearch(Page.Url().Action("SearchTree", "Data")));%>
                    <awe:ocon runat="server" id="RmtLazyTree" />
                </div>
            </div>
        </div>

        <div class="example cbl">
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxRadioListDemo.aspx") %>#Odropdown-with-submenu">DropdownList submenu</a>
                </div>
                <div class="einput">
                    <% AllMealsSbm.DropdownList(new DropdownListOpt
                        {
                            Value = Db.Meals[21].Id,
                            Url = Page.Url().Action("GetMealsTreeImg", "Data"),
                            Submenu = true
                        }.ImgItem());
                    %>
                    <awe:ocon runat="server" id="AllMealsSbm" />
                </div>
            </div>

            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxCheckboxListDemo.aspx") %>#Multiselect-with-submenu">Multichek submenu</a>
                </div>
                <div class="einput">
                    <% MultichkMealsSbm.Multicheck(
                            new MulticheckOpt
                            {
                                Value = new[] { Db.Meals[2].Id },
                                Url = Page.Url().Action("GetMealsTreeImg", "Data"),
                                Submenu = true,
                                ClearBtn = true
                            }
                            .ImgItem()); %>
                    <awe:ocon runat="server" id="MultichkMealsSbm" />
                </div>
            </div>

            <div class="efield">
                <div class="elabel"><a href="<%=ResolveUrl("~/DatePickerDemo.aspx") %>">DateRangePicker</a></div>
                <div class="einput">
                    <% DateRange1.DatePicker(new DatePickerOpt { SelectRange = true, Placeholder = "select dates" }); %>
                    <awe:ocon runat="server" id="DateRange1" />
                </div>
            </div>
        </div>

        <div class="example cbl">
            <div class="ib arl">
                <div class="elabel"><a href="<%=ResolveUrl("~/AjaxRadioListDemo.aspx") %>">AjaxRadioList</a></div>
                <% ParentCat.RadioButtonList(
                           new RadioButtonListOpt
                           {
                               Value = Db.Categories[2].Id,
                               Url = Page.Url().Action("GetCategories", "Data")
                           }); %>
                <awe:ocon runat="server" id="ParentCat" />
            </div>
            <div class="ib arl">
                <div class="elabel"><a href="<%=ResolveUrl("~/AjaxCheckboxListDemo.aspx") %>">CheckboxList</a></div>
                <% ChildMeal1.CheckBoxList(
                         new CheckBoxListOpt
                         {
                             Url = Page.Url().Action("GetMeals", "Data"),
                             Value = new[] { 185, 187 }
                         }
                         .Parent(ParentCat.ClientID, "categories")); %>
                <awe:ocon runat="server" id="ChildMeal1" />
            </div>
        </div>
        <br />
        <div class="example cbl">
            <div class="efield">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/AjaxCheckboxListDemo.aspx") %>#Multiselect">Multiselect</a>
                </div>
                <% AllMealsMulti.Multiselect(
                          new MultiselectOpt
                          {
                              NoSelectClose = true,
                              CssClass = "bigMulti",
                              Value = new[] { Db.Meals[2].Id, Db.Meals[3].Id, Db.Meals[5].Id },
                              Url = Page.Url().Action("GetMealsGroupedImg", "Data")
                          }
                          .ImgItem()); %>
                <awe:ocon runat="server" id="AllMealsMulti" />
            </div>
        </div>

        <div class="example cbl">
            <div class="efield">
                <div class="elabel">
                    Odropdown with fav buttons
                </div>
                <div class="einput">
                    <%  AllMealsFav.DropdownList(
                            new DropdownListOpt
                            {
                                Url = Page.Url().Action("GetMealsImg", "Data"),
                                CssClass = "bigFavs"
                            }
                            .Favs()
                            .ImgItem());
                    %>
                    <awe:ocon runat="server" id="AllMealsFav"></awe:ocon>
                </div>
            </div>
        </div>

        <div class="example cbl">
            <div class="efield">
                <div class="elabel">
                    Multicheck
                </div>
                <% AllMealsMultichk.Multicheck(
                         new MulticheckOpt
                         {
                             Value = new[] { Db.Meals[2].Id, Db.Meals[3].Id, Db.Meals[5].Id },
                             Url = Page.Url().Action("GetMealsGroupedImg", "Data"),
                             ClearBtn = true,
                             NoSelectClose = true,
                         }
                         .ImgItem()); %>
                <awe:ocon runat="server" id="AllMealsMultichk" />
            </div>
        </div>

        <br />
        <div class="example">
            <div class="efield cbl">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/PopupDemo.aspx") %>">Popup</a>
                </div>

                <% InitPopup1.InitPopup()
                                .Name("popup1")
                                .Url(Page.Url().Action("Popup1", "PopupDemo"))
                                .LoadOnce()
                                .Title("popup title"); %>
                <awe:ocon runat="server" id="InitPopup1" />

                <% Button1.Button().Text("Open Popup").OnClick(Page.Awe().OpenPopup("popup1")); %>
                <awe:ocon runat="server" id="Button1" />

                <% InitPopup2.InitPopup()
                                .Name("popupTop")
                                .Url(Page.Url().Action("Popup1", "PopupDemo"))
                                .LoadOnce()
                                .Modal()
                                .Top()
                                .Mod(o => o.OutClickClose())
                                .Width(1000)
                                .Title("top modal popup"); %>
                <awe:ocon runat="server" id="InitPopup2" />

                <% Button2.Button().Text("Open top modal").CssClass("awe-btnp").OnClick(Page.Awe().OpenPopup("popupTop")); %>
                <awe:ocon runat="server" id="Button2" />

                <% InitPopup3.InitPopup()
                                .Name("ttip")
                                .Content("tooltip content")
                                .Mod(o => o.Dropdown()); %>
                <awe:ocon runat="server" id="InitPopup3" />

                <script>
                    $(function () {
                        awem.hovPopup({
                            hover: $('#tip1Trg'),
                            name: 'ttip'
                        });
                    });
                </script>

                <span id="tip1Trg" class="mitem">Hover me</span>
            </div>
            <div class="efield cbl">
                <div class="elabel">
                    <a href="<%=ResolveUrl("~/Dropmenu.aspx") %>">Dropmenu</a>
                </div>
                <div id='menuHov1'>
                    <div class="mitem" data-prop="file">File</div>
                    <div class="mitem" data-prop="meals">Meals</div>
                    <div class="mitem" data-prop="help">Help</div>
                </div>

                <div id="log1" style="min-height: 2em;"></div>
                <script>
                    $(function () {
                        var data = {
                            file: [
                                { c: 'New' },
                                { c: 'Save' },
                                {
                                    c: 'Recent Files',
                                    nv: 1, // non value, clicking on it does nothing
                                    it: [{ c: 'file1' }, { c: 'file2' }, { c: 'file3' }]
                                },
                                { c: 'Quit' }
                            ],
                            meals: [],
                            help: [
                                { c: 'View help' },
                                { c: 'Feedback' },
                                { c: '', cs: "o-litm", nv: 1 },  // horiz line
                                { c: 'About' }]
                        };

                        $.when(cstorg.get('<%=Page.Url().Action("GetMealsTreeImg", "Data") %>')).then(function (res) {
                            data.meals = res;
                        });

                        function openMenu(mitem, right) {
                            var prop = mitem.data('prop');

                            var dm1 = awem.dropmenu({
                                dataFunc: function () {
                                    return data[prop];
                                },
                                minw: 150,
                                submenu: true, // tree data as submenu
                                asmi: prop !== 'meals' ? -1 : 0, // autosearch only for meals
                                itemFunc: site.imgItem,
                                select: function (item) {
                                    awe.flash($('#log1').html('click on ' + item.c));
                                }
                            });

                            dm1.open({ opener: mitem, right: right });
                            return dm1;
                        }

                        // open on hover menu
                        awem.hovMenu({
                            hover: $('#menuHov1').find('.mitem'),
                            open: openMenu
                        });
                    });
                </script>
            </div>

            <div class="efield cbl">
                <div class="elabel">
                    Notification
                </div>
                <button type="button" class="awe-btn awe-btnp" onclick="awem.notif('Hi,</br> how are you ! ', 5000)">Show Notification</button>
                <button type="button" class="awe-btn redbtn" onclick="awem.notif('<h5>Oops !</h5> error example ', 0, 'o-err')">Show Error</button>
                <button type="button" class="awe-btn" onclick="awe.flash($(this).parent())">Flash</button>
                <button type="button" class="awe-btn" onclick="awe.flash(awem.notif('Hi,</br> how are you ! ', 5000))">Flash Notify</button>
            </div>
        </div>

        <div class="example">
            <div class="efield cbl">
                <div class="hlabel">
                    <a href="<%=ResolveUrl("~/LookupDemo.aspx") %>">Lookup</a>
                </div>
                <% MealLookupDropdown.Lookup()
                                  .Controller("MealLookup")
                                  .Mod(o => o.Dropdown()); %>
                <awe:ocon runat="server" id="MealLookupDropdown" />
            </div>

            <div class="efield cbl">
                <div class="hlabel">
                    <a href="<%=ResolveUrl("~/MultiLookupDemo.aspx") %>">MultiLookup</a>
                </div>
                <% MealsMultiLookupDropdown.MultiLookup()
                                  .Controller("MealsMultiLookup"); %>
                <awe:ocon runat="server" id="MealsMultiLookupDropdown" />
            </div>

            <div class="efield cbl">
                <div class="hlabel">
                    <a href="<%=ResolveUrl("~/LookupDemo.aspx") %>">Lookup (custom search)</a>
                </div>
                <% MealCustomSearch.Lookup()
                                            .Controller("MealCustomSearchLookup")
                                            .CustomSearch(); %>
                <awe:ocon runat="server" id="MealCustomSearch" />
            </div>
        </div>
    </div>

    <div class="example qo cbl">
        <div class="efield cbl">
            <div class="elabel">
                <a href="<%=ResolveUrl("LookupDemo.aspx") %>#Lookup-Grid">Lookup grid</a>
            </div>
            <div class="einput">
                <% MealCustomPopup.Lookup()
                                 .ClearButton()
                                 .LookupGrid(Page.Url().Action("MealLookup", "LookupDemo"))
                                 .Controller("MealLookup"); %>
                <awe:ocon runat="server" id="MealCustomPopup" />
            </div>
        </div>

        <div class="efield cbl">
            <div class="elabel"><a href="<%=ResolveUrl("~/FormInput.aspx") %>">Form inputs</a></div>
            <% ToggleBtn1.CheckBox().Otoggl().Value(true); %>
            <awe:ocon runat="server" id="ToggleBtn1" />
            <% Ochk1.CheckBox().Ochk().Value(true); %>
            <awe:ocon runat="server" id="Ochk1" />
        </div>
    </div>

    <div class="example qo">
        <div class="efield">
            <div class="elabel">
                ActivePanel
            </div>
            <div class="einput">
                <% CategoriesDdForAP.DropdownList(new DropdownListOpt
                    {
                        Url = Page.Url().Action("GetCategories", "Data"),
                        ClearBtn = true
                    }); %>
                <awe:ocon runat="server" id="CategoriesDdForAP" />

                <div style="min-height: 3em; padding-top: .5em;">

                    <% ChildPanel1.ActivePanel(new ActivePanelOpt
                        {
                            Url = Page.Url().Action("CategoryContent", "ActivePanel")
                        }
          .Parent(CategoriesDdForAP.ClientID, "category")); %>
                    <awe:ocon runat="server" id="ChildPanel1" />
                </div>
            </div>
        </div>
    </div>

        <br />

        <div class="example">
            <h2>Grid, search using parent binding</h2>
            <%--begin1--%>
            <div class="bar">
                <% Txtperson.TextBox().Placeholder("search for person ...").CssClass("searchtxt"); %>
                <awe:ocon runat="server" id="Txtperson" />
                <% Txtfood.TextBox().Placeholder("search for food ...").CssClass("searchtxt"); %>
                <awe:ocon runat="server" id="Txtfood" />
                <% OCountry.AjaxRadioList().Url(Page.Url().Action("GetCountries", "Data")).Odropdown().HtmlAttributes(new { style = "min-width:15em;" }); %>
                <awe:ocon runat="server" id="OCountry" />
            </div>

            <% Grid1.Grid()
                        .Reorderable()
                        .Mod(o => o.PageInfo().PageSize().AutoMiniPager().ColumnsSelector())
                        .Columns(
                            new Column { Bind = "Id", Width = 75, Groupable = false, Resizable = false },
                            new Column { Bind = "Person" },
                            new Column { Bind = "Food.Name", ClientFormatFunc = "site.imgFood", MinWidth = 200 },
                            new Column { Bind = "Country.Name", ClientFormat = ".(CountryName)", Header = "Country" },
                            new Column { Bind = "Date", Grow = .1 }.Mod(o => o.Autohide()),
                            new Column { Bind = "Location" }.Mod(o => o.Autohide()),
                            new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef" })
                        .Url(Page.Url().Action("GetItems", "LunchGrid"))
                        .Persistence(Persistence.Session) // save collapsed groups and nodes when switching between grid pages.
                        .Resizable()
                        .Height(350)
                        .Parent(Txtperson.ClientID, "person")
                        .Parent(Txtfood.ClientID, "food")
                        .Parent(OCountry.ClientID, "country"); %>
            <awe:ocon runat="server" id="Grid1" />
            <script>
                var root = '<%=ResolveUrl("~/Content/Pictures/Food/") %>';
                function imgFood(itm) {
                    return '<img src="' + root + itm.FoodPic + '" class="food" />' + itm.Food;
                }
            </script>
            <%--end1--%>
            <% Tabs1.Tabs().CssClass("code")
                              .Add("description",
                                  @"Grid basic features and search using <code>Parent</code> binding.<br/> 
            Some columns have autohide mod, you can resize the browser window to see the columns hide and show depending on window width.", "expl")
                              .Add("page", Page.Source("Default.aspx", 1))
                              .Add("controller", Page.Csource("Awesome/Grid/LunchGridController.cs")); %>
            <awe:ocon runat="server" id="Tabs1" />
        </div>

        <div class="expl">
            The following demos are loaded via ajax (on scroll), which is why they are mvc views, the same applies for popups that load their content via ajax.
        </div>


        <%--div used to load additional demos on scroll--%>
        <%--demos will be mvc5 partial views--%>
        <div id='lastEx'>
        </div>

        <br />
        <br />
        See also:
    <br />
        <a href="<%=ResolveUrl("~/DragAndDropDemo.aspx") %>">Drag And Drop Demo (grid move rows)</a><br />
        <a href="<%=ResolveUrl("~/GridClientDataDemo.aspx") %>">Grid Client Data Demo</a><br />
        <a href="<%=ResolveUrl("~/GridNestingDemo.aspx") %>#In-nest-editing-grid">Grid In Nest Editing Demo</a><br />

        <script>
            $(function () {
                var indx = 0;
                var last = $('#lastEx');
                var url = '<%=Page.Url().Action("Rend", "Data") %>';

            site.loadWhenSeen(last, url, indx++, loadNext);

            function loadNext(res) {
                if (!res || res == "end") return;

                var el = $('<div class="example" />').html(res);
                last.after(el);
                last = el;

                site.handleAnchors();
                site.handleTabs();
                site.parseCode();

                site.loadWhenSeen(last, url, indx++, loadNext);
            }
        });
        </script>
</asp:Content>
