﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="DropMenu.aspx.cs" Inherits="AwesomeWebFormsDemo.Dropmenu" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">

    <h1>Dropmenu</h1>
    <div class="example">
        <h2>Simple Dropmenu</h2>
        <%--begin1--%>
        <div id="area1" class="area">
            <div class="msg">click here</div>
        </div>
        <script>
            $(function () {
                var div = $('#area1');
                var msg = div.find('.msg');
                var items = [{ k: 1, c: 'item 1' }, { k: 2, c: 'item 2' }, { k: 3, c: 'item 3' }];

                var dd = awem.dropmenu({ dataFunc: getData, select: select });

                div.click(function (e) {
                    dd.open({ xy: { y: e.clientY, x: e.clientX } });
                });

                function select(it) {
                    msg.html('you clicked ' + it.c);
                }

                function getData() {
                    return items;
                }
            });
        </script>
        <%--end1--%>
        <div class="code">
            <%=Page.Source("Dropmenu.aspx", 1) %>
        </div>
    </div>

    <div class="example">
        <h2>Dropmenu with different items depending on what is clicked</h2>
        <%--begindi--%>
        <div class="area" id="area2">
            <div class="card">
                <div class="big">a</div>
            </div>
            <div class="card">
                <div class="big">b</div>
            </div>
            <div class="card">
                <div class="big">c</div>
            </div>
            <div class="msg">click here, or on a card</div>
        </div>
        <script>
            $(function () {
                var div = $('#area2');
                var items = [];
                var msg = div.find('.msg');
                var dd = awem.dropmenu({ dataFunc: getData, select: select });

                div.click(function (e) {
                    var card = $(e.target).closest('.card');
                    items = [{ k: 1, c: 'item 1' }, { k: 2, c: 'item 2' }];

                    if (card.length) {
                        items.push({ k: 'hide', c: 'hide card ' + card.find('.big').html(), i: card.index() });
                    }

                    if (div.find('.card:hidden').length) {
                        items.push({ k: 'all', c: 'show all' });
                    }

                    dd.render();
                    dd.open({ xy: { y: e.clientY, x: e.clientX } });
                });

                function select(it) {
                    msg.html('you clicked ' + it.c);
                    if (it.k == 'hide') {
                        div.find('.card').eq(it.i).hide();
                    } else if (it.k == 'all') {
                        div.find('.card').show();
                    }
                }

                function getData() {
                    return items;
                }
            });
        </script>
        <%--enddi--%>
        <div class="code">
            <%=Page.Source("DropMenu.aspx", "di") %>
        </div>
    </div>

    <div class="example">
        
        <h3>Autocomplete in textarea</h3>
<div class="csettings">
    <label>Use <% ChkUseAt.CheckBox(); %>
<awe:Ocon runat="server" ID="ChkUseAt" /></label>
    <label>min len: <% TxtMinLen.TextBox().Numeric(o => o.Min(1).Max(5)).Value(1); %>
 <awe:Ocon runat="server" ID="TxtMinLen" /></label>
    <label>filter using starts with: <% ChkFstart.CheckBox(); %>
 <awe:Ocon runat="server" ID="ChkFstart" /></label>
</div>
<%--beginait--%>
<textarea id="text1" style="width: 100%" placeholder="try mango onion banana"></textarea>
<script>
        $(function () {
            var useAt = 0;
            var minLen = 1;
            var txt = $('#text1');
            var items = [];
            var word = '';
            var fstart;
            var dd;

            init();

            $.get('<%=Page.Url().Action("GetAllMeals", "Data") %>', function (res) {
                items = res;
                dd.render();
            });

            function init() {
                if (dd) {
                    dd.destroy();
                }

                dd = awem.dropmenu({
                    dataFunc: getData,
                    opnlc: txt,
                    hpos: txt,
                    select: select,
                    clsempt: 1,
                    flts: fstart, // filter using startsWith
                    srctxt: txt,
                    gterm: getSrcTerm,
                    combo: 1
                });
            }

            function getSrcTerm() {
                // func in site.js
                word = site.getCaretWord(txt[0]);
                var res = -1;
                if (word.length >= minLen) {
                    if (useAt) {
                        if (word[0] == '@') {
                            res = word.substr(1);
                        }
                    } else {
                        res = word;
                    }
                }

                return res;
            }

            function getData() {
                return items;
            }

            function select(item) {
                // func in site.js
                site.replaceInTexarea(txt[0], (useAt ?  '@' : '') + item.c, word);
            }

            // settings
            $('#<%=ChkUseAt.ClientID %>').change(function () {
                useAt = $(this).val() == 'true';
            });

            $('#<%=TxtMinLen.ClientID %>').change(function () {
                minLen = Number($(this).val());
            });

            $('#<%=ChkFstart.ClientID %>').change(function () {
                fstart = $(this).val() == 'true';
                init();
            });
        });
</script>
<%--endait--%>
<div class="code">
    <%=Page.Source("DropMenu.aspx", "ait") %>
</div>
    </div>

    <% InitPopup1.InitPopup().Name("p1").Url(Page.Url().Action("Popup1", "Dropmenu")); %>
    <awe:Ocon runat="server" ID="InitPopup1" />
    <% Button1.Button().OnClick(Page.Awe().OpenPopup("p1")).Text("Open Popup"); %>
    <awe:Ocon runat="server" ID="Button1" />
 </asp:Content>