﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridCustomFormat.aspx.cs" Inherits="AwesomeWebFormsDemo.GridCustomFormat" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
<h3>Grid Custom Formatting</h3>
<%--begin--%>
<% 
    var btnFormat = Page.Awe().Button()
                    .Text("details")
                    .OnClick(Page.Awe().OpenPopup("details")
                    .Params(new { id = ".(Id)" }))
                    .ToString();

    var linkFormat = "<a href='" + ResolveUrl("~/LunchDetails.aspx") + "?id=.(Id)'>open</a>";
 %>

<% CustomFormatGrid.Grid()
        .Url(Page.Url().Action("CustomFormatGrid", "GridDemo"))
        .Mod(o => o.ColumnsSelector())
        .Persistence(Persistence.Session)
        .Height(350)
        .RowClassClientFormat(".(RowClass)")
        .Columns(
        new Column { Bind = "Person", ClientFormat = ".(Person) was at .(Location)", HeaderCssClass = "boldh" },
        new Column { Bind = "Food.Name", ClientFormat = "and had .(FoodName)", CssClass = "bluev" },
        new Column { Bind = "Price", ClientFormatFunc = "formatPrice", Width = 100 },
        new Column { Bind = "Organic", ClientFormatFunc = "toggle", Width = 90 },
        new Column { Bind = "Date" },
        new Column { ClientFormatFunc = "useTemplate('template1')" },
        new Column { ClientFormat = linkFormat, Width = 90, CssClass = "center" },
        new Column { ClientFormat = btnFormat, Width = 100 }); %>
<awe:Ocon runat="server" ID="CustomFormatGrid" />

<% InitPopup1.InitPopup().Name("details").Url(Page.Url().Action("Details", "GridDemo")).Mod(o => o.Dropdown()).Modal(); %>
<awe:Ocon runat="server" ID="InitPopup1" />

<% 
    var orgFormat = Page.Awe().CheckBox("org")
                .Prefix(".(Id)")
                .Otoggl(cssClass: ".(Chked)")
                .Svalue(".(Organic)")
                .Enabled(false)
                .ToString();
 %>

<script type="text/javascript">
    function toggle(lunch) {
        var str = <%=DemoUtils.Encode(orgFormat) %>;
        var chkd = lunch.Organic ? 'o-chked' : '';

        str = str.split('.(Id)').join(lunch.Id).split('.(Organic)').join(lunch.Organic).split('.(Chked)').join(chkd);
        return str;
    }

    function formatPrice(lunch, prop) {
        var color = 'navy';
        var price = lunch[prop];
        if (price < 20) color = 'green';
        if (price > 50) color = 'red';
        return "<div style='color:" + color + ";text-width:bold;'>" + price + " &pound; </div>";
    }

    function useTemplate(id) {
        return function (model) {
            var str = $('#' + id).html();
            for (var name in model) {
                str = str.replace("." + name, model[name]);
            }
            return str;
        };
    }
</script>
<style>
    .boldh .awe-col, .boldh {
        color: navy;
    }

    .bluev {
        color: blueviolet;
    }

    .pinkb {
        background: pink !important;
        color: black;
    }

    .greenb {
        background: #f0f9f7 !important;
        color: black;
    }

    .awe-grid .pinkb a, .awe-grid .greenb a {
        color: blue;
    }
</style>
<div id="template1" style="display: none">
    .Person spent .Price &pound;
</div>
<%--end--%>
<br />

<% Tabs1.Tabs().Add("description",
    @"Cell values can be evaluated on the client side using templates and js functions or on the server side using Map and setting a custom value (as shown here for the Date column).
        The group header value can also be set on the server side, same applies for the footer.<br />
        <br />
        <ul>
            <li>
                <code>Column.ClientFormat</code> - Client format for the column defined as a string using <code>.(ModelPropertyName)</code> for including values of the row model,
                if the ClientFormat starts with &lt;td then grid rendering wont wrap the cell value with td (the ones in format will be used instead),
                this way additional html attributes can be added to the td tag (this attributes can contain <code>.(ModelProp)</code> )
            </li>
            <li>
                <code>Column.ClientFormatFunc</code> - Defines the Name of a javascript function that will receive as a parameter the model (or mapped model) of the grid row and must return a string
                which will be used a value for the cell
            </li>
            <li>
                <code>RowClassClientFormat</code> - used to set a css class to grid rows
            </li>
        </ul>", "expl")
          .Add("page", Page.Source("GridCustomFormat.aspx"))
          .Add("controller", Page.Csource("Demos/Grid/GridDemoController.cs", "format"))
          .Add("popup view", Page.Source("GridDemo/Details.cshtml"))
          .Add("open view", Page.Source("LunchDetails.aspx")); %>
<awe:Ocon runat="server" ID="Tabs1" />
</asp:Content>