﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridCustomQuerying.aspx.cs" Inherits="AwesomeWebFormsDemo.GridCustomQuerying" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <h3>Grid custom querying</h3>
    The default scenario is that you give an IQueryable to the GridModelBuilder and it will sort it and page it 
    using <code>.OrderBy</code> and <code>.Skip/.Take</code>, this works ok on EntityFramework, 
    but if you're doing something like sql procedures, service calls etc. you might want to do this sorting and paging yourself.
    <br />
    <br />
    Sorting rules and current page are in the <code>GridParams {SortNames[], SortDirections[], Page}</code> parameter and to tell the <code>GridModelBuilder</code> not to do any querying you have to set the <code>PageCount</code> parameter on it. 
    (grouping doesn't require any querying)
    <%--begin--%>
    <% CustomQueryingGrid.Grid()
           .Url(Page.Url().Action("GetItems", "CustomQueryingGrid"))
           .Height(450)
           .Columns(
               new Column { Bind = "Id", Groupable = false, Sortable = false, Width = 70 },
               new Column { Bind = "Person" },
               new Column { Bind = "Food.Name" }); %>
    <awe:Ocon runat="server" ID="CustomQueryingGrid" />
    <%--end--%>
    <br />
    <% Tabs1.Tabs().Add("view", Page.Source("GridCustomQuerying.aspx"))
           .Add("controller", Page.Csource("Demos/Grid/CustomQueryingGridController.cs")); %>
    <awe:Ocon runat="server" ID="Tabs1" />
</asp:Content>