<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridCustomRender.aspx.cs" Inherits="AwesomeWebFormsDemo.GridCustomRender" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <script>
    // used in inline crud
    var meals = <%=DemoUtils.Encode(Db.Meals.Select(o => new KeyContent(o.Id, o.Name))) %>;
</script>

<h1>Grid custom rendering</h1>
<div class="expl">Custom rendering achieved using mods that override grid api methods</div>

<div class="example">
    <h2>Grid Cards View</h2>
<%--begincv--%>
<% GridCardsView.Grid()
      .CssClass("scrlh cardsViewGrid") // scrollbar for grid header when needed
      .Reorderable()
      .Mod(o => o.PageInfo().PageSize().AutoMiniPager().ColumnsSelector().CustomRender("cardsview"))
      .Columns(
          new Column { Bind = "Id", Width = 75, Groupable = false, Resizable = false },
          new Column { Bind = "Person" }.Mod(o => o.Nohide()),
          new Column { Bind = "Food.Name" },
          new Column { Bind = "Location" },
          new Column { Bind = "Date", Width = 120 }.Mod(o => o.Autohide()),
          new Column { Bind = "Country.Name", ClientFormat = ".(CountryName)", Header = "Country" },
          new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef" })
      .Url(Page.Url().Action("GetItems", "LunchGrid"))
      .Resizable()
      .Height(450); %>
<awe:Ocon runat="server" ID="GridCardsView" />
<script>
    function cardsview(o) {
        var api = o.api;

        // node content add wrap for padding
        api.ncon = function(p) {
            if (!p.lvl) return p.ren();
            return '<div style="padding-left:' + p.lvl + 'em;" >' + p.ren() + '</div>';
        };

        // group header content
        api.ghead = function(g) {
            return api.ceb() + g.c;
        };

        // render item
        api.itmf = function (opt) {
            var columns = o.columns;

            var content = '';
            if (opt.con) {
                content = opt.con;
            } else {
                for (var i = 0; i < columns.length; i++) {
                    var col = columns[i];
                    
                    // is column hidden
                    if (api.ich(col)) continue;
                    content += '<div class="elabel">'+ (col.H ? col.H +': ' : '') + '</div>' + aweUtils.gcvw(api, col, opt) + '</br>';
                }
            }

            if (opt.ceb) {
                opt.clss += ' cardhead';
                opt.style += 'margin-left:' + opt.ind + 'em;';
            } else {
                opt.clss += ' itcard';
            }

            var attr = opt.attr;
            attr += ' class="' + opt.clss + '"';
            opt.style && (attr += ' style="'+opt.style+'"');

            return '<div ' + attr + '>' + content + '</div>';
        };

        // ignore columns width for grid content
        o.syncon = 0;

        // no alt rows
        o.alt = 0;
    }
</script>
<%--endcv--%>
<br/>
<br/>
<div class="tabs">
    <div data-caption="description" class="expl">
        Grid cards view achieved by overriding api methods, columns can be reordered, hidden/shown, and the changes will be reflected in the rendered card. 
        The column headers width is ignored for calculating grid content width, so when you shrink the browser window the grid content won't get a horizontal scrollbar.
        On touch you can scroll the grid header horizontally by dragging from the left an right sides of the grid header.
    </div>
    <div data-caption="view"><%=Page.Source("GridCustomRender.aspx", "cv") %></div>
</div>
</div>

<div class="example">
    <h2>Grid Custom Render with Inline Editing</h2>
<%--beginie--%>
<% 
    var gridId = InlineCustomRender.ClientID;
    var initObj = new
    {
        Name = DemoUtils.RndName(),
        Date = DateTime.Now.ToShortDateString(),
        ChefId = Db.Chefs.First().Id,
        MealsIds = Db.Meals.Take(2).Select(o => o.Id).ToArray()
    };

 %>
<div class="bar">
    <div style="float: right;">
        <% TxtSearchInlCr.TextBox().Placeholder("search...").CssClass("searchtxt"); %>
        <awe:Ocon runat="server" ID="TxtSearchInlCr" />
    </div>
    <button type="button" onclick="$('#<%=gridId %>').data('api').inlineCreate()" class="awe-btn">Create</button>

    <%=Page.InlineCreateButtonForGrid(gridId, initObj, "Create with predefined values") %>
</div>

<%=Page.InitDeletePopupForGrid(gridId, "GridInlineEditDemo") %>

<% InlineCustomRender.Grid()
      .CssClass("scrlh inlEditCards")
      .Mod(o => o.PageInfo()
          .InlineEdit(Page.Url().Action("Save", "GridInlineEditDemo"))
          .CustomRender("inlDinner"))
      .Url(Page.Url().Action("GridGetItems", "GridInlineEditDemo"))
      .Parent(TxtSearchInlCr.ClientID, "search")
      .Height(600)
      .ColumnWidth(100)
      .Attr("data-syncg", "dinner") // crud sync using signalr in site.js
      .Columns(
          new Column { Bind = "Id", Width = 75, Hidden = true }
              .Mod(o => o.InlineId()),

          new Column { Bind = "Name" }
              .Mod(o => o.Inline(Page.Awe().TextBox("Name"))),

          new Column { Bind = "Date" }
              .Mod(o => o.Inline(Page.Awe().DatePicker("Date").ReadonlyInput().ChangeYear().ChangeMonth())),

          new Column { Id = "chef", Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef" }
              .Mod(o => o.Inline(Page.Awe().Lookup("ChefId").Controller("ChefLookup"))),

          new Column { Id = "meals", Prop = "Meals", Header = "Meals" }
              .Mod(o => o.Inline(Page.Awe().AjaxCheckboxList("MealsIds").CssClass("cedMulti").Multiselect().DataFunc("aweUtils.getItems(meals)"))),

          new Column { Bind = "BonusMeal.Name", ClientFormat = ".(BonusMeal)", Header = "Bonus Meal", Width = 140 }
              .Mod(o => o.Inline(Page.Awe().AjaxRadioList("BonusMealId").Odropdown().DataFunc("aweUtils.getItems(meals)"), "BonusMealId")),

          new Column { Bind = "Organic", ClientFormat = ".(DispOrganic)" }
              .Mod(o => o.Inline(Page.Awe().CheckBox("Organic").Otoggl())),

          new Column { Id = "edit", ClientFormat = GridUtils.InlineEditFormat(), Hidden = true },
          new Column { Id = "del", ClientFormat = Page.InlineDeleteFormatForGrid(gridId), Hidden = true }); %>
<awe:Ocon runat="server" ID="InlineCustomRender" />
<script>
    function inlDinner(o) {
        var api = o.api;

        // node (group) content add wrap for padding
        api.ncon = function(p) {
            if (!p.lvl) return p.ren();
            return '<div style="padding-left:' + p.lvl + 'em;" >' + p.ren() + '</div>';
        };

        // group header content
        api.ghead = function(g) {
            return api.ceb() + g.c;
        };

        // render item (row)
        api.itmf = function(opt) {
            var content = '';

            // content already set (group header)
            if (opt.con) {
                content = opt.con;
            } else {
                var colByBind = function (bind) {
                    return aweUtils.columnByBind(o, bind);
                };

                var colById = function (id) {
                    return aweUtils.columnById(o, id);
                };

                // get column value
                function val(col, cls) {
                    return aweUtils.gcvw(api, col, opt, cls);
                }

                function field(col, nolabel) {
                    var label = '';
                    if (col.H && !nolabel) {
                        label = '<div class="elabel">' + col.H + ':</div> ';
                    }
                    return '<div class="efield">' + label + '<div class="einput">' + val(col) + '</div></div>';
                }

                function hid(col) {
                    return '<div style="display:none;">' + val(col) + '</div>';
                }

                content += hid(colByBind('Id')) +
                    '<div class="earea">' +
                    field(colByBind('Name')) +
                    field(colByBind('Date')) +
                    field(colById('chef')) +
                    '</div><div class="earea">' +
                    field(colByBind('BonusMeal.Name')) +
                    field(colByBind('Organic')) +
                    '</div>' +
                    field(colById('meals')) +
                    '<div class="inlbtns">' +
                    val(colById('edit'), 'awe-il') +
                    val(colById('del'), 'awe-il') +
                    '</div>';
            }

            // has collapse button
            if (opt.ceb) {
                opt.clss += ' cardhead';
                opt.style += 'margin-left:' + opt.ind + 'em;';
            } else {
                opt.clss += ' edcard';
            }

            var attr = opt.attr;
            attr += ' class="' + opt.clss + '"';
            opt.style && (attr += ' style="' + opt.style + '"');

            return '<div ' + attr + '>' + content + '</div>';
        };

        // ignore columns width for grid content
        o.syncon = 0;

        // no alt rows
        o.alt = 0;
    }
</script>
<%--endie--%>
<br />
<div class="tabs">
    <div data-caption="description" class="expl">
        Grid with custom rendering and inline editing mod applied. Edit on row click can also be used.
    </div>
    <div data-caption="view"><%=Page.Source("GridCustomRender.aspx", "ie") %></div>
</div>
</div>

<div class="example">
   <h2>Tree grid with custom rendering</h2>
<%--begintg--%>
<% TreeGridCr.Grid()
          .Url(Page.Url().Action("SimpleTree", "TreeGrid"))
          .Mod(o => o.CustomRender("crtree"))
          .Columns(
              new Column { Bind = "Name" },
              new Column { Bind = "Id", Width = 100 }
          )
          .Persistence(Persistence.View)
          .Groupable(false)
          .PageSize(3)
          .Height(400); %>
<awe:Ocon runat="server" ID="TreeGridCr" />
<script>
    function crtree(o) {
        var api = o.api;        

        // node content wrap
        api.ncon = function (p) {
            // don't wrap at level 0 and nodetype = items
            if (!p.lvl || p.gv.nt == 2) return p.ren();
            return '<div style="padding-left:' + p.lvl + 'em;" >' + p.ren() + '</div>';
        };

        // node
        api.nodef = function (p) {
            var attr = p.h ? 'style="display:none;"' : '';
            if (p.lvl == 1) {
                var res = '<div class="tgroot" ' + attr + '>' + p.ren() + '</div>';
                return res;
            }

            return p.ren();
        };

        // group header content
        api.ghead = function (g, lvl) {
            return api.ceb() + g.c;
        };

        // render row
        api.itmf = function (opt) {
            function val(col) {
                return aweUtils.gcv(api, col, opt);
            }

            var content = '';
            if (opt.con) {
                content = opt.con;
            } else {
                if (opt.ceb) content += api.ceb();
                content += val(aweUtils.columnByBind(o, 'Name'));
            }

            if (opt.ceb) {
                opt.clss += ' tgitem awe-ceb';
            } else {
                opt.clss += ' tgitem';
            }

            var attr = opt.attr;
            attr += ' class="' + opt.clss + '"';
            opt.style && (attr += ' style="' + opt.style + '"');

            return '<div ' + attr + '>' + content + '</div>';
        };
    }
</script>
<%--endtg--%>
<br />
<br />
<div class="tabs">
    <div data-caption="description" class="expl">
        Using custom render mod to override api methods and render the grid using divs with padding instead of the default table.
    </div>
    <div data-caption="view"><%=Page.Source("GridCustomRender.aspx","tg") %></div>
</div>
</div>

<div class="example">
    <%--begintgnc--%>
    <h2> Tree grid nested cards </h2>
    <% LazyTreeGridCr.Grid()
          .Url(Page.Url().Action("LazyTree", "TreeGrid"))
          .Mod(o => o.CustomRender("cardstree"))
          .Columns(
              new Column {Bind = "Name"},
              new Column {Bind = "Id", Width = 100})
           .Persistence(Persistence.View)
           .PageSize(3)
           .Height(500); %>
    <awe:Ocon runat="server" ID="LazyTreeGridCr" />
    <script>
        function cardstree(o) {
            var api = o.api;

            // node
            api.nodef = function(p) {
                // don't wrap nodetype = items
                if (p.gv.nt == 2) return p.ren();
                var attr = p.h ? 'style="display:none;"' : ''; // collapsed
                var res = '<div class="gwrap" ' + attr + '>' + p.ren() + '</div>';
                return res;
            };

            // group header content
            api.ghead = function(g) {
                return api.ceb() + g.c;
            };

            // render row
            api.itmf = function(opt) {
                function val(col) {
                    return aweUtils.gcv(api, col, opt);
                }

                var content = '';
                if (opt.con) {
                    content = opt.con;
                } else {
                    if (opt.ceb) content += api.ceb();
                    content += val(aweUtils.columnByBind(o, 'Name'));
                }

                if (opt.ceb) {
                    opt.clss += ' cardhead awe-ceb';
                } else {
                    opt.clss += ' itcard';
                }

                var attr = opt.attr;
                attr += ' class="' + opt.clss + '"';
                opt.style && (attr += ' style="' + opt.style + '"');

                return '<div ' + attr + '>' + content + '</div>';
            };

            // ignore columns width for content
            o.syncon = 0;
        }
    </script>
    <%--endtgnc--%>
    <br/>
    <br/>
    <div class="tabs">
        <div data-caption="description" class="expl">
            Rendering the grid nodes as cards and placing the child nodes inside the parent card. The grid is also using lazy loading.
        </div>
        <div data-caption="page"><%=Page.Source("GridCustomRender.aspx","tgnc") %></div>
    </div>
</div>
</asp:Content>