<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.GridDemo" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
<h1>Grid control basic features</h1>

<%--begin--%>
<div class="bar">
    <% TxtPerson.TextBox().Placeholder("search for person ...").CssClass("searchtxt"); %>
    <awe:Ocon runat="server" ID="TxtPerson" />
    <% TxtFood.TextBox().Placeholder("search for food ...").CssClass("searchtxt"); %>
    <awe:Ocon runat="server" ID="TxtFood" />
    <% SelCountry.AjaxRadioList().Url(Page.Url().Action("GetCountries", "Data")).Odropdown().HtmlAttributes(new { style = "min-width:15em;" }); %>
    <awe:Ocon runat="server" ID="SelCountry" />
</div>

<% Grid1.Grid()
      .Mod(o => o.ColumnsSelector().PageSize().PageInfo().Loading().AutoMiniPager())
      .Columns(
          new Column { Bind = "Id", Width = 75, Groupable = false, Resizable = false },
          new Column { Bind = "Person" },
          new Column { Bind = "Food.Name", ClientFormatFunc = "site.imgFood" },
          new Column { Bind = "Country.Name", ClientFormat = ".(CountryName)", Header = "Country" },
          new Column { Bind = "Date", Width = 120 },
          new Column { Bind = "Location" },
          new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef" })
      .Url(Page.Url().Action("GetItems", "LunchGrid"))
      .Reorderable()
      .Persistence(Persistence.Session)
       .Height(350)
      .Parent(TxtPerson.ClientID, "person")
      .Parent(TxtFood.ClientID, "food")
      .Parent(SelCountry.ClientID, "country"); %>
<awe:Ocon runat="server" ID="Grid1" />    
<%--end--%>
<br />
<div class="tabs">
    <div data-caption="description" class="expl">
        The Awesome Grid control for ASP.net MVC and ASP.net Core is used to display data, by default using a table, but that can be changed. <a href="https://www.aspnetawesome.com/learn/mvc/Grid"> Documentation </a> 
        <br/>
        <br/>
        It can get the data from the server by specifying the url <code>Url(urlstr)</code> or from a js function <code>DataFunc(jsfunc)</code> (the javascript function could also do an ajax request and return the promise).
        <br/>
        The Grid (like most awesome controls) can be bound to other controls using the <code>Parent</code> extension (used for filtering). 
        It can also be filtered using the api.
        <br/>
        Mods are used to add additional features to the grid like: inline editing, automatic columns hiding and via dropdown, adaptive pager (based on window width), and more.
        <br/>
        <br/>
        Features:
        <ul class="alist">
            <li>Sorting (multiple and single column), Grouping</li>
            <li>Resize, reorder, hide and show columns (using columns selector mod or api)</li>
            <li>Persistence - save columns state, current page and collapsed groups/nodes</li>
            <li><a href="<%=ResolveUrl("~/GridCustomFormat.aspx") %>">Custom formatting</a></li>
            <li>Client side api</li>
            <li><a href="<%=ResolveUrl("~/TreeGrid.aspx") %>">Tree Grid</a></li>
            <li><a href="<%=ResolveUrl("~/GridNestingDemo.aspx") %>">Nesting</a></li>
            <li><a href="<%=ResolveUrl("~/GridNestingDemo.aspx") %>#Nested-grids--Hierarchical-grid">Hierarchical grid</a> (done using nesting)</li>
            <li><a href="<%=ResolveUrl("~/GridInlineEditDemo.aspx") %>">Inline Editing</a> (using mod)</li>
            <li><a href="<%=ResolveUrl("~/GridMultiRowHeaderGroups.aspx") %>">Multiple rows group headers</a></li>
            <li><a href="<%=ResolveUrl("~/DragAndDropDemo.aspx") %>">Reorder rows</a>, also from one grid to another</li>
            <li>Selection</li>
            <li><a href="<%=ResolveUrl("~/GridRTLSupport.aspx") %>">RTL Support</a></li>
            <li>Responsive layout, and <a href="<%=ResolveUrl("~/Default.aspx") %>#Grid-search-using-parent-binding">autohide columns</a> (using Autohide mod)</li>
            <li>Custom rendering</li>
            <li>Cards View (using custom rendering mod)</li>
        </ul>
        <br/>
        For export to excel, pdf, txt (csv) please see this <a href="<%=ResolveUrl("~/GridExportToExcelDemo.aspx") %>">demo</a>
    </div>
    <div data-caption="page">
        <%=Page.Source("GridDemo.aspx") %>
    </div>
    <div data-caption="controller">
        <%=Page.Csource("Awesome/Grid/LunchGridController.cs") %>
    </div>
</div>
<br />
<br />
<p>
    See also:
</p>
<a href="<%=ResolveUrl("~/GridClientDataDemo.aspx") %>"> Grid Client Data Demo</a><br/>
<a href="<%=ResolveUrl("~/MailboxDemo.aspx") %>"> Grid Mailbox Demo</a><br/>
</asp:Content>