<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridExportToExcelDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.GridExportToExcelDemo" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server"> 
<h2>Export grid to excel, pdf, txt (csv) demo</h2>
<div class="expl">
    This demo is showing how to build the grid model and use it to export the data in various formats (xls, pdf, txt) using external libraries and custom code.
</div>
<br />
<%--begin--%>
<% 
    var grid = LunchGrid.ClientID;
 %>
<% LunchGrid.Grid()
        .Url(Page.Url().Action("GetItems", "GridExportToExcelDemo"))
        .Persistence(Persistence.Session)
        .Mod(o => o.ColumnsSelector())
        .Resizable()
        .Height(350)
        .Columns(
        new Column { Bind = "Id", Width = 80 },
        new Column { Bind = "Person" },
        new Column { Bind = "Food.Name" },
        new Column { Bind = "Date", Width = 150},
        new Column { Bind = "Price", Width = 110 },
        new Column { Bind = "Country.Name", ClientFormat = ".(CountryName)", Header = "Country" },
        new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef" },
        new Column { Bind = "Location" }); %>
<awe:Ocon runat="server" ID="LunchGrid" />

<br />
<div class="bar">
    <button id="exportGrid" type="button" class="awe-btn">Export grid to excel</button>
    <button id="exportGridPdf" type="button" class="awe-btn">Export grid to Pdf</button>
    <button id="exportGridTxt" type="button" class="awe-btn">Export grid to txt (csv)</button>
    <div style="padding: 0 1em; display: inline-block;">
        <label><% AllPages.CheckBox(); %>
<awe:Ocon runat="server" ID="AllPages" /> All pages</label>
    </div>
    
    <br/>
    <br/>
    <button id="exportAll" type="button" class="awe-btn">Export all records to excel</button>    
</div>
<script>
    $(function () {
        $('#exportAll').click(function () {
            getFile('<%=Page.Url().Action("ExportAllToExcel", "GridExportToExcelDemo") %>');
        });

        $('#exportGrid').click(function () {
            getFile('<%=Page.Url().Action("ExportGridToExcel", "GridExportToExcelDemo") %>');
        });

        $('#exportGridPdf').click(function () {
            getFile('<%=Page.Url().Action("ExportGridToPdf", "GridExportToExcelDemo") %>');
        });

        $('#exportGridTxt').click(function () {
            getFile('<%=Page.Url().Action("ExportGridToTxt", "GridExportToExcelDemo") %>');
        });

        function getFile(url) {
            var $form = $('<form method="post"/>').attr('action', url).appendTo('body');
            var grid = $('#<%=grid %>');

            // request paramters (sorting, grouping, any parent parameters)
            var req = grid.data('api').getRequest();
            
            // send visible columns info, binds to GridExpParams
            var viscols = aweUtils.getVisCols(grid); 
            awef.loop(viscols, function(v) {
                $form.append("<input type='hidden' name='visNames' value='" + v + "'/>");
            });

            awef.loop(req, function(val) {
                    $form.append("<input type='hidden' name='" + val.name + "' value='" + val.value + "'/>");
            });

            $form.append($('#allPages').clone());
            $form.submit();
            $form.remove();
        }
    });
</script>
<%--end--%>
<br/>
<br/>
<div class="tabs">
    <div data-caption="description" class="expl">
        Export the content of a grid to excel, pdf and txt file (csv).
        To create an excel file we're using the <a href="https://github.com/tonyqus/npoi">NPOI library</a>.<br/>
        For exporting to Pdf the <a href="https://itextpdf.com/">iText7</a> library is used.<br/>
        To get the entire source code you can download this demo.
    </div>
    <div data-caption="page"><%=Page.Source("GridExportToExcelDemo.aspx") %></div>
    <div data-caption="controller"><%=Page.Csource("Demos/Grid/GridExportToExcelDemoController.cs") %></div>
</div>
</asp:Content>