﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridInlineEditConditional.aspx.cs" Inherits="AwesomeWebFormsDemo.GridInlineEditConditional" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
<h1>Grid inline editing conditional</h1>
<%--begin--%>
<%  var gridId = DinnersGrid2.ClientID;  %>
<%=Page.InitDeletePopupForGrid(gridId, "GridInlineEditDemo") %>

<div class="bar">
    <%=Page.InlineCreateButtonForGrid(gridId, new { DispOrganic = "" }) %>
</div>

<% 
    var isAdmin = false;
 %>
<% DinnersGrid2.Grid()
      .Mod(o => o.PageInfo().InlineEdit(Page.Url().Action("Save", "GridInlineEditDemo")))
      .Url(Page.Url().Action("GridGetItems", "GridInlineEditDemo"))
      .Height(350)
      .Resizable()
      .Columns(
          new Column { Bind = "Id", Width = 75 }.Mod(o => o.InlineId()),
          new Column { Bind = "Name" }.Mod(o => o.Inline(Page.Awe().TextBox("Name"))),

          new Column { Bind = "Date", Width = 170 }
            .Mod(o => o.Inline("<input type='hidden' name='Date' value='#Value'/>#Value").Inline(Page.Awe().DatePicker("Date")).InlineFunc("dateCond")),

          new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef", Width = 200 }
            .Mod(o => o.Inline(Page.Awe().Lookup("Chef").Controller("ChefLookup"), "ChefId")),

          new Column { Prop = "Meals", Header = "Meals", Width = 220 }
          .Mod(o => o.Inline(Page.Awe().AjaxCheckboxList("Meals").Multiselect().DataFunc("aweUtils.getItems(meals)"), "MealsIds")),

          new Column { Bind = "BonusMeal.Name", ClientFormat = ".(BonusMeal)", Header = "Bonus Meal" }
            .Mod(o => o.Inline(Page.Awe().AjaxRadioList("BonusMealId").DataFunc("aweUtils.getItems(meals)").Odropdown(), "BonusMealId")),

          new Column { Bind = "Organic", Width = 100, ClientFormat = ".(DispOrganic)" }
          .Mod(o =>
          {
              if (isAdmin)
                  o.Inline(Page.Awe().CheckBox("Organic").Otoggl());
              else
                  o.InlineReadonly(); // readonly, used if you set isAdmin = false
          }),

          new Column { ClientFormatFunc = "editff", Width = Setting.InlEditBtnWidth },
          new Column { ClientFormatFunc = "delff", Width = Setting.InlDelBtnWidth }); %>
<awe:Ocon runat="server" ID="DinnersGrid2" />
<script>
    var meals = <%=DemoUtils.Encode(Db.Meals.Select(o => new KeyContent(o.Id, o.Name))) %>;

    function dateCond(o, params) {
        if (o.DateReadOnly) return params[0];
        return params[1];
    }

    function editff(o) {
        return o.Editable === false ? '' : '<%=GridUtils.InlineEditFormat() %>';
    }

    function delff(o) {
        var format = <%=DemoUtils.Encode(Page.InlineDeleteFormatForGrid(gridId)) %>;
        format = format.split(".(Id)").join(o.Id);
        return o.Editable === false ? '' : format;
    }
</script>
<%--end--%>

<br />
<div class="tabs">
    <div class="expl" data-caption="description">
        rows with 1 meal are not editable<br />
        dates with year less than 2015 are readonly
    </div>
    <div data-caption="page"><%=Page.Source("GridInlineEditConditional.aspx") %></div>
    <div data-caption="controller"><%=Page.Csource("Demos/Grid/GridInlineEditDemoController.cs") %></div>
</div> 
</asp:Content>