﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridInlineEditDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.GridInlineEditDemo" %>

<%@ Import Namespace="AwesomeWebFormsDemo.Helpers.Awesome" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <script>
        var meals = <%=DemoUtils.Encode(Db.Meals.Select(o => new KeyContent(o.Id, o.Name))) %>;
    </script>

    <h1>Grid inline editing demo</h1>
    <%--begin--%>
    <%
        var gridId = InlineCrudGrid.ClientID;
        var initObj = new
        {
            Name = "hi there",
            Date = DateTime.Now.ToShortDateString(),
            ChefId = Db.Chefs.First().Id,
            MealsIds = Db.Meals.Take(2).Select(o => o.Id).ToArray()
        };
    %>
    <div class="bar">
        <div style="float: right;">
            <% TxtSearchInl.TextBox().Placeholder("search...").CssClass("searchtxt"); %>
            <awe:ocon runat="server" id="TxtSearchInl" />
        </div>
        <button type="button" onclick="$('#<%=gridId %>').data('api').inlineCreate()" class="awe-btn mbtn">Create</button>

        <%=Page.InlineCreateButtonForGrid(gridId, initObj, "Create with predefined values") %>
    </div>

    <%=Page.InitDeletePopupForGrid(gridId, "GridInlineEditDemo") %>

    <% InlineCrudGrid.Grid()
        .Mod(o => o.Main(false)
        .InlineEdit(Page.Url().Action("Save", "GridInlineEditDemo"))) //, reloadOnSave:true, oneRow:true
    .Url(Page.Url().Action("GridGetItems", "GridInlineEditDemo"))
    .Parent("txtSearchInl", "search")
    .Height(350)
    .Resizable()
    .Reorderable()
    .Attr("data-syncg", "dinner") // crud sync using signalr in site.js
    .Columns(
        new Column { Bind = "Id", Width = 75 }
        .Mod(o => o.InlineId()),

        new Column { Bind = "Name" }
        .InlString(),

        new Column { Bind = "Date", Width = 180 }
        .InlDate(),

        new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef", MinWidth = 170 }
        .Inl(Page.Awe().Lookup("ChefId").Controller("ChefLookup")),

        new Column { Prop = "Meals", Header = "Meals", MinWidth = 200, Grow = 2.2 }
        .InlMultiselect(new MultiselectOpt
        {
            Name = "MealsIds",
            Url = Page.Url().Action("GetMealsImg", "Data")
        }
        .ImgItem()),

        new Column { Bind = "BonusMeal.Name", Prop = "BonusMeal", Header = "Bonus Meal" }
        .InlDropdownList(new DropdownListOpt
        {
            Name = "BonusMealId",
            Url = Page.Url().Action("GetMealsImg", "Data")
        }
        .ImgItem()),                

        new Column { Bind = "Organic", Width = 90, Prop = "DispOrganic" }
        .Inl(Page.Awe().CheckBox("Organic").Otoggl()),
        
        Page.InlEditColumn(),
        Page.InlDeleteColumn(gridId)); %>

    <awe:ocon runat="server" id="InlineCrudGrid" />
    <%--end--%>
    <br />
    <div class="tabs">
        <div data-caption="description" class="expl">
            Inline editing for grid achieved using InlineEdit grid mod<br />

            Delete action is the same as in the grid crud demo, using a popup.<br />

            To set initial values on create set the initial model as a parameter 
            in the inlineCreate method, example: $grid.data('api').inlineCreate({ Name: 'hi' })<br />
            On Save you also get the grid parameters, for example this grid has txtSearchInl as parent, 
            so you get the value of txtSearchInl as 'search' parameter in the Edit/Create post actions
        </div>
        <div data-caption="view"><%=Page.Source("Shared/Demos/GridInlineCrud.cshtml") %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Grid/GridInlineEditDemoController.cs") %></div>
    </div>

    <br />

    <h2>Edit on row click</h2>
    <%--begin2--%>
    <%  var grid2Id = DinnersGrid2.ClientID;  %>
    <div class="bar">
        <div style="float: right;">
            <% TxtSearch2.TextBox().Placeholder("search...").CssClass("searchtxt"); %>
            <awe:ocon runat="server" id="TxtSearch2" />
        </div>
        <button type="button" onclick="$('#<%=grid2Id %>').data('api').inlineCreate()" class="awe-btn mbtn">Create</button>
    </div>
    <div style="clear: both;"></div>
    <%=Page.InitDeletePopupForGrid(grid2Id, "GridInlineEditDemo") %>

<% DinnersGrid2.Grid()
    .Mod(o => o.Main(false).InlineEdit(Page.Url().Action("Save", "GridInlineEditDemo"), rowClickEdit: true))
    .Url(Page.Url().Action("GridGetItems", "GridInlineEditDemo"))
    .Parent("txtSearch2", "search")
    .Height(350)
    .Resizable()
    .Reorderable()
    .Attr("data-syncg", "dinner")
    .Columns(
    new Column { Bind = "Id", Width = 75 }
    .Mod(o => o.InlineId()),

    new Column { Bind = "Name" }
        .InlString(),

    new Column { Bind = "Date", Width = 160 }
        .InlDate(),

    new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef", MinWidth = 170 }
        .InlDropdownList(new DropdownListOpt { Name = "ChefId", Url = Page.Url().Action("GetChefs", "Data") }),

    new Column { Prop = "Meals", Header = "Meals", MinWidth = 250 }
        .InlMultiselect(new MultiselectOpt { Name = "MealsIds", Url = Page.Url().Action("GetMealsImg", "Data") }),

    new Column { Bind = "BonusMeal.Name", Prop = "BonusMeal", Header = "Bonus Meal" }
        .InlDropdownList(new DropdownListOpt { Name = "BonusMealId", Url = Page.Url().Action("GetMealsImg", "Data") }),

    new Column { Bind = "Organic", Width = 90, Prop = "DispOrganic" }
        .Inl(Page.Awe().CheckBox("Organic").Otoggl()),
    Page.InlEditColumn(),
    Page.InlDeleteColumn(DinnersGrid2.ClientID)); %>

    <awe:ocon runat="server" id="DinnersGrid2" />
    <%--end2--%>
    <br />
    <div class="tabs">
        <div data-caption="description" class="expl">
            Edit on row click, and save when clicking out if there is are any changes.
            <br />
            In case of validation errors grid loading (go to another page, sort, group) will be prevented.
        </div>
        <div data-caption="page"><%=Page.Source("GridInlineEditDemo.aspx", "2") %></div>
    </div>
    <br />
    <br />
    See also:
    <br />
    <a href="<%=ResolveUrl("~/GridInlineEditConditional.aspx") %>">Grid inline editing conditional demo</a><br />
    <a href="<%=ResolveUrl("~/GridInlineEditMultiEditors.aspx") %>">Grid inline multiple editors demo</a>
</asp:Content>
