﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridInlineEditMultiEditors.aspx.cs" Inherits="AwesomeWebFormsDemo.GridInlineEditMultiEditors" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
<h2>Multiple editors in one grid cell</h2>
<%--begin--%>
<%  var gridId = DinnersGrid.ClientID;  %>
<div class="bar">
    <div style="float: right;">
        <% TxtSearch.TextBox().Placeholder("search...").CssClass("searchtxt"); %>
        <awe:Ocon runat="server" ID="TxtSearch" />
    </div>
    <button type="button" onclick="$('#<%=gridId %>').data('api').inlineCreate()" class="awe-btn mbtn">Create</button>
    <% 
        var chefId = Db.Chefs.First().Id;
        var meals = Db.Meals.Take(2).Select(o => o.Id).ToArray();
        var initObj = new { Name = "hi there", Date = DateTime.Now.ToShortDateString(), ChefId = chefId, MealsIds = meals };
     %>
    
    <%=Page.InlineCreateButtonForGrid(gridId, initObj, "Create with predefined values") %>
</div>

<%=Page.InitDeletePopupForGrid(gridId, "GridInlineEditDemo") %>

<% DinnersGrid.Grid()
      .Mod(o => o.PageInfo()
          .InlineEdit(Page.Url().Action("Save", "GridInlineEditDemo")))
      .Url(Page.Url().Action("GridGetItems", "GridInlineEditDemo"))
      .Parent(TxtSearch.ClientID, "search")
      .Height(350)
      .Resizable()
      .Reorderable()
      .Columns(
          new Column { Bind = "Id", Width = 75 }
              .Mod(o => o.InlineId()),

          new Column { Bind = "Name,Date", ClientFormat = ".(Name) .(Date)", Header = "Name" }
              .Mod(o => o.Inline(Page.Awe().TextBox("Name"))
                         .Inline(Page.Awe().DatePicker("Date"))),

          new Column { Bind = "Chef.FirstName,Chef.LastName", Prop = "ChefName", Header = "Chef", Width = 200 }
              .Mod(o => o.Inline(Page.Awe().Lookup("Chef").Controller("ChefLookup"), "ChefId")),

          new Column { ClientFormat = ".(Meals) and .(BonusMeal)", Header = "Meals" }
              .Mod(o => o.Inline(Page.Awe().AjaxCheckboxList("Meals").Multiselect().DataFunc("aweUtils.getItems(meals)"), "MealsIds")
                         .Inline(Page.Awe().AjaxRadioList("BonusMealId").Odropdown().DataFunc("aweUtils.getItems(meals)"), "BonusMealId")),

          new Column { Bind = "Organic", Width = 100, ClientFormat = ".(DispOrganic)" }
              .Mod(o => o.Inline(Page.Awe().CheckBox("Organic").Otoggl())),

          Page.InlEditColumn(),
          Page.InlDeleteColumn(gridId)); %>
<awe:Ocon runat="server" ID="DinnersGrid" />
<script>
    var meals = <%=DemoUtils.Encode(Db.Meals.Select(o => new KeyContent(o.Id, o.Name))) %>;
</script>
<%--end--%>
<br />
<div class="tabs">
    <div data-caption="page"><%=Page.Source("GridInlineEditMultiEditors.aspx") %></div>
    <div data-caption="controller"><%=Page.Csource("Demos/Grid/GridInlineEditDemoController.cs") %></div>
</div>  
</asp:Content>