﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="GridNestingDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.GridNestingDemo" %>
<asp:Content runat="server" ID="ContentPlaceHolder1" ContentPlaceHolderID="ContentPlaceHolder1">
<h3>Grid nesting demo</h3>
<div class="expl">
    The awesome grid can have multiple nests, an url or js func can be specified for loading the nest content.
    <br />
    When using url the Key of the grid is sent as "Key" parameter to the url.<br />
    The class of the html element that will act as a toggle button for the nest needs to be specified, that element will get the awe-on class additionally while its nest is open.
    Opening a nest will close other nests that are open for the same row.
</div>

<h2>Master detail grid</h2>
Using one nest with url to achieve a master detail grid view
<%--begin1--%>
<% MasterDetailGrid.Grid()
        .Columns(
            new Column { ClientFormat = "<div class='detailnst'><i class='caretc'><i class='o-caret'></i></i> .(Id)</div>", Width = 100, Header = "Id" },
            new Column { Bind = "Person" },
            new Column { Bind = "Food.Name" },
            new Column { Bind = "Location" })
        .Url(Page.Url().Action("GetItems", "LunchGrid"))
        .PageSize(5)
        .Height(300)
        .Nests(new Nest { Name = "detailnst", Url = Page.Url().Action("LunchDetail", "GridNestingDemo"), LoadOnce = true }); %>
<awe:Ocon runat="server" ID="MasterDetailGrid" />
<br/>
<p>
    using grid api to open, close and toggle open nest for the first row:
</p>
<button type="button" class="awe-btn" id="btnOpenNest">Open nest</button>
<button type="button" class="awe-btn" id="btnCloseNest">Close nest </button>
<button type="button" class="awe-btn" id="btnToggleNest">Toggle nest</button>

<script>
    $(function () {
        var grid = $('#<%=MasterDetailGrid.ClientID %>');
        var api = grid.data('api');

        $('#btnToggleNest').click(function () {
            api.nestToggle(grid.find('.awe-row:first'), 'detailnst');
        });

        $('#btnOpenNest').click(function () {
            api.nestOpen(grid.find('.awe-row:first'), 'detailnst');
        });

        $('#btnCloseNest').click(function () {
            api.nestClose(grid.find('.awe-row:first'), 'detailnst');
        });
    });
</script>

<style>
    .detailnst {
        cursor: pointer;
    }

    .caretc {
        position: relative;
        padding: 0 .7em;
        margin-right: .5em;
    }

        .caretc .o-caret {
            transform: rotate(-90deg);
            zoom: 1.1;
        }

    .detailnst-on .caretc .o-caret {
        transform: rotate(-45deg);
    }
</style>
<%--end1--%>

<% Tabs1.Tabs().CssClass("code")
    .Add("demo view", Page.Source("GridNestingDemo.aspx", 1))
    .Add("grid controller", Page.Csource("Awesome/Grid/LunchGridController.cs"))
    .Add("demo controller", Page.Csource("Demos/Grid/GridNestingDemoController.cs", 1))
    .Add("LunchDetail view", Page.Source("GridNestingDemo/LunchDetail.cshtml")); %>
<awe:Ocon runat="server" ID="Tabs1" />

<h2>Nested grids / Hierarchical grid</h2>
the url of the nest points to an action that will render another grid, it also receives the key of the row (Id) as a parameter to filter it's content
<%--begin2--%>
<% CategoriesGrid.Grid()
        .Resizable()
        .Url(Page.Url().Action("CategoriesGrid", "Data"))
        .Columns(new Column { Bind = "Name", ClientFormat = "<div class='detailnst'><i class='caretc'><i class='o-caret'></i></i> .(Name)</div> " })
        .Nests(new Nest { Name = "detailnst", Url = Page.Url().Action("MealGrid", "GridNestingDemo"), LoadOnce = true }); %>
<awe:Ocon runat="server" ID="CategoriesGrid" />
<%--end2--%>

<% Tabs2.Tabs().CssClass("code")
    .Add("demo view", Page.Source("GridNestingDemo.aspx", 2))
    .Add("demo controller", Page.Csource("Demos/Grid/GridNestingDemoController.cs"))
    .Add("inner grid markup view", Page.Source("GridNestingDemo/MealGrid.cshtml", 2))
    .Add("grids controller", Page.Csource("Awesome/DataController.cs", "casg")); %>
<awe:Ocon runat="server" ID="Tabs2" />
</asp:Content>