﻿<%@ Page Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="LookupDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.LookupDemo" %>
<%@ Import Namespace="AwesomeWebFormsDemo.Controllers.Awesome.Lookup" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">

<div class="example">
    <h3>Lookup Grid</h3>
    <div class="efield">
        <div class="elabel">
            Meal:
        </div>
        <div class="einput">
            <%--begin--%>
            <% MealCustomPopup.Lookup()
                        .LookupGrid(Page.Url().Action("MealLookup", "LookupDemo"))
                        .Controller("MealLookup"); %>
            <awe:Ocon runat="server" ID="MealCustomPopup" />
            <%--end--%>
        </div>
    </div>

    <br />
    <% Tabs1.Tabs().Add("description", @"
        Lookup with grid inside the popup, done using the lookupgrid mod that also uses PopupUrl extension.", "expl")
                     .Add("page", Page.Source("LookupDemo.aspx"))
                     .Add("lookup controller", Page.Csource("Awesome/Lookup/MealLookupController.cs"))
                     .Add("popup view", Page.Source("LookupDemo/MealLookup.cshtml")); %>
    <awe:Ocon runat="server" ID="Tabs1" />
</div>

<div class="example">
    <h3>Lookup with Custom Items template</h3>
    <div class="efield">
        <div class="elabel">
            Meal:
        </div>
        <div class="einput">
            <%--beginci--%>
            <% MealCustomItem.Lookup()
                  .Controller("MealCustomItemLookup")
                  .CustomSearch(); %>
            <awe:Ocon runat="server" ID="MealCustomItem" />
            <%--endci--%>
        </div>
    </div>
    <br />
    <% Tabs2.Tabs().Add("description",
        @"The Search action of the LookupController returns json of AjaxListResult,
            we need to set the string AjaxListResult.Content instead of Items in order to achieve
            Custom Item Template, exactly the same as for the AjaxList helper.", "expl")
                       .Add("page", Page.Source("LookupDemo.aspx", "ci"))
                       .Add("lookup controller", Page.Csource("Awesome/Lookup/MealCustomItemLookupController.cs"))
                       .Add("search form view", Page.Source("MealCustomItemLookup/SearchForm.cshtml"))
                       .Add("items view", Page.Source("MealCustomItemLookup/Items.cshtml")); %>
    <awe:Ocon runat="server" ID="Tabs2" />
</div>

<div class="example">
    <h3>Lookup bound parents</h3>
    <%--beginbp--%>
    <div class="efield">
        <div class="elabel">
            Parent Categories:
        </div>
        <div class="einput">
            <% CategoriesData.MultiLookup()
                  .Controller<CategoriesMultiLookupController>()
                  .ClearButton(); %>
            <awe:Ocon runat="server" ID="CategoriesData" />
        </div>
    </div>
    <div class="efield">
        <div class="elabel">
            Parent Category:
        </div>
        <div class="einput">
            <% Category.AjaxDropdown().Url(Page.Url().Action("GetCategories", "Data")); %>
            <awe:Ocon runat="server" ID="Category" />
        </div>
    </div>
    <div class="efield">
        <div class="elabel">
            Child Meal:
        </div>
        <div class="einput">
            <% ChildOfMany.Lookup()
                  .Parent(CategoriesData.ClientID, "categories")
                  .Parent(Category.ClientID, "categories")
                  .Controller<MealCustomSearchLookupController>(); %>
            <awe:Ocon runat="server" ID="ChildOfMany" />
        </div>
    </div>
    <%--endbp--%>
    <br />
    <% Tabs3.Tabs().Add("description",
        @"Binding to parents and setting predefined parameters is done the same as for
            the AjaxDropdown using .Parent() and .Parameter(), values are passed to both GetItem and Search actions.<br />
            Unlike other controls the Lookup won't change its value when the value of the parent is changed.", "expl")
                       .Add("page", Page.Source("LookupDemo.aspx", "bp")); %>
    <awe:Ocon runat="server" ID="Tabs3" />
</div>

<div class="example">
    <h3>Setting predefinded parameters</h3>
    <% 
        var cat0 = Db.Categories[0];
        var cat1 = Db.Categories[1];
     %>
    <div class="efield">
        <div class="elabel">
            Meal1 (categories = {<%=cat0.Name %>, <%=cat1.Name %>}):
        </div>
        <div class="einput">
            <% Meal2.Lookup()
                .Parameter("categories", new[] { cat0.Id })
                .Controller<MealCustomSearchLookupController>()
                .ParameterFunc("giveParams")
            ; %>
            <awe:Ocon runat="server" ID="Meal2" />
        </div>
    </div>
    <script>
        function giveParams() {
            return { categories: <%=cat1.Id %> };
        }
    </script>
</div>
</asp:Content>