﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="MasterDetailCrudDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.MasterDetailCrudDemo" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">

    <h2>Master Detail CRUD Demo using Grid and PopupForm</h2>
    This is a demo for master detail CRUD using the Grid.<br />
    For master-detail grid see <a href="<%=ResolveUrl("~/GridNestingDemo.aspx") %>#Master-detail-grid">Master Detail Grid</a>, or <a href="<%=ResolveUrl("~/GridNestingDemo.aspx") %>#Nested-grids--Hierarchy">Hierarchy (Nested Grids)</a>
    <%--begin--%>
    <%  var grid1 = RestaurantGrid.ClientID;  %>
    <%=Page.InitCrudPopupsForGrid(grid1, "MasterDetailCrudDemo", 470, 1000) %>

    <div class="bar">
        <button type="button" class="awe-btn mbtn" onclick="awe.open('create<%=grid1 %>')">Create</button>
    </div>

    <% RestaurantGrid.Grid()
           .Height(350)
           .Attr("data-syncg", "rest") // crud sync using signalr in site.js
           .Url(Page.Url().Action("RestaurantGridGetItems", "MasterDetailCrudDemo"))
           .Groupable(false)
           .Columns(
               new Column { ClientFormat = ".(Id)", Header = "Id", Width = 70 },
               new Column { Bind = "Name" },
               Page.EditColumnForGrid(grid1),
               Page.DeleteColumnForGrid(grid1)); %>
    <awe:Ocon runat="server" ID="RestaurantGrid" />
    <%--end--%>

    <div class="tabs code">
        <div data-caption="main view"><%=Page.Source("MasterDetailCrudDemo.aspx") %></div>
        <div data-caption="master create view"><%=Page.Source("MasterDetailCrudDemo/Create.cshtml") %></div>
        <div data-caption="detail create view"><%=Page.Source("AddressesGridCrud/Create.cshtml") %></div>
        <div data-caption="master crud controller"><%=Page.Csource("Demos/Grid/MasterDetailCrud/MasterDetailCrudDemoController.cs") %></div>
        <div data-caption="detail crud controller"><%=Page.Csource("Demos/Grid/MasterDetailCrud/AddressesGridCrudController.cs") %></div>
    </div>

    <h3>Master Detail CRUD using Inline Editing and nesting</h3>
    <%--begingl--%>
    <% 
        var grid3 = RestaurantGridInline.ClientID;
    %>

    <%=Page.InitDeletePopupForGrid(grid3, "MasterDetailCrudDemo") %>

    <div class="bar">
        <% Button1.Button().Text("Create").OnClick("$('#" + grid3 + "').data('api').inlineCreate()").CssClass("mbtn"); %>
        <awe:Ocon runat="server" ID="Button1" />
    </div>

    <% RestaurantGridInline.Grid()
          .Url(Page.Url().Action("RestaurantGridGetItems", "MasterDetailCrudDemo"))
          .Mod(o => o.InlineEdit(Page.Url().Action("Create", "RestInl"), Page.Url().Action("Edit", "RestInl"), rowClickEdit: true))
          .Groupable(false)
          .Attr("data-syncg", "rest")
          .Nests(new Nest { Name = "detailnst", Url = Page.Url().Action("Addresses", "RestInl"), LoadOnce = true })
          .Columns(
              new Column { ClientFormat = ".(Id)", Header = "Id", Width = 70 }.Mod(o => o.InlineId()),
              new Column { Bind = "Name" }.Mod(o => o.Inline(Page.Awe().TextBox("Name"))),
              new Column
              {
                  ClientFormat = "<button type='button' class='awe-btn detailnst'>details <i class='caretc'><i class='o-caret'></i></i></button>",
                  Width = 135
              },
              Page.InlEditColumn(),
              Page.InlDeleteColumn(grid3)); %>
    <awe:Ocon runat="server" ID="RestaurantGridInline" />
    <style>
        /* hide addresses button for new rows */
        .o-glnew .detailnst {
            display: none;
        }

        .caretc {
            position: relative;
            padding: .4em .5em;
            display: inline-block;
        }

            .caretc .o-caret {
                transform: rotate(-90deg);
                zoom: 1.1;
            }

        .detailnst-on .caretc .o-caret {
            transform: rotate(0);
        }
    </style>
    <%--endgl--%>
    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("MasterDetailCrudDemo.aspx", "gl") %></div>
        <div data-caption="nest view"><%=Page.Source("RestInl/Addresses.cshtml") %></div>
        <div data-caption="RestInl controller"><%=Page.Csource("Demos/Grid/MasterDetailCrud/RestInlController.cs") %></div>
    </div>
</asp:Content>