using System.Collections.Generic;

namespace AwesomeWebFormsDemo.Models
{
    public static class MySiteMap
    {
        private static readonly IList<SiteMapItem> items = new List<SiteMapItem>();

        public static IEnumerable<SiteMapItem> GetAll()
        {
            return items;
        }

        static MySiteMap()
        {
            var grid = new SiteMapItem { Name = "Grid" };

            items.Add(grid);
            
            items.Add(new SiteMapItem { Name = "Quick View", Page = "GridDemo.aspx", Parent = grid, Keywords = "basic features"});
            items.Add(new SiteMapItem { Name = "Custom Querying", Page = "GridCustomQuerying.aspx", Parent = grid });
            items.Add(new SiteMapItem { Name = "Custom Format", Page = "GridCustomFormat.aspx", Parent = grid });
            items.Add(new SiteMapItem { Name = "RTL Support", Page = "GridRtlSupport.aspx", Parent = grid });
            items.Add(new SiteMapItem { Name = "Nesting", Page = "GridNestingDemo.aspx", Keywords = "master detail", Parent = grid });
            items.Add(new SiteMapItem { Name = "Tree Grid", Page = "TreeGrid.aspx", Parent = grid });
            items.Add(new SiteMapItem { Name = "Header Groups", Page = "GridMultiRowHeaderGroups.aspx", Parent = grid });
            items.Add(new SiteMapItem { Name = "Custom Render", Page = "GridCustomRender.aspx", Parent = grid });

            var demos = new SiteMapItem { Name = "Demos", Parent = grid };
            items.Add(demos);
            items.Add(new SiteMapItem { Name = "Grid Inline Editing", Page = "GridInlineEditDemo.aspx", Parent = demos });

            items.Add(new SiteMapItem
            {
                Name = "Grid Inline Editing Conditional",
                Page = "GridInlineEditConditional.aspx",
                Parent = demos,
                NoMenu = true
            });

            items.Add(new SiteMapItem
            {
                Name = "Grid Inline Multiple Editors",
                Page = "GridInlineEditMultiEditors.aspx",
                Parent = demos,
                NoMenu = true
            });

            items.Add(new SiteMapItem { Name = "Grid Crud (Popup)", Page = "GridCrudDemo.aspx", Keywords = "editing", Parent = demos });
            items.Add(new SiteMapItem { Name = "Master Detail crud", Page = "MasterDetailCrudDemo.aspx", Parent = demos });
            items.Add(new SiteMapItem { Name = "Grid Client Data", Page = "GridClientDataDemo.aspx", Parent = demos });
            
            items.Add(new SiteMapItem { Name = "Grid Mailbox", Page = "MailboxDemo.aspx", Parent = demos });

            items.Add(new SiteMapItem { Name = "Spreadsheet Grid", Page = "GridSpreadsheet.aspx", Keywords = "inline", Parent = demos });
            items.Add(new SiteMapItem { Name = "Scheduler", Page = "Scheduler.aspx", Keywords = "", Parent = demos });
            items.Add(new SiteMapItem
            {
                Name = "Autocomplete Cells Spreadsheet Grid",
                Page = "GridSpreadsheetAutocomplete.aspx",
                Keywords = "inline",
                Parent = demos,
                NoMenu = true
            });

            var awesome = new SiteMapItem { Name = "Awesome" };

            items.Add(awesome);
                        
            var lookup = new SiteMapItem { Name = "Lookup", Page = "LookupDemo.aspx", Parent = awesome };
            items.Add(lookup);

            var multilookup = new SiteMapItem { Name = "MultiLookup", Page = "MultiLookupDemo.aspx", Parent = awesome };
            items.Add(multilookup);

            items.Add(new SiteMapItem { Name = "Drag And Drop", Page = "DragAndDropDemo.aspx", Parent = awesome, Keywords = "grid reorder rows move" });
            items.Add(new SiteMapItem { Name = "Dropmenu", Page = "Dropmenu.aspx", Parent = awesome });
            items.Add(new SiteMapItem { Name = "AjaxDropdown", Page = "AjaxDropdownDemo.aspx", Parent = awesome });
            items.Add(new SiteMapItem { Name = "AjaxRadioList", Page = "AjaxRadioListDemo.aspx", Keywords = "odropdown buttongroup select combobox", Parent = awesome });
            items.Add(new SiteMapItem { Name = "AjaxCheckBoxList", Page = "AjaxCheckBoxListDemo.aspx", Keywords = "multiselect dropdown buttongroup", Parent = awesome });
            items.Add(new SiteMapItem { Name = "Autocomplete", Page = "AutocompleteDemo.aspx", Parent = awesome });
            
            items.Add(new SiteMapItem { Name = "Popup", Page = "PopupDemo.aspx", Parent = awesome });
            items.Add(new SiteMapItem { Name = "PopupForm", Page = "PopupFormDemo.aspx", Parent = awesome });
            items.Add(new SiteMapItem { Name = "DatePicker", Page = "DatePickerDemo.aspx", Parent = awesome, Keywords = "timepicker" });
            items.Add(new SiteMapItem { Name = "TextBox", Page = "TextBoxDemo.aspx", Parent = awesome });
            items.Add(new SiteMapItem { Name = "Form Inputs", Page = "FormInput.aspx", Parent = awesome, Keywords = "ocheckbox ochk otoggle" });

            var ajaxlist = new SiteMapItem { Name = "AjaxList", Collapsed = true };

            items.Add(ajaxlist);
            items.Add(new SiteMapItem { Name = "Quick View", Page = "AjaxListDemo.aspx", Parent = ajaxlist });
            items.Add(new SiteMapItem { Name = "Custom Item Template", Page = "AjaxListCustomItemTemplate.aspx", Parent = ajaxlist });
                        
            var generic = new SiteMapItem { Name = "Generic" };

            items.Add(generic);
            items.Add(new SiteMapItem { Name = "Validation", Page = "Validation.aspx", Parent = generic });
            
            var misc = new SiteMapItem { Name = "Misc" };
            items.Add(misc);
            
            items.Add(new SiteMapItem { Name = "Wizard Demo", Page = "WizardDemo.aspx", Parent = misc });
            items.Add(new SiteMapItem { Name = "CRUD inside Lookup", Page = "CrudInLookup.aspx", Parent = misc });
            items.Add(new SiteMapItem { Name = "Grid export to excel/pdf/txt", Page = "GridExportToExcelDemo.aspx", Parent = misc });
        }
    }
}