﻿<%@ Page Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="MultiLookupDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.MultiLookupDemo" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
<div class="example">
    <h3>MultiLookup Grid</h3>
    <div class="efield">
        <div class="elabel">
            Meal:
        </div>
        <div class="einput">
            <%--begin--%>
            <% MealCustomPopup.MultiLookup()
                  .MultiLookupGrid(Page.Url().Action("MealMultiLookup", "MultiLookupDemo"))
                  .Height(500)
                  .Width(500)
                  .Controller("MealsMultiLookup"); %>
            <awe:Ocon runat="server" ID="MealCustomPopup" />
            <%--end--%>
        </div>
    </div>

    <br />
    <% Tabs1.Tabs().Add("description", 
@"MultiLookup with grids inside the popup, done using the MultiLookupGrid mod that also uses PopupUrl extension.", "expl")
        .Add("page", Page.Source("MultiLookupDemo.aspx"))
        .Add("multilookup controller", Page.Csource("Awesome/MultiLookup/MealsMultiLookupController.cs"))
        .Add("popup view", Page.Source("MultiLookupDemo/MealMultiLookup.cshtml")); %>
    <awe:Ocon runat="server" ID="Tabs1" />
</div>

<div class="example">
    <h3>
        MultiLookup with custom Items Layout
    </h3>
    <div class="efield">
        <div class="elabel">
            Meals:
        </div>
        <div class="einput">
            <%--beginci--%>
            <% MealsCustomItem.MultiLookup()
                  .Controller<MealsCustomItemMultiLookupController>()
                  .Mod(o => o.ShowHeader())
                  .CustomSearch()
                  .Height(700)
                  .HighlightChange(); %>
            <awe:Ocon runat="server" ID="MealsCustomItem" />
            <%--endci--%>
        </div>
    </div>
    <br />
    <% Tabs2.Tabs().Add("page", Page.Source("MultiLookupDemo.aspx", "ci"))
                     .Add("controller", Page.Csource("Awesome/MultiLookup/MealsCustomItemMultiLookupController.cs"))
                     .Add("search form view", Page.Source("MealsCustomItemMultiLookup/SearchForm.cshtml"))
                     .Add("items view", Page.Source("MealsCustomItemMultiLookup/Items.cshtml")); %>
    <awe:Ocon runat="server" ID="Tabs2" />
</div>

<div class="example">
    <h3>MultiLookup bound to many parents</h3>
    <div class="efield">
        <div class="elabel">
            Parent Categories:
        </div>
        <div class="einput">
            <% CategoriesData.MultiLookup()
                          .Controller<CategoriesMultiLookupController>()
                          .ClearButton(); %>
            <awe:Ocon runat="server" ID="CategoriesData" />
        </div>
    </div>
    <div class="efield">
        <div class="elabel">
            Parent Category:
        </div>
        <div class="einput">
            <% Category.AjaxDropdown().Url(Page.Url().Action("GetCategories", "Data", "MultiLookupDemo")); %>
            <awe:Ocon runat="server" ID="Category" />
        </div>
    </div>
    <div class="efield">
        <div class="elabel">
            Child Meals:
        </div>
        <div class="einput">
            <% ChildOfMany.MultiLookup()
              .Parent(CategoriesData.ClientID, "categories")
              .Parent(Category.ClientID, "categories")
              .Controller<MealsCustomSearchMultiLookupController>()
            ; %>
            <awe:Ocon runat="server" ID="ChildOfMany" />
        </div>
    </div>
</div>

<div class="example">
    <h3>Setting predefined parameters</h3>
    <% 
        var category1 = Db.Categories[0];
        var category2 = Db.Categories[1];
     %>
    <div class="efield">
        <div class="elabel">
            Meals (categories =
            <%=category1.Name %>):
        </div>
        <div class="einput">
            <% Meals2.MultiLookup()
                          .Parameter("categories", new[] { category1.Id })
                          .Controller<MealsCustomSearchMultiLookupController>()
                          .ParameterFunc("giveParams"); %>
            <awe:Ocon runat="server" ID="Meals2" />
        </div>
    </div>
    <script>
        function giveParams() {
            return { categories: <%=category2.Id %> };
        }
    </script>
</div>
</asp:Content>