﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="PopupDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.PopupDemo" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
<h1>Popup</h1>
<div class="expl">
    It is initialized using <code>Html.Awe().InitPopup()</code> and after opened using <code>awe.open</code> js function.
</div>
<br />
<div class="example">
    <h2>Initialize and open popup on button click </h2>
    <%--begin1--%>
    <% InitPopup1.InitPopup()
        .Name("popup1")
        .Url(Page.Url().Action("Popup1", "PopupDemo"))
        .LoadOnce()
        .Title("popup title"); %>
    <awe:Ocon runat="server" ID="InitPopup1" />

    <% Button1.Button().Text("Open Popup").OnClick(Page.Awe().OpenPopup("popup1")); %>
    <awe:Ocon runat="server" ID="Button1" />
    <%--end1--%>
    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("PopupDemo.aspx", 1) %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Helpers/PopupDemoController.cs", 1) %></div>
        <div data-caption="popup view"><%=Page.Source("PopupDemo/Popup1.cshtml", 1) %></div>
    </div>
</div>

<div class="example">
    <h2>Position top, modal, close on click outside</h2>
    <%--begintm--%>
    <% InitPopupMod.InitPopup()
          .Name("popupTop")
          .Url(Page.Url().Action("Popup1", "PopupDemo"))
          .LoadOnce()
          .Modal()
          .Top()
          .Mod(o => o.OutClickClose())
          .Width(1000)
          .Title("top modal popup"); %>
    <awe:Ocon runat="server" ID="InitPopupMod" />

    <% ButtonTop.Button().Text("Open top modal").OnClick(Page.Awe().OpenPopup("popupTop")); %>
    <awe:Ocon runat="server" ID="ButtonTop" />
    <%--endtm--%>
    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("PopupDemo.aspx", "tm") %></div>
    </div>
</div>

<div class="example">
    <h2>Dropdown Popup</h2>
    <%--begin4--%>
    <% InitPopup2.InitPopup()
        .Name("popupdd1")
        .Url(Page.Url().Action("DropdownContent", "PopupDemo"))
        .LoadOnce()
        .Mod(o => o.Dropdown()); %>
    <awe:Ocon runat="server" ID="InitPopup2" />

    <% Button2.Button().Text("open popup").OnClick(Page.Awe().OpenPopup("popupdd1")); %>
    <awe:Ocon runat="server" ID="Button2" />
    <% Button3.Button().Text("open same popup").OnClick(Page.Awe().OpenPopup("popupdd1")); %>
    <awe:Ocon runat="server" ID="Button3" />
    <br />
    <br />
    <div class="area">
        <div class="msg">click here</div>
    </div>
    <script>
        $(function () {
            $(document).on('click', '.area', function (e) { awe.open('popupdd1', { xy: { x: e.clientX, y: e.clientY } }, e); });
        });
    </script>
    <br />
    <% InitPopup3.InitPopup()
        .Name("ddinpop")
        .Url(Page.Url().Action("DdInPopup", "PopupDemo"))
        .LoadOnce()
        .Modal()
        .Mod(o => o.OutClickClose()); %>
    <awe:Ocon runat="server" ID="InitPopup3" />

    <% Button4.Button().Text("dropdown in popup").OnClick(Page.Awe().OpenPopup("ddinpop")); %>
    <awe:Ocon runat="server" ID="Button4" />
    <%--end4--%>

    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("PopupDemo.aspx", 4) %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Helpers/PopupDemoController.cs", 3) %></div>
        <div data-caption="popup view"><%=Page.Source("PopupDemo/DropdownContent.cshtml") %></div>
    </div>
</div>

<div class="example">
    <h2>Sending client side paramters to server on content load</h2>
    Value sent to the server action that returns the popup's content:
    <%--begin2--%>
    <input type="text" id="txtParam1" value="textbox value abc" />

    <br />

    <% InitPopup4.InitPopup()
          .Name("PopupParams")
          .Url(Page.Url().Action("PopupWithParameters", "PopupDemo"))
          .Parent("txtParam1")
          .Parameter("p1", 15)
          .ParameterFunc("setParams"); %>
    <awe:Ocon runat="server" ID="InitPopup4" />

    <% Button5.Button().Text("Open Popup")
          .OnClick(Page.Awe().OpenPopup("PopupParams").Params(new { Id = 123 })); %>
    <awe:Ocon runat="server" ID="Button5" />

    <script>
        function setParams() {
            return { a: "hi", b: "how are you" };
        }
    </script>
    <%--end2--%>
    <div class="code tabs">
        <div data-caption="page"><%=Page.Source("PopupDemo.aspx", 2) %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Helpers/PopupDemoController.cs", 2) %></div>
        <div data-caption="popup view"><%=Page.Source("PopupDemo/PopupWithParameters.cshtml") %></div>
    </div>
</div>

<div class="example">
    <h2>Full screen popup</h2>
    <%--begin5--%>
    <% InitPopup5.InitPopup()
          .Name("psize")
          .Url(Page.Url().Action("PopupSize", "PopupDemo"))
          .Fullscreen(); %>
    <awe:Ocon runat="server" ID="InitPopup5" />

    <% Button6.Button().Text("Open").OnClick(Page.Awe().OpenPopup("psize")); %>
    <awe:Ocon runat="server" ID="Button6" />
    <%--end5--%>

    <%=Page.Source("PopupDemo.aspx", "5", true) %>
</div>

<div class="example">
    <h2>Buttons</h2>
    <%--begin3--%>
    <div id="p3Cont"></div>
    <% InitPopup6.InitPopup().Name("p3")
          .Button("Add Hi", "addHi")
          .Button("Close", "closePopup")
          .Url(Page.Url().Action("PopupBtns", "PopupDemo"))
          .Close("onClose"); %>
    <awe:Ocon runat="server" ID="InitPopup6" />

    <% Button7.Button().Text("Open").OnClick(Page.Awe().OpenPopup("p3")); %>
    <awe:Ocon runat="server" ID="Button7" />
    <div id="p3Log"></div>
    <script type="text/javascript">
        function closePopup() {
            $(this).data('api').close();
        }

        function addHi() {
            $(this).prepend('<p>hi</p>');
            $(this).data('api').lay();
        }

        function onClose() {
            awe.flash($('#p3Log').html('popup was closed at ' + site.getFormattedTime()));
        }

    </script>
    <%--end3--%>
    <div class="code">
        <%=Page.Source("PopupDemo.aspx", 3) %>
    </div>
</div>

<div class="example">
    <h2>Autosize </h2>
    Open any popup and try resizing the browser (try to make it smaller than the popup), works for popups from other helpers as well.

    <h3>Notes</h3>
    When there is more Popup helpers declared that have the same <code>.Name(string)</code>,
    they will share the same popup window, so opening one will close the other;
    if you need to have popups with different names to share the same popup window use <code>.Group(string)</code>.
</div>

<h3>Open animation</h3>
<div class="expl">
    Using custom js to create a slide in animation when the popup opens.
</div>
<br />
<%--beginanim--%>
<% InitPopupAnim1.InitPopup()
      .Name("popupAnim")
      .Url(Page.Url().Action("Popup1", "PopupDemo"))
      .Modal()
      .Mod(o => o.OutClickClose())
      .LoadOnce()
      .Title("popup slide in animation"); %>
<awe:Ocon runat="server" ID="InitPopupAnim1" />

<% ButtonAnim1.Button().Text("popup slide in from right").OnClick(Page.Awe().OpenPopup("popupAnim").Params(new { slide = "right" })); %>
<awe:Ocon runat="server" ID="ButtonAnim1" />
<% ButtonAnim2.Button().Text("popup slide in from bottom").OnClick(Page.Awe().OpenPopup("popupAnim").Params(new { slide = "bot" })); %>
<awe:Ocon runat="server" ID="ButtonAnim2" />

<script>
    $(function () {
        $(document).on('aweopen', '.awe-popup', function () {
            var popup = $(this);
            var o = popup.data('o');
            var prms = o.params;
            if (prms && prms.slide) {
                slide(popup, prms.slide);
            }
        });
    });

    function slide(popup, from) {
        var o = popup.data('o');
        var max = from == 'bot' ? $(window).height() : $(window).width();
        var transl = 'translate' + (from == 'bot' ? 'Y' : 'X');

        var div = popup.closest('.o-pmc');
        o.nolay = 1;
        div.css('transform', transl + '(' + max + 'px)');

        setTimeout(function () {
            div.css('transition', '.5s');
            div.css('transform', transl + '(0)');

            setTimeout(function () {
                o.nolay = 0;
                div.css('transition', '');
                div.css('transform', '');
                o.cx.api.lay();
            }, 500);
        }, 30);
    }
</script>
<%--endanim--%>
<div class="tabs code">
    <div data-caption="page"><%=Page.Source("PopupDemo.aspx", "anim") %></div>
</div>
</asp:Content>