﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="PopupFormDemo.aspx.cs" Inherits="AwesomeWebFormsDemo.PopupFormDemo" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
  <h1>PopupForm - used to load and post a form in a popup</h1>
<div class="expl">
    It can be initialized using <code>Html.Awe().InitPopupForm</code> and opened using <code>awe.open</code> js function or <code>Html.Awe().OpenPopup</code> helper.
    It loads the content from the <code>.Url(string)</code> provided and when the user clicks ok, the form will be posted, if the result of the post is view/string (usually when ModelState not valid) the content of the popup will be replaced with the post result,
    when the result is a json object the popup will close, if the PopupForm has a success function defined the json object will be passed that function.
</div>
<br/>
You can see the PopupForm being used in all of the Crud demos (<a href="<%=ResolveUrl("~/GridCrudDemo.aspx") %>">Grid</a>, 
also in the <a href="<%=ResolveUrl("~/WizardDemo.aspx") %>">Wizard Demo</a>. 
In most Crud demos the call to Html.Awe().InitPopupForm is being wrapped in a custom helper Page.InitCrudPopupsForGrid which calls this helper multiple times (for Create, Edit, Delete).

<div class="example">
    <h2>PopupForm with Success function assigned</h2>
    <%--begin--%>
    <% InitPopupForm1.InitPopupForm()
          .Name("createDinner")
          .Height(400)
          .Url(Page.Url().Action("Create", "DinnersGridCrud"))
          .Success("created"); %>
    <awe:Ocon runat="server" ID="InitPopupForm1" />

    <% Button1.Button().Text("Create").OnClick(Page.Awe().OpenPopup("createDinner")); %>
    <awe:Ocon runat="server" ID="Button1" />

    <script type="text/javascript">
        function created(result, popup) {
            alert('dinner created');
        }
    </script>
    <%--end--%>

    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("PopupFormDemo.aspx") %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Grid/DinnersGridCrudController.cs") %></div>
        <div data-caption="popup view"><%=Page.Source("DinnersGridCrud/Create.cshtml") %></div>
    </div>
</div>
<div class="example">
    <h2>Sending client side parameters to server on content load</h2>

    Value sent to the server action that returns the popup's content:
    <input type="text" id="txtParam1" value="textbox text xyz" />
    <br />

    <%--begin4--%>

    <% InitPopupForm2.InitPopupForm()
          .Name("PopupFormParams")
          .Url(Page.Url().Action("PopupWithParameters", "PopupFormDemo"))
          .Button("Help", "helpClick")
          .Parent("txtParam1")
          .Parameter("p1", 15)
          .ParameterFunc("setParams"); %>
    <awe:Ocon runat="server" ID="InitPopupForm2" />

    <% Button2.Button().Text("Open Popup")
          .OnClick(Page.Awe().OpenPopup("PopupFormParams").Params(new { Id = 123 })); %>
    <awe:Ocon runat="server" ID="Button2" />

    <script>
        function setParams() {
            return { a: "hi", b: "how are you" };
        }

        function helpClick() {
            awe.flash($(this).find('.msg1').html('help clicked'));
        }
    </script>
    <%--end4--%>
    <div class="code tabs">
        <div data-caption="page"><%=Page.Source("PopupFormDemo.aspx", "4") %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Helpers/PopupFormDemoController.cs") %></div>
        <div data-caption="popup view"><%=Page.Source("PopupFormDemo/PopupWithParameters.cshtml") %></div>
    </div>
</div>
<div class="example">
    <h2>Submit confirmation using OnLoad func</h2>
    <%--begincs--%>
    <% InitPopupForm3.InitPopupForm()
                    .Name("confirmedPopup")
                    .Height(200)
                    .Url(Page.Url().Action("PopupConfirm", "PopupFormDemo"))
                    .UseDefaultButtons(true)
                    .OnLoad("regConfirm"); %>
    <awe:Ocon runat="server" ID="InitPopupForm3" />

    <% Button3.Button().Text("Open popup").OnClick(Page.Awe().OpenPopup("confirmedPopup")); %>
    <awe:Ocon runat="server" ID="Button3" />

    <script>
        function regConfirm() {
            var $popup = this.d;
            var $form = $popup.find('form');
            $form.on('submit', function () {
                if (!$form.valid() || !confirm("Are you sure ?")) {
                    return false;
                }
            });
        }
    </script>
    <%--endcs--%>
    <div class="code tabs">
        <div data-caption="page"><%=Page.Source("PopupFormDemo.aspx", "cs") %></div>
    </div>
</div>
</asp:Content>