<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="Scheduler.aspx.cs" Inherits="AwesomeWebFormsDemo.Scheduler" %>
<%@ Import Namespace="Omu.AwemWebForms.Scheduler" %>
<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">
    <h2>Scheduler Demo</h2>

    Scheduler built using the awesome Grid, AjaxRadioList and PopupForm helpers.<br />
    <br />

    <% InitPopupForm1.InitPopupForm()
              .Name("createMeeting")
              .Group("scheduler")
              .Height(570)
              .Url(Page.Url().Action("Create", "SchedulerDemo"))
              .ParameterFunc("aweUtils.getMinutesOffset")
              .Success("aweUtils.refreshGrid('" + Schedule1.ClientID + "')"); %>
    <awe:Ocon runat="server" ID="InitPopupForm1" />

    <% InitPopupForm2.InitPopupForm()
              .Name("editMeeting")
              .Group("scheduler")
              .Height(570)
              .Url(Page.Url().Action("Edit", "SchedulerDemo"))
              .ParameterFunc("aweUtils.getMinutesOffset")
              .Success("aweUtils.refreshGrid('" + Schedule1.ClientID + "')"); %>
    <awe:Ocon runat="server" ID="InitPopupForm2" />

    <% InitPopupForm3.InitPopupForm()
              .Name("deleteMeeting")
              .Group("scheduler")
              .Height(200)
              .Url(Page.Url().Action("Delete", "SchedulerDemo"))
              .Success("aweUtils.refreshGrid('" + Schedule1.ClientID + "')"); %>
    <awe:Ocon runat="server" ID="InitPopupForm3" />

    <button type="button" class="awe-btn mbtn" onclick="awe.open('createMeeting')">Create</button>

    <div class="scheduler">
        <div class="schedBar">
            <div class="o-btng sbitem">
                <button type="button" class="awe-btn todaybtn">Today</button>
                <button type="button" class="awe-btn prevbtn"><i class="o-arw left"></i></button>
                <button type="button" class="awe-btn nextbtn"><i class="o-arw right"></i></button>
            </div>
            <div class="sbitem">
                <% Date.DatePicker().CssClass("schDate").HtmlAttributes(null, new { tabindex = -1 }); %>
                <awe:Ocon runat="server" ID="Date" />
                <span class="dateLabel"></span>
            </div>
            <div class="sbitem sbvtype">
                <% ViewType.AjaxRadioList()
                      .CssClass("viewType")
                      .ButtonGroup()
                      .Url(Page.Url().Action("GetViewTypes", "SchedulerDemo")); %>
                <awe:Ocon runat="server" ID="ViewType" />
            </div>
        </div>

        <% Schedule1.Grid()
                   .Height(430)
                   .Mod(o => o.Loading())
                   .ShowFooter(false)
                   .ShowGroupedColumn(false)
                   .RowClassClientFormat(".RowClass")
                   .CssClass("schedulerGrid")
                   .Url(Page.Url().Action("ScheduleGetItems", "SchedulerDemo"))
                   .Parent(ViewType.ClientID, "viewType")
                   .Parent(HoursType.ClientID, "hoursType")
                   .Parent(HourStep.ClientID, "hourStep")
                   .Parent(Date.ClientID, "date")
                   .ParameterFunc("aweUtils.getMinutesOffset"); %>
        <awe:Ocon runat="server" ID="Schedule1" />

        <div class="schedBotBar">
            <% HoursType.AjaxRadioList()
                      .Mod("awem.odropdown")
                      .Value(SchedulerHour.FullDay)
                      .Url(Page.Url().Action("GetHoursTypes", "SchedulerDemo")); %>
            <awe:Ocon runat="server" ID="HoursType" />

            <% HourStep.AjaxRadioList()
                      .Odropdown(o => o.InLabel("Step: "))
                      .Value(60)
                      .Url(Page.Url().Action("GetHourSteps", "SchedulerDemo")); %>
            <awe:Ocon runat="server" ID="HourStep" />
        </div>
    </div>
    <script src="<%:ResolveUrl("~/Scripts/scheduler.js") %>"></script>
    <script>
        $(function () {
            scheduler.init('<%=Schedule1.ClientID %>', 'Meeting'); // gridId, popupName (create|edit|delete + 'Meeting')
        });

        function buildCell(i) {
            return function (row) {
                var cell = row.Cells[i];
                if (!cell) return "";
                var result = "<div data-ticks='" + cell.Ticks + "' data-allday='" + row.AllDay + "' class='timePart' >";

                if (cell.Day) {
                    result += "<div class='awe-il'><span class='day' data-date='" + cell.Date + "'>" + cell.Day + "</span></div>";
                }

                if (cell.Events) {
                    $.each(cell.Events, function (index, value) {
                        var style = '';
                        if (value.Color) {
                            var color = 'fff';
                            var bcolor = value.Color.replace('#', '');

                            if (hexToVal(bcolor) > 530) {
                                color = darken(bcolor);
                            }

                            style = 'style="background-color:' + value.Color + '; color:#' + color + ';"';
                        }
                        result += '<div class="schEvent" data-id="' + value.Id + '" ' + style + '>'
                            + (value.Time ? '<div class="schTime">' + value.Time + '</div>' : "")
                            + '<button type="button" class="delEvent">&times;</button>'
                            + '<div class="eventTitle">' + value.Title + '</div>'
                            + '</div>';
                    });
                }

                result += '</div>';
                return result;
            };
        }

        function hexToVal(hex) {
            var r = parseInt(hex.substr(0, 2), 16),
                g = parseInt(hex.substr(2, 2), 16),
                b = parseInt(hex.substr(4, 2), 16);
            return r + g + b;
        }

        function darken(hex) {
            var r = parseInt(hex.substr(0, 2), 16),
                g = parseInt(hex.substr(2, 2), 16),
                b = parseInt(hex.substr(4, 2), 16);

            function f(c) {
                var h = Math.max(0, c - 170).toString(16);
                if (!h) h = '00';
                if (h.length == 1) h = '0' + h;
                return h;
            }

            return f(r) + f(g) + f(b);
        }
    </script>
</asp:Content>
