/* eslint-disable */
//import * as jQuery from 'jquery';
//import { sideMenu } from './sidemenu';
//import { awef, awe, aweui, aweUtils } from './aweui/all.js';
//import { cstorg } from './cstorg.js';

var site = function ($) {
    var encode = awef.encode;
    var menuApi;
    var root = './';
    var foodDir = 'Content/Pictures/Food/';

    function endsWith(src, str) {
        var lastIndex = src.lastIndexOf(str);
        return (lastIndex !== -1) && (lastIndex + str.length === src.length);
    }

    var cacheUrls = [
        '/GetAllMeals',
        '/GetMealsImg',
        '/GetMealsTreeImg',
        '/GetCategories',
        '/GetMealsGroupedImg',
        '/GetCountries',
        '/GetChefs'
    ];

    // setting global before get data,
    // if the helper's data url ends with one of the cacheUrls, set its dataFunc to get that url from cstorg (cache)
    awe.bfgd = function (o, data) {
        if (o.url && !o.dataFunc) {
            awef.loop(cacheUrls,
                function (u) {
                    if (endsWith(o.url.toUpperCase(), u.toUpperCase())) {
                        o.dataFunc = cstorg.getf(o.url);
                        return false;
                    }
                });
        }
    }

    function getRoot() {
        return awef.isNull(document.root) ? './' : document.root;
    }

    function documentReady() {
        root = getRoot();
        setupSideMenu();
        setupFmwPicker();

        layPage();
        $(window).on('resize', layPage);

        handleAnchors();

        $('#btnLogo').click(function (e) {
            if ($(window).width() < 1050) {
                e.preventDefault();
                $('#btnMenuToggle').trigger('click');
            }
        });

        $(document).on('click',
            '.mnitm',
            function (e) {
                var trg = $(e.target);
                if (!trg.is('a') && !trg.closest('.awe-cbc').length) {
                    var a = $(this).find('a').first();
                    if (a.length) a[0].click();
                }
            })
            .on('click', '.getFullSrc', function (e) {
                awe.open('getSrc1', {
                    setCont: function (sp, o) {
                        var cont = '<div style="padding:.5em;">Download this demo\'s solution zip archive: ';
                        cont += '<a href="https://www.aspnetawesome.com/Download/WebFormsDemoApp">AwesomeWebFormsDemo.zip (937 KB)</a><br/><br/>';
                        cont += '</div>'
                        o.scon.html(cont);
                    },
                    outClickClose: 1,
                    modal: 1,
                    dropdown: 1
                }, e);
            });

        $('#btnMenuToggle').click(function (ev) {
            menuToggle($('#demoMenu').is(':visible'), ev);
        });

        site.parseCode && site.parseCode();

        // for tab show
        $(document).on('aweshow', function (e) {
            $(e.target).find('pre').addClass('prettyprint');
            prettyPrint();
        });

        handleTabs();

        $('#chTheme').change(function () {
            var theme = $('#chTheme').val();
            $('#aweStyle').attr('href', root + "/Content/themes/" + theme + "/AwesomeMvc.css?v=" + document.ver);
            $('body').attr('class', theme);
            if (['black-cab', 'bts', 'met', 'val', 'start', 'gtx'].indexOf(theme) > -1) {
                $('body').addClass('dark');
            }

            if (['black-cab', 'gtx'].indexOf(theme) > -1) {
                $('body').addClass('vdark');
            }

            window.Cookies && Cookies.set(document.themeCookie, theme, { expires: 30 });
        });

        signalrSync.init();

        $(document).on('aweload', 'table.awe-ajaxlist', wrapLists);

        function layPage() {
            $("#main").css("min-height", ($(window).height() - 120) + "px");
            $('#maincont').css("min-height", $(window).height() - ($('#header').outerHeight() + 110)); 
            
            menuApi.setHeight();
        }
    }

    function setupFmwPicker() {
        $('#ddlFmw').on('change', function () {
            window.location.href = $(this).val();
        });
    }

    var sideMenAsPopupWinW = 1050;
    function setupSideMenu() {
        var px;
        $(window).on('mousemove', function (e) {
            px = e.pageX;
        });

        menuApi = sideMenu.build({
            id: 'Menu',
            src: 'msearch',
            keyupf: srckup,
            isSelected: function (item) {
                return item.Action == document.action && item.Controller == document.controller;
            },
            getHeight: function () {
                var pad = 70;
                if ($(window).width() < sideMenAsPopupWinW) pad = 110;
                return $(window).height() - $('#header').height() - pad;
            },
            scrollSync: true,
            cancelSync: function () {
                return px < $('#Menu').outerWidth() + 20;
            }
        });

        $('#Menu').data('api').load();

        function srckup() {
        }
    }

    function handleTabs() {
        function tabs(o) {
            var cont = o.elm;
            var sawetabs = 'awe-tabs';
            if (!cont.hasClass(sawetabs)) {
                cont.addClass(sawetabs);
                cont.children().wrapAll('<div class="awe-tabscontent"/>');

                $('<div class="awe-tabsbar"></div>').prependTo(cont);
                awe.tabs({ elm: cont });
            }
        }

        $('.tabs').each(function (_, item) {
            tabs({ elm: $(item) });
        });
    }

    function strim(str) {
        return (str || '').trim();
    }

    function getAnchorName(a) {
        var name = a.data('name');
        if (!name) name = strim(a.html()).replace(/ /g, '-').replace(/\(|\)|:|\.|\;|\\|\/|\?|,/g, '');
        name = name.replace('&lt', '').replace('&gt', '');
        return name;
    }

    function handleAnchors() {
        var anchor = window.location.hash.replace('#', '').replace(/\(|\)|:|\.|\;|\\|\/|\?|,/g, '');
        $('h3,h2').each(function (_, e) {
            var a = $(e);
            if (!a.data('ah')) {
                a.data('ah', 1);
                var name = a.data('name');
                var url = a.data('u') || '';
                if (!name) name = strim(a.html()).replace(/ /g, '-').replace(/\(|\)|:|\.|\;|\\|\/|\?|,/g, '');
                name = name.replace('&lt', '').replace('&gt', '').replace('\'', '');
                a.append("<a class='anchor' name='" + name + "' href='" + url + "#" + name + "' tabIndex='-1'>&nbsp;<i class='ico-link'></i></a>");

                if (name === anchor) {
                    window.location.href = "#" + name;
                    awe.flash(a);
                }
            }
        });
    }

    // wrap ajaxlists for horizontal scrolling on small screens
    function wrapLists() {
        $('table.awe-ajaxlist:not([wrapped])').each(function () {
            var columns = $(this).find('thead th').length;
            var mw = $(this).data('mw');
            if (columns || mw) {
                mw = mw || columns * 120;

                $(this).wrap('<div style="width:100%; overflow:auto;"></div>')
                    .wrap('<div style="min-width:' + mw + 'px;padding-bottom:2px;"></div>')
                    .attr('wrapped', 'wrapped');
            }
        });
    }
    
    function menuToggle(hide, ev) {
        var sideCont = $('#sideCont');
        var aside = $('aside');        
        var btn = $('#btnMenuToggle');
        var smallscreen = $(window).width() <= sideMenAsPopupWinW;

        if (hide) {            
            btn.removeClass('on').trigger('awedomlay');
            if (!smallscreen) {
                sideCont.hide();
            }

        } else {                        
            sideCont.show();
            menuApi.init();

            if (smallscreen) {     
                
                awe.open({
                    setCont: function (sp, o) {                        
                        o.scon.append(aside);                        
                        menuApi.setHeight();
                    },             
                    close: function () {
                        sideCont.append(aside);                        
                    },
                    dropdown: true,
                    outClickClose: true,
                    opener: $('#header'),
                    modal: true,
                    popupClass: 'sidePopup',
                    width: 200
                });
                return;
            }

            btn.addClass('on').trigger('awedomlay');
        }
    }

    function slide(popup) {
        var o = popup.data('o');
        var maxtop = $(window).height();
        var div = popup.closest('.o-pmc');

        o.nolay = 1;

        div.css('transform', 'translateY(' + maxtop + 'px)');

        setTimeout(function () {
            div.css('transition', '.5s');
            div.css('transform', 'translateY(0)');
            setTimeout(function () {
                o.nolay = 0;
                div.css('transition', '');
                div.css('transform', '');
                o.cx.api.lay();
            }, 500);
        }, 30);
    }

    function prettyPrint() {
        try {
            window.PR && PR.prettyPrint();
        } catch (ex) {
            //ignore
        }
    }


    return {
        openStngsMenu: function (event) {
            awe.open({
                setCont: function (sp, o) {                    
                    o.scon.append($('#settings'));                    
                },
                //modal: true,                
                close: function () {
                    var cont = $('#settings');
                    $('#settingsCont').append(cont);
                },
                dropdown: true
            }, event);
        },
        fmwData: function () {
            return [
                { k: "", c: "Go to demo:", nv: 1, cs: 'o-itm o-itmg o-nv' },
                { c: 'ASP.net Core/MVC', k: 'https://demo.aspnetawesome.com' },
                { c: 'Blazor', k: 'https://blazor.aspnetawesome.com/' },
                { c: 'Store Awesome (ASP.net Core, EF)', k: 'https://store.aspnetawesome.com' },
                { c: 'Angular demo', k: 'https://angular.aspnetawesome.com' },
                { c: 'ASP.net Web-Forms', k: 'https://demowf.aspnetawesome.com' },
                { c: 'aweui (Angular, React, Vue)', k: 'https://aweui.aspnetawesome.com' },                
                { c: 'ProDinner demo (ASP.net Core, EF)', k: 'https://prodinner.aspnetawesome.com' },
            ];
        },
        menuDataFunc: function (url) {
            var data;
            return function (sgp) {
                if (data) return sideMenu.getMenuGridFunc(data)(sgp);

                return $.when(cstorg.get(url)).then(function (res) {
                    data = res;
                    return sideMenu.getMenuGridFunc(data)(sgp);
                });
            }
        },
        itmTheme: function (itm) {
            var res = '<i class="theme-colors">';

            awef.loop(itm.colors, function (color) {
                res += '<i class="color-box" style="background-color: ' + color + '"></i>';
            });

            res += '</i>';

            return res + itm.k;
        },
        imgFood: function (itm) {
            var img = itm.FoodPic
                ? '<img alt="food" src="' + getRoot() + '/' + foodDir + itm.FoodPic + '" class="food" width="45" height="33" />'
                : '';

            return img + awef.encode(itm.FoodName);
        },
        imgFoodCaption: function (itm) {
            return '<img alt="food" class="cthumb" src="' + root + '/' + foodDir + itm.url + '" width="23" height="17" />' + awef.encode(itm.c);
        },
        imgFoodItem: function (itm) {
            return '<div class="o-igit"><img src="' + root + '/' + foodDir + itm.url + '"/>' + awef.encode(itm.c) + '</div>';
        },
        imgItem: function (itm) {
            return '<div class="o-igit">' +
                (itm.url ? '<img width="45" height="33" alt="item" src="' + itm.url + '"/>' : '')
                + awef.encode(itm.c) + '</div>';
        },
        documentReady: documentReady,
        getAnchorName: getAnchorName,
        handleAnchors: handleAnchors,
        handleTabs: handleTabs,
        slide: slide,
        getFormattedTime: function () {
            var d = new Date();
            return ('0' + d.getHours()).slice(-2) + ":" + ('0' + d.getMinutes()).slice(-2) + ":" + ('0' + d.getSeconds()).slice(-2);
        },
        getThemes: function () {
            return [
                { k: 'mat', colors: ['#fff', '#f3f6f9', '#3481e5'] },
                { k: 'start', colors: ['rgb(228 230 233)', '#e4e6e9', 'rgb(24, 119, 242)'] },
                { k: 'bts', colors: ['#fff', '#6c757d', '#007bff'] },
                { k: 'mui', colors: ['#fff', '#fff', '#26a69a'] },
                { k: 'gui3', colors: ['#F4F9F9', '#F8F8F8', '#4D90FE'] },
                { k: 'zen', colors: ['#c7c8ca', '#fff', '#333'] },
                { k: 'wui', colors: ['#fafafa', '#f8f8f8', '#f8f8f8'] },
                { k: 'gui', colors: ['#F0F2F2', '#FFD814', '#007185'] },
                { k: 'val', colors: ['#fdf5f7', '#e77f94', '#b383c7'] },
                { k: 'met', colors: ['#f7f7f7', '#36A9E1', '#75a532'] },
                { k: 'gtx', colors: ['rgb(17, 17, 17)', '#2d2d2d', '#76b900'] },
                { k: 'black-cab', colors: ['#586779', '#445869', '#3f88b1'] },
            ];
        },
        parseCode: function () {
            // show code 
            $('.code').each(function (i, el) {
                var codediv = $(el);
                var scbtn = $('<span class="shcode">show code</span>')
                    .click(function () {
                        var btn = $(this);
                        btn.toggleClass("hideCode showCode");
                        var parent = $(this).parent();
                        var div = parent.next();

                        div.find('.srccode').each(function () {
                            var d = $(this);
                            if (d.data('handled')) return;
                            d.data('handled', 1);
                            var name = d.data('name');

                            var backbtn = $('<button class="awe-btn backbtn" type="button">go back</button>').click(setMain);

                            d.append(strUtil.wrapCode(''));

                            var main = d.find('pre');

                            function setMain() {
                                var code = strUtil.getCode(name);
                                main.html(code).removeClass('prettyprinted');
                                prettyPrint();
                                backbtn.hide();
                            }

                            d.find('.codeWrap').prepend(backbtn);
                            setMain();
                        });

                        if (div.closest('.cbl').length) {
                            awe.open('showCode',
                                {
                                    setCont: function (sp, o) {
                                        o.scon.html(div);
                                        div.show();
                                    },
                                    close: function () {
                                        parent.after(div.hide());
                                    },
                                    modal: true,
                                    width: 900,
                                    outClickClose: true
                                });
                        }
                        else if (btn.hasClass("hideCode")) {
                            btn.html("hide code");
                            div.show();
                            site.parseCode();
                        } else {
                            btn.html("show code");
                            div.hide();
                        }
                    });

                var wrp = $('<div/>').append(scbtn).addClass('shcodew');
                codediv.wrap('<div/>')
                    .parent()
                    .hide()
                    .before(wrp);

                codediv.removeClass('code');
            });

            $('pre:visible').addClass('prettyprint');
            prettyPrint();
        },
        getDownloads: function () {
            return [
                { k: "https://www.aspnetawesome.com/Download/WebFormsDemoApp", c: "Main Demo - ASP.net Web-Forms (this demo)" },                
                { k: "https://www.aspnetawesome.com/Download/WebFormsMinSetupDemo", c: "Min Setup Demo - ASP.net Web-Forms (Template Project)" },                                
                { k: "https://www.aspnetawesome.com/Download/WebFormsTrial", c: "ASP.net Web-Forms Awesome lib trial (js/css/dll)" },                
                { c: '', cs: "o-litm", nv: 1 },  // horiz line
                { k: 'https://www.aspnetawesome.com/#All-Downloads', c: 'See All Downloads' },
            ];
        },
        loadWhenSeen: function (el, url, indx, callback) {
            var started = 0;
            if (!loadIfVis()) {
                $(window).on('scroll resize', loadIfVis);
            }

            function loadIfVis() {
                if (el.offset().top + el.outerHeight() < $(window).height() + $(window).scrollTop() + 300) {
                    if (started) return 1;
                    started = 1;

                    $(window).off('scroll resize', loadIfVis);

                    $.when(cstorg.get(url, { v: indx })).then(function (res) {
                        callback(res);
                        $(document).trigger('ajaxComplete');
                    });

                    return 1;
                }
            }
        },
        getSideMenuData: function (url) {
            var storageKey = awe.ppk + "_menuNodes";
            if (sessionStorage && sessionStorage[storageKey]) {
                return JSON.parse(sessionStorage[storageKey]);
            } else {
                return $.get(url).then(function (items) {
                    sessionStorage[storageKey] = JSON.stringify(items);
                    return items;
                });
            }
        },
        getCaretWord: function (el) {
            // textarea autocomplete 
            function getWordAtPos(s, pos) {
                var preText = s.substring(0, pos);
                if (preText.indexOf(" ") > 0 || preText.indexOf("\n") > 0) {
                    var words = preText.split(" ");
                    words = words[words.length - 1].split("\n");
                    return words[words.length - 1]; // return last word
                }
                else {
                    return preText;
                }
            }

            function getCaretPos(ctrl) {
                var caretPos = 0;
                if (document.selection) {
                    ctrl.trigger('focus');
                    var sel = document.selection.createRange();
                    sel.moveStart('character', -ctrl.value.length);
                    caretPos = sel.text.length;
                }
                else if (ctrl.selectionStart || ctrl.selectionStart === '0') {
                    caretPos = ctrl.selectionStart;
                }

                return caretPos;
            }

            var pos = getCaretPos(el);
            return getWordAtPos(el.value, pos);
        },
        replaceInTexarea: function (t, text, word) {
            if (t.setSelectionRange) {
                var sS = t.selectionStart - word.length;
                var sE = t.selectionEnd;
                t.value = t.value.substring(0, sS) + text + t.value.substr(sE);
                t.setSelectionRange(sS + text.length, sS + text.length);
                t.focus();
            }
            else if (t.createTextRange) {
                document.selection.createRange().text = text;
            }
        },
        gitCaption: function (item) {
            return '<img class="cthumb" src="' + encode(item.avatar) + '&s=40" />' + encode(item.c);
        },
        gitItem: function (item) {
            var res = "<div class='content'>" + '<div class="title">' + encode(item.c) + '<img class="thumb" src="' + encode(item.avatar) + '&s=40" />' + '</div>';
            if (item.desc) res += '<p class="desc">' + encode(item.desc) + '</p>';
            res += '</div>';
            return res;
        },
        gitRepoSearch: function (o, info) {
            var term = info.term;
            var c = info.cache;
            c.termsUsed = c.termsUsed || {};
            c.nrterms = c.nrterms || []; // no result terms

            if (c.termsUsed[term]) return [];
            c.termsUsed[term] = 1;

            var nores = 0;
            // don't search terms that contain nrterms
            $.each(c.nrterms, function (i, val) {
                if (term.indexOf(val) >= 0) {
                    nores = 1;
                    return false;
                }
            });

            if (nores) {
                return [];
            }

            return $.get('https://api.github.com/search/repositories', { q: term })
                .then(function (data) {
                    if (!data || !data.items.length) {
                        c.nrterms.push(term);
                    }

                    return $.map(data.items, function (item) { return { k: item.id, c: item.full_name, avatar: item.owner.avatar_url, desc: item.description }; });
                })
                .fail(function () { c.termsUsed[term] = 0; });
        },
    };
}(jQuery);

//export {site};