﻿<%@ Page Title="Home" MasterPageFile="~/Site.Master" Language="C#" AutoEventWireup="true" CodeBehind="TreeGrid.aspx.cs" Inherits="AwesomeWebFormsDemo.TreeGrid" %>

<asp:Content ID="Content1" ContentPlaceHolderID="ContentPlaceHolder1" runat="server">

    <h2>Tree Grid Demo</h2>
    Tree grid is achieved by setting the GridModelBuilder.GetChildren,
    this function should return an IQueryable&lt;T&gt; when the item is a node, or an Awe.Lazy when its a lazy node.
    For lazy loading GetItem also needs to be set, it will be executed in the lazy request, GetItem is also used by the api.updateItem.
    In the constructor of the GridModelBuilder only root items are set.

    <h3>Tree grid, basic features</h3>
    simple tree grid, without lazy loading
    <%--begin1--%>
    <% TreeGrid1.Grid()
      .Url(Page.Url().Action("SimpleTree", "TreeGrid"))
      .Columns(
          new Column { Bind = "Name" },
          new Column { Bind = "Id", Width = 100 })
      .Persistence(Persistence.View)
      .Groupable(false)
      .PageSize(3)
      .Height(400); %>
    <awe:Ocon runat="server" ID="TreeGrid1" />
    <%--end1--%>

    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("TreeGrid.aspx", 1) %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Grid/TreeGridController.cs", 1) %></div>
    </div>

    <h3>Lazy loading Nodes, Tree Grid</h3>
    <%--begin2--%>
    <% LazyTreeGrid.Grid()
      .Url(Page.Url().Action("LazyTree", "TreeGrid"))
      .Columns(
          new Column { Bind = "Name" },
          new Column { Bind = "Id", Width = 100 })
      .Persistence(Persistence.View)
      .PageSize(3)
      .Height(400); %>
    <awe:Ocon runat="server" ID="LazyTreeGrid" />
    <%--end2--%>

    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("TreeGrid.aspx", 2) %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Grid/TreeGridController.cs", 2) %></div>
    </div>

    <h3>Tree Grid with CRUD operations</h3>

    <%--begin3--%>
    <% var crudgrid = CrudTreeGrid.ClientID; %>

    <%:Page.InitCrudPopupsForGrid(crudgrid, "TreeGrid", 200,
    cfg: (opt, act) =>
    {
        if (act == "create")
        {
            opt.OnSuccess = "nodeCreated";
        }
    }) %>   

<script>
    // needed to handle crud when search criteria is present
    // (e.g. if you add a child and update the node it might not show up because of the search criteria)
    var nodesAdded = [];
    $(function () {
        $('#<%=crudgrid %>').on('aweload', function () {
            nodesAdded = [];
        });
    });

    function nodeCreated(res) {
        var grid = $('#<%=crudgrid %>');
        var api = grid.data('api');

        nodesAdded.push(res.Node.Id);

        // update parent if present of reload the grid with empty sorting and grouping rules
        if (res.ParentId) {
            var xhr = api.update(res.ParentId, { nodesAdded: nodesAdded });
            $.when(xhr).done(function () {
                if (res.Node) {
                    awe.flash(api.select(res.Node.Id)[0]);
                }
            });
        } else {
            var row = api.renderRow(res.Node, 1);// render row as lvl 1 (root)
            grid.find('.awe-content .awe-itc').prepend(row);
        }
    }
</script>

    <div class="bar">
        <button type="button" class="awe-btn mbtn" style="float: left;" onclick="awe.open('create<%=crudgrid %>')">add root</button>
        <div style="text-align: right;">
            <% Txtname.TextBox().Placeholder("search...").CssClass("searchtxt"); %>
            <awe:Ocon runat="server" ID="Txtname" />
        </div>
    </div>

    <% CrudTreeGrid.Grid()
             .Url(Page.Url().Action("CrudTree", "TreeGrid"))
             .Columns(
                 new Column { Bind = "Name" },
                 new Column { Bind = "Id", Width = 100 },
                 new Column { ClientFormat = GridUtils.AddChildFormat(crudgrid), Width = 120 },
                 new Column { ClientFormat = GridUtils.EditFormatForGrid(crudgrid), Width = GridUtils.EditBtnWidth },
                 new Column { ClientFormat = GridUtils.DeleteFormatForGrid(crudgrid), Width = GridUtils.DeleteBtnWidth })
             .Reorderable()
             .Resizable()
             .PageSize(3)
             .Parent(Txtname.ClientID, "name")
             .Height(400); %>
    <awe:Ocon runat="server" ID="CrudTreeGrid" />
    <%--end3--%>

    <div class="tabs code">
        <div data-caption="page"><%=Page.Source("TreeGrid.aspx", 3) %></div>
        <div data-caption="controller"><%=Page.Csource("Demos/Grid/TreeGridController.cs", 3) %></div>
    </div>

    <h3>Use as TreeView</h3>
    The menu on the left is a TreeGrid with hidden footer and header. You can see the code for it in the Site.Master of this demo.
</asp:Content>