using System.Web.Configuration;
using System.Web.Mvc;
using System.Web.Script.Serialization;
using System.Web.UI;

namespace AwesomeWebFormsDemo.Utils
{
    public static class AUtil
    {
        public static string ServerMapPath(this HtmlHelper html)
        {
            return html.ViewContext.HttpContext.Server.MapPath(@"~\");
        }        

        public static string ServerMapPath(this Page page)
        {
            return page.MapPath(@"~\");
        }

        public static string CssDir()
        {
            return "~/Content/";
        }

        public static string JsDir()
        {
            return "~/Scripts/";
        }

        public static string JsonEncode(object o)
        {
            return new JavaScriptSerializer().Serialize(o);
        }

        public static bool IsDev()
        {
            var compilationSection = (CompilationSection)System.Configuration.ConfigurationManager.GetSection(@"system.web/compilation");
            return compilationSection.Debug;
        }
    }
}