using System;
using System.Collections.Generic;
using AwesomeWebFormsDemo.ViewModels.Attributes;
using Omu.AwesomeWebForms;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;

namespace AwesomeWebFormsDemo.ViewModels.Input
{
    public class DinnerInput
    {
        public int? Id { get; set; }

        [Required]
        [StringLength(50, MinimumLength = 3)]
        public string Name { get; set; }

        [Required]
        public DateTime? Date { get; set; }

        [UIHint("MultiLookup")]
        [Required]
        [CollectionMaxLen(7)]
        [DisplayName("Meals")]
        [MultiLookup(Controller = "MealsMultiLookup")]
        public IEnumerable<int> MealsIds { get; set; }

        [UIHint("Lookup")]
        [Required]
        [DisplayName("Chef")]
        [Lookup(Controller = "ChefLookup")]
        public int? ChefId { get; set; }

        [Required]
        [UIHint("DropdownList")]
        [AweUrl(Action = "GetAllMeals", Controller = "Data")]
        [DisplayName("Bonus meal")]
        public int? BonusMealId { get; set; }

        public bool? Organic { get; set; }
    }
}