using Microsoft.AspNetCore.Mvc;
using AweuiAspCore.Models;
using System.Linq;

namespace AweuiAspCore.Controllers.Awesome
{
    public class DataController : Controller
    {
        public ActionResult GetMenuNodes()
        {
            var menuNodes =
                MySiteMap.GetAll().Select(
                    o =>
                    new
                    {
                        o.Id,
                        o.Name,
                        o.Keywords,
                        ParentId = o.Parent?.Id,
                        Url = o.Action != null ? Url.Action(o.Action, o.Controller) + o.Anchor : null,
                        o.Action,
                        o.Controller,
                        o.Collapsed,
                        o.NoMenu,
                        o.Anchor
                    });

            return Json(menuNodes);
        }

        public ActionResult GetLunches()
        {
            return Json(Db.Lunches.Take(200).Select(o => new
            {
                o.Id,
                o.Person,
                o.Food,
                FoodName = o.Food,
                o.FoodPic,
                o.Location,
                CountryName = o.Country.Name,
                ChefName = o.Chef.FirstName + " " + o.Chef.LastName,
                o.Date,
                o.Date.Year,
                DateStr = o.Date.ToShortDateString(),
                Meals = o.Meals.Select(m => new { m.Id, m.Name }),
                MealsStr = string.Join(", ", o.Meals.Select(m => m.Name))
            }));
        }
    }
}