//import { awef, awem, aweUtils, aweui } from '../aweui/all.js';

var formBuilder = function (opt) {
    var model = opt.model;
    var funcs = [];
    var prefix = '';

    if (opt.sp) {
        var prm = aweUtils.getParams(opt.sp);
        if (prm.__aweconid) {
            prefix = prm.__aweconid;
        }
    }

    var fields = [];

    return {
        id: function (idstr) {
            return prefix + idstr;
        },
        str: function (s) {
            fields.push(s);
        },
        add: function (o) {
            var val = model[o.prop];
            var name = o.prop;
            var label = o.label || name;
            var id = o.id || prefix + name;
            var inpcls = o.inpcls || '';
            var inptype = 'hidden';

            var finput = function () {
                return '<input type="' + inptype + '" id="' + id + '" name="' + name + '" value="' + val + '"/>';
            };

            if (o.func === aweui.datepicker) {
                inptype = 'text';
            }

            if (awef.isNotNull(val)) {
                if (val instanceof Date) {
                    val = awem.dateToStr(val);
                } else if (val instanceof Array) {
                    val = JSON.stringify(val);
                }
            } else {
                val = '';
            }

            var fieldStr = '';

            if (o.hidden) {
                inptype = 'hidden';
                fieldStr += finput();
            } else {
                fieldStr += '<div class="efield">';
                fieldStr += '<div class="elabel"><label>' + label + '</label></div>\n';
                fieldStr += '<div class="einput ' + inpcls + '">' +
                    finput() +
                    '<div class="evldmsg"><span vld-for="' + name + '"></span></div></div>';
                fieldStr += '</div>';
            }

            fields.push(fieldStr);

            if (o.func) {
                var opt = o.opt || {};
                opt.id = id;
                funcs.push({ f: o.func, opt: opt });
            }
        },
        applyToPopup: function (o) {
            var res = '';
            var area = '';
            awef.loop(fields, function (fld, i) {

                area += fld;
                if (i > 0 && i % 4 == 0 || fields.length == i + 1) {
                    res += '<div class="earea">' + area + '</div>';
                    area = '';

                }
            });

            o.scon.html('<form><div class="eform">' + res + '</div></form>');

            awef.loop(funcs,
                function (fo) {
                    fo.f(fo.opt);
                });
        }
    };
};

//export { formBuilder };