using System.Linq;
using System.Threading.Tasks;
using Core.Model;
using Data;
using Microsoft.EntityFrameworkCore;

namespace Service
{
    public class ChefService
    {
        private readonly ProDbContext cx;

        public ChefService(ProDbContext cx)
        {
            this.cx = cx;
        }

        public async Task<Chef> GetFullAsync(int id)
        {
            return await GetFullQuery().SingleAsync(o => o.Id == id);
        }

        public IQueryable<Chef> GetFullQuery(bool showDeleted = false)
        {
            IQueryable<Chef> res = cx.Set<Chef>()
                .Include(o => o.Country);

            if (!showDeleted)
            {
                res = res.Where(o => o.IsDeleted == false);
            }

            return res;
        }
    }
}