using System.Linq;
using System.Threading.Tasks;
using Core.Model;
using Data;
using Microsoft.EntityFrameworkCore;

namespace Service
{
    public class DinnerService
    {
        private readonly ProDbContext cx;

        public DinnerService(ProDbContext cx)
        {
            this.cx = cx;
        }

        public async Task<Dinner> GetFullAsync(int id)
        {
            return await GetFullQuery(true).SingleAsync(o => o.Id == id);
        }

        public IQueryable<Dinner> GetFullQuery(bool showDeleted = false)
        {
            IQueryable<Dinner> res = cx.Set<Dinner>()
                .Include(o => o.Chef)
                .Include(o => o.Country)
                .Include(o => o.DinnerMeals).ThenInclude(o => o.Meal);

            if (!showDeleted)
            {
                res = res.Where(o => o.IsDeleted == false);
            }

            return res;
        }
    }
}