using System.Drawing;
using System.IO;
using System.Threading.Tasks;
using Service.Infra;

namespace Service
{
    public class MealService
    {
        private const string MealsPath = "meals";
        public const string TempPath = "upload";

        public async Task SetPicture(string rootPath, string newFilName, string oldFileName)
        {
            void Action()
            {
                if (!string.IsNullOrWhiteSpace(oldFileName))
                {
                    DeleteImages(rootPath, oldFileName);
                }

                TempImgToMeals(rootPath, newFilName);
            }

            await ExecUtil.Try(Action);
        }

        private void DeleteImages(string root, string filename)
        {
            var dirPath = Path.Combine(root, MealsPath);
            File.Delete(Path.Combine(dirPath, filename));
            File.Delete(Path.Combine(dirPath, "s" + filename));
            File.Delete(Path.Combine(dirPath, "m" + filename));
        }

        private void TempImgToMeals(string rootPath, string newFileName)
        {
            var tempImgPath = Path.Combine(rootPath, TempPath, newFileName);
            using (var tempImg = Image.FromFile(tempImgPath))
            {
                var fullMealsPath = Path.Combine(rootPath, MealsPath);

                var small = Imager.Resize(tempImg, 100, 75, true);
                var mini = Imager.Resize(tempImg, 45, 34, true);

                Imager.SaveJpeg(Path.Combine(fullMealsPath, newFileName), tempImg);
                Imager.SaveJpeg(Path.Combine(fullMealsPath, "s" + newFileName), small);
                Imager.SaveJpeg(Path.Combine(fullMealsPath, "m" + newFileName), mini);
            }

            File.Delete(tempImgPath);
        }
    }
}