using System;
using System.Diagnostics;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;

namespace WebUI.Controllers
{
    public class HomeController : Controller
    {
        public IActionResult Index()
        {
            return View();
        }

        public IActionResult About()
        {
            return PartialView();
        }

        public ActionResult Social()
        {
            return PartialView();
        }

        [HttpPost]
        public IActionResult ChangeTheme(string theme)
        {
            Response.Cookies.Append("theme", theme);
            return Ok();
        }

        [HttpPost]
        public ActionResult RemCookMsg()
        {
            var cname = "CookieMsg";
            var cookies = Request.Cookies;
            if (!cookies.ContainsKey(cname))
            {
                Response.Cookies.Append(cname, "", new CookieOptions
                {
                    Expires = DateTime.Now.AddYears(1),
                });
            }

            return Ok();
        }

    }
}