using Microsoft.AspNetCore.Builder;
using Microsoft.AspNetCore.Localization;
using System.Collections.Generic;
using System.Globalization;

namespace WebUI.Utils
{
    public static class AppCultureSettings
    {
        public static string[] SupportedCulturesArr
        {
            get => new string[] { "it", "en", "fr", "de", "ro", "ru", "es" };
        }

        public static IList<CultureInfo> SupportedCultures
        {
            get => new List<CultureInfo>
            {
                new CultureInfo("en"),
                new CultureInfo("fr"),
                new CultureInfo("it"),
                new CultureInfo("es"),
                new CultureInfo("de"),
                new CultureInfo("ro"),
                new CultureInfo("ru"),
            };
        }

        public static RequestLocalizationOptions ReqLocOpt => new RequestLocalizationOptions
        {
            DefaultRequestCulture = new RequestCulture("en"),
            // Formatting numbers, dates, etc.
            SupportedCultures = SupportedCultures,
            // UI strings that we have localized.
            SupportedUICultures = SupportedCultures
        };

        public static void ConfigureReqLocOpt(RequestLocalizationOptions opts)
        {
            opts.DefaultRequestCulture = new RequestCulture("en");
            // Formatting numbers, dates, etc.
            opts.SupportedCultures = SupportedCultures;
            // UI strings that we have localized.
            opts.SupportedUICultures = SupportedCultures;
        }
    }
}