using Newtonsoft.Json;
using Omu.AwesomeMvc;

namespace WebUI.Utils
{
    public class CacheKeyGen
    {
        public static string New(string name, params object[] coll)
        {
            var res = name;

            for (var i = 0; i < coll.Length; i++)
            {
                var obj = coll[i];

                if (obj == null) continue;

                if (obj is GridParams gp)
                {
                    obj = new
                    {
                        gp.SortNames, 
                        gp.SortDirections, 
                        gp.Page,
                        gp.PageSize,
                        gp.Groups,
                        gp.Paging,
                        gp.PgsBef
                    };
                }

                res += i + "=" + JsonConvert.SerializeObject(obj);
            }

            return name + res;
        }
    }
}