using System;
using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using Omu.AwesomeMvc;
using WebUI.Utils;
using WebUI.ViewModels.Attributes;

namespace WebUI.ViewModels.Input
{
    public class DinnerInput : Input
    {
        [Required(ErrorMessage = StrConst.FieldRequired)]
        [StrLen(50)]
        [DisplayName("Name")]
        public string Name { get; set; }

        [Required(ErrorMessage = StrConst.FieldRequired)]
        [UIHint("LookupCountry")]
        [DisplayName("Country")]
        public int? CountryId { get; set; }

        [Required(ErrorMessage = StrConst.FieldRequired)]
        [UIHint("DropdownList")]
        [AweUrl(Controller = "Data", Action = "GetAllChefs")]
        [DisplayName("Chef")]
        public int? ChefId { get; set; }

        [Required(ErrorMessage = StrConst.FieldRequired)]
        [StrLen(20)]
        [DisplayName("Address")]
        public string Address { get; set; }

        [Required(ErrorMessage = StrConst.FieldRequired)]
        [DisplayName("Start")]
        public DateTime? Start { get; set; }

        [Required(ErrorMessage = StrConst.FieldRequired)]
        [CollectionMaxLen(10)]
        [UIHint("MealsMultiLookup")]        
        [DisplayName("Meals")]        
        public int[] Meals { get; set; }

        [Required(ErrorMessage = StrConst.FieldRequired)]
        [UIHint("TimePicker")]
        [DisplayName("Time")]
        public DateTime? Time { get; set; }

        [Required(ErrorMessage = StrConst.FieldRequired)]
        [Range(10, 120)]
        [UIHint("Duration")]
        [AweMeta("Step", 5)]
        [AweMeta("Min", 10)]
        [AweMeta("Max", 120)]
        [DisplayName("Duration")]
        public int Duration { get; set; }
    }
}