using System.ComponentModel;
using System.ComponentModel.DataAnnotations;
using WebUI.Utils;
using WebUI.ViewModels.Attributes;

namespace WebUI.ViewModels.Input
{
    public class UserCreateInput : UserEditInput
    {
        [StrLen(15)]
        [Required(ErrorMessage = StrConst.FieldRequired)]
        public string Login { get; set; }

        [StrLen(20)]
        [Required(ErrorMessage = StrConst.FieldRequired)]
        [UIHint("Password")]
        public string Password { get; set; }

        [StrLen(20)]
        [Required(ErrorMessage = StrConst.FieldRequired)]
        [UIHint("Password")]
        [DisplayName("Confirm Password")]
        public string ConfirmPassword { get; set; }
    }
}