var proUtils = function ($) {
    var dict = site.dict;
    return {
        duration: function (hourw, hoursw, minw) {
            return function (val) {
                var mval = parseInt(val, 10);
                if (isNaN(mval)) return val;
                var hour = Math.floor(mval / 60);
                var minute = mval % 60;
                var res = "";
                if (hour > 0)
                    res += hour + " " + (hour > 1 ? hoursw : hourw) + " ";
                if (minute > 0)
                    res += minute + " " + minw;

                return res;
            };
        },
        inlDelRes: function (gridId) {
            return function (model) {
                var inlCancel = '<button type="button" class="awe-btn o-glcanb awe-nonselect o-gl o-glbtn">' + dict('Cancel') + '</button>';
                return inlCancel + proUtils.delRes(gridId)(model);
            }
        },
        delRes: function (gridId) {
            return function (model) {
                var del = '<button aria-label="delete" type="button" class="awe-btn awe-nonselect delbtn o-glh" onclick="awe.open(\'delete' + gridId + '\', { params: { id: ' + model.id + '}})" >' +
                    '<span class="ico-crud ico-del"></span></button>';

                var restore = '<button aria-label="restore" type="button" class="awe-btn delbtn o-glh" onclick="proUtils.restore(\'' + gridId + '\', ' + model.id + ')" >' +
                    '<span class="ico-crud ico-restore"></span></button>';
                return model.isDeleted ? restore : del;
            }
        },
        restore: function (gridId, id) {
            $.when(awe.oc('restore' + gridId, { params: { id: id } }))
                .done(function (res) {
                    return $('#' + gridId).data('api').update(res.id);
                });
        },
        dinnerItem: function (o) {
            var api = o.api;

            // render item (row)
            api.itmf = function (opt) {
                var content = '';
                // content already set (group header)
                if (opt.con) {
                    content = opt.con;
                } else {
                    // get column value
                    function val(col, cls) {
                        return aweUtils.gcvw(api, col, opt, cls);
                    }

                    var itm = opt.itm;

                    var meals = '';
                    awef.loop(itm.mealsPics,
                        function (pic) {
                            meals +=
                                '<img src="' + site.mealsUrl + 's' + (pic || '0.jpg') + '" class="sthumb" alt=' + itm.name + ' width=100 height=75 />';
                        });

                    content +=
                        '<div class="fr">' + val(aweUtils.columnById(o, 'del')) + '</div>' +
                        '<div class="fl">' + itm.name + ' - ' + itm.chefName + '</div>' +
                        '<br class="cbt" />' +
                        meals +
                        '<br class="cbt" />' +
                        '<div class="fl">' + itm.countryName + ' ' + itm.address + '</div>' +
                        '<div class="fr">' + val(aweUtils.columnById(o, 'edit')) + '</div>' +
                        '<div class="fr" style="margin-right: 1em;">' + itm.start + ' - ' + itm.end + '</div>' +
                        '<br class="cbt" />';
                }

                // has collapse button
                if (opt.ceb) {
                    opt.clss += ' dinnerHead';
                    opt.style += 'margin-left:' + opt.ind + 'em;';
                } else {
                    opt.clss += ' dinnerItem';
                }

                var attr = opt.attr;
                attr += ' class="' + opt.clss + '"';
                opt.style && (attr += ' style="' + opt.style + '"');

                return '<div ' + attr + '>' + content + '</div>';
            };

            // ignore columns width for grid content
            o.syncon = 0;

            // no alt rows
            o.alt = 0;
        },
        inlineMeal: function (o) {
            var api = o.api;

            // render item (row)
            api.itmf = function (opt) {
                var content = '';
                // content already set (group header)
                if (opt.con) {
                    content = opt.con;
                } else {
                    // get column value
                    function val(col, cls) {
                        return aweUtils.gcvw(api, col, opt, cls);
                    }

                    function field(col, cls) {
                        var label = '';
                        if (col.H) {
                            label = '<div class="elabel">' + col.H + ':</div> ';
                        }

                        return '<div class="efield">' + label + '<div class="einput">' + val(col, cls) + '</div></div>';
                    }

                    function hid(col) {
                        return '<div style="display:none;">' + val(col) + '</div>';
                    }

                    content +=
                        hid(aweUtils.columnByBind(o, 'id')) +
                        val(aweUtils.columnById(o, 'picture'), 'inl') +
                        '<div class="mealItemMain">' +
                        field(aweUtils.columnByBind(o, 'name')) +

                        // o-gl => visible only when in inline edit mode
                        "<button type='button' class='awe-btn changePic o-gl'>" + dict('ChangePicture') + "</button>" +
                        '</div><br/>' +
                        field(aweUtils.columnByBind(o, 'comments'), 'cardComm') +
                        '<div class="inlbtns">' +
                        val(aweUtils.columnById(o, 'edit'), 'inl') +
                        val(aweUtils.columnById(o, 'del'), 'inl') +
                        '</div>';
                }


                // has collapse button
                if (opt.ceb) {
                    opt.clss += ' cardhead';
                    opt.style += 'margin-left:' + opt.ind + 'em;';
                } else {
                    opt.clss += ' edcard';
                }

                var attr = opt.attr;
                attr += ' class="' + opt.clss + '"';
                opt.style && (attr += ' style="' + opt.style + '"');

                return '<div ' + attr + '>' + content + '</div>';
            };

            // ignore columns width for grid content
            o.syncon = 0;

            // no alt rows
            o.alt = 0;
        }
    };
}(jQuery);