use master
go
--kill all connections to Db
--you might get "Only user processes can be killed." it's ok
DECLARE @dbname sysname
SET @dbname = 'ostore'
DECLARE @spid int
SELECT @spid = min(spid) from master.dbo.sysprocesses where dbid = db_id(@dbname)
WHILE @spid IS NOT NULL
BEGIN
EXECUTE ('KILL ' + @spid)
SELECT @spid = min(spid) from master.dbo.sysprocesses where dbid = db_id(@dbname) AND spid > @spid
END
go
--recreate the database
drop database ostore
go
create database ostore
go
use ostore
go

create table appInfos(
id int primary key,
productsListVersion int not null default(0)
)

create table users(
id int identity primary key,
login nvarchar(100) unique not null,
password nvarchar(100) not null
)

create table contactusMessages(
id int identity primary key,
email nvarchar(100) not null,
message nvarchar(700) not null,
dateCreated datetime not null,
isRead bit default(0) not null
)

create table products(
id int identity primary key,
name nvarchar(120) not null,
description nvarchar(max),
picture nvarchar(250),
price smallmoney,
version int default(1) not null,
priority int default(0) not null,
isActive bit default(0) not null,
isDeleted bit default(0) not null,
richDescription nvarchar(max)
)

create table orders(
id int identity primary key,
firstName nvarchar(50) not null,
lastName nvarchar(50) not null,
email nvarchar(100) not null,
streetAddress nvarchar(200) not null,
city nvarchar(100) not null,
state nvarchar(2) not null,
zipCode nvarchar(10) not null,
subtotal smallmoney not null,
datecreated datetime not null
)

create table orderItems(
id int identity primary key,
orderId int  not null references orders(id) on delete cascade,
productId int not null references products(id),
quantity int not null,
unitPrice smallmoney not null
)

-- delete from users
-- insert users(login, password) values('admin', '2CKZQuTrOvRGAi289cVCho3wULSjeXZaddB9A9/yqxI=')

USE [ostore]
GO
SET IDENTITY_INSERT [dbo].[products] ON 
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (1, N'Pain au chocolat Chocolatine', N'French pastries with chocolate', N'[{"Name":"5.jpg"},{"Name":"7.jpg"}]', 100.0000, 0, 1, 10, 13, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (2, N'Croissant', N'Croissant, made with flour, butter', N'[{"Name":"3.jpg"},{"Name":"4.jpg"}]', 120.0000, 0, 1, 6, 11, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (3, N'broccoli soup', N'pro style broccoli soup', N'[{"Name":"2.jpg"},{"Name":"3.jpg"},{"Name":"4.jpg"}]', 30.0000, 0, 1, 7, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (4, N'Banana', N'yellow fruit', N'[{"Name":"3.jpg"},{"Name":"6.jpg"},{"Name":"11.jpg"},{"Name":"15.jpg"},{"Name":"17.jpg"},{"Name":"25.jpg"}]', 27.0000, 0, 1, 30, 14, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (5, N'Organic Pineapple', N'Fresh Organic Pineapple', N'[{"Name":"3.jpg"},{"Name":"9.jpg"},{"Name":"7.jpg"}]', 35.0000, 0, 1, 13, 14, N'{"type":"cont","children":[{"type":"text","text":"pineapple are good"},{"type":"img","opt":{"name":"9.jpg"}},{"type":"htmlyt","text":"<iframe width=\"560\" height=\"315\" src=\"https://www.youtube.com/embed/xItrxEfb0rE?si=3lvjcUBAZvxB4J1M\" title=\"YouTube video player\" frameborder=\"0\" allow=\"accelerometer; autoplay; clipboard-write; encrypted-media; gyroscope; picture-in-picture; web-share\" allowfullscreen></iframe>"}]}')
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (6, N'Macarons Cookies Gourmet Chocolate Desserts', N'With just a hint of tart in the middle, this flavor combines a sweet buttercream filling with a house-made raspberry jelly center.', N'[{"Name":"3.jpg"},{"Name":"4.jpg"},{"Name":"5.jpg"}]', 370.0000, 0, 1, 12, 13, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (7, N'Whole Grain Pasta Thin Spaghetti', N'WHOLE GRAIN DURUM WHEAT FLOUR', N'[{"Name":"3.jpg"},{"Name":"4.jpg"}]', 230.0000, 0, 1, 5, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (8, N'Organic Mango, No Sugar Added, No Preservatives, Al-Natural, Premium Quality', N'USDA Organic products are grown and processed according to standards addressing soil and water quality, among other factors.', N'[{"Name":"11.jpg"},{"Name":"4.jpg"},{"Name":"5.jpg"}]', 1500.0000, 0, 1, 19, 11, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (9, N'Broccoli Crowns Conventional', N'Broccoli Crowns', N'[{"Name":"3.jpg"},{"Name":"4.jpg"}]', 25.0000, 0, 1, 7, -5, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (10, N'Sun Dried Tomatoes Halves in Olive Oil', N'In the new tradition of healthy eating we use premium ingredients from the bounty of California including extra virgin olive oil, premium California tomatoes ripened in the sun, and authentic seasonings to create healthy Mediterranean inspired products. Sun Dried Tomato Halves in 100% Olive Oil are Mediterranean diet approved, Kosher, vegan, and Non GMO. Enjoy a true Italian kitchen staple perfect for pasta, pizza, sandwiches, salads, charcuterie, appetizers, and more!', N'[{"Name":"6.jpg"},{"Name":"7.jpg"}]', 300.0000, 0, 1, 21, 11, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (11, N'Salad tomato cucumber lettuce radish', N'very nice salad', N'[{"Name":"2.jpg"},{"Name":"3.jpg"},{"Name":"4.jpg"}]', 159.0000, 0, 1, 7, 13, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (12, N'Market French Baguette', N'baguette de pain', N'[{"Name":"2.jpg"},{"Name":"11.jpg"}]', 500.0000, 0, 1, 18, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (13, N'Cantaloupe Melon', N'Fresh Cantaloupe, yellow melon', N'[{"Name":"8.jpg"},{"Name":"9.jpg"}]', 320.0000, 0, 1, 10, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (14, N'Crimson Sweet Heirloom Watermelon', N'green, red on the inside,
It is One of the Most Popular Heirloom Watermelons.', N'[{"Name":"2.jpg"},{"Name":"5.jpg"},{"Name":"6.jpg"}]', 280.0000, 0, 1, 8, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (15, N'Orange Juice Homestyle Some Pulp', N'juice made from oranges', N'[{"Name":"158.jpg"},{"Name":"160.jpg"},{"Name":"161.jpg"}]', 5.0000, 0, 1, 164, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (16, N'Strawberries red berry fruit organic fresh', N'awesome qweq asda qweqw asda', N'[{"Name":"4.jpg"},{"Name":"5.jpg"},{"Name":"6.jpg"}]', 35.0000, 0, 1, 9, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (17, N'Coconut Water with Pulp | Plant Based | Non-GMO | No Added Sugar | Essential Electrolytes', N'Coconut Water is an excellent way to conquer thirst naturally. Packed with electrolytes and great taste, our coconut water is perfect for hydrating and restoring balance to your daily routine.', N'[{"Name":"4.jpg"},{"Name":"5.jpg"},{"Name":"6.jpg"},{"Name":"8.jpg"}]', 102.1200, 0, 1, 9, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (18, N'Green Olives', N'Organic green olives', N'[{"Name":"7.jpg"},{"Name":"5.jpg"}]', 1231.0000, 0, 1, 15, 14, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (19, N'Artichoke Marinated - Natural and Delicious on Salads, Pizzas & More', N'Marinated Quartered Artichoke Heart. 
Perfect Choice Artichoke Heart elevates an ordinary meal to something truly exceptional.', N'[{"Name":"4.jpg"},{"Name":"3.jpg"}]', 79.5000, 0, 1, 11, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (20, N'Red Organic Raspberries', N'red organic raspberries', N'[{"Name":"5.jpg"},{"Name":"3.jpg"}]', 50.0000, 0, 1, 12, 15, N'{"type":"cont","children":[{"type":"img","opt":{"name":"5.jpg"}}]}')
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (21, N'Cherry Red Conventional', N'Cherries', N'[{"Name":"3.jpg"},{"Name":"6.jpg"}]', 33.0000, 0, 1, 12, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (22, N'Peaches fresh organic', N'Peaches', N'[{"Name":"6.jpg"},{"Name":"3.jpg"},{"Name":"17.jpg"}]', 52.0000, 0, 1, 33, 15, N'{"type":"cont","children":[{"type":"richText","text":"<h2></h2><h2><img src=\"/pictures/Products/22/17.jpg\" style=\"float: right;\" class=\"note-float-right\"></h2><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">The&nbsp;<b>peach</b>&nbsp;(<i>Prunus persica</i>) is a&nbsp;<a href=\"https://en.wikipedia.org/wiki/Deciduous\" title=\"Deciduous\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">deciduous</a>&nbsp;<a href=\"https://en.wikipedia.org/wiki/Tree\" title=\"Tree\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">tree</a>&nbsp;first&nbsp;<a href=\"https://en.wikipedia.org/wiki/Domesticated\" class=\"mw-redirect\" title=\"Domesticated\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">domesticated</a>&nbsp;and&nbsp;<a href=\"https://en.wikipedia.org/wiki/Agriculture\" title=\"Agriculture\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">cultivated</a>&nbsp;in&nbsp;<a href=\"https://en.wikipedia.org/wiki/Zhejiang\" title=\"Zhejiang\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Zhejiang province</a>&nbsp;of&nbsp;<a href=\"https://en.wikipedia.org/wiki/East_China\" title=\"East China\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Eastern China</a>.<sup id=\"cite_ref-YangZheng20142_3-0\" class=\"reference\" style=\"line-height: 1; unicode-bidi: isolate; text-wrap: nowrap; font-size: 11.2px;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-YangZheng20142-3\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[3]</a></sup>&nbsp;It bears edible juicy&nbsp;<a href=\"https://en.wikipedia.org/wiki/Fruit\" title=\"Fruit\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">fruits</a>&nbsp;with various characteristics, most called&nbsp;<b>peaches</b>&nbsp;and others (the glossy-skinned, non-fuzzy varieties),&nbsp;<b>nectarines</b>.</p><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">The specific name&nbsp;<i>persica</i>&nbsp;refers to its widespread cultivation in&nbsp;<a href=\"https://en.wikipedia.org/wiki/Persia\" class=\"mw-redirect\" title=\"Persia\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Persia</a>&nbsp;(modern-day Iran), from where it was transplanted to Europe and in the 16th century to the Americas. It belongs to the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Genus\" title=\"Genus\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">genus</a>&nbsp;<i><a href=\"https://en.wikipedia.org/wiki/Prunus\" title=\"Prunus\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Prunus</a></i>, which includes the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Cherry\" title=\"Cherry\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">cherry</a>,&nbsp;<a href=\"https://en.wikipedia.org/wiki/Apricot\" title=\"Apricot\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">apricot</a>,&nbsp;<a href=\"https://en.wikipedia.org/wiki/Almond\" title=\"Almond\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">almond</a>, and&nbsp;<a href=\"https://en.wikipedia.org/wiki/Plum\" title=\"Plum\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">plum</a>, in the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Rosaceae\" title=\"Rosaceae\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">rose family</a>. The peach is classified with the almond in the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Subgenus\" title=\"Subgenus\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">subgenus</a>&nbsp;<i><a href=\"https://en.wikipedia.org/wiki/Amygdalus\" class=\"mw-redirect\" title=\"Amygdalus\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Amygdalus</a></i>, distinguished from the other subgenera by the corrugated seed shell (<a href=\"https://en.wikipedia.org/wiki/Endocarp\" class=\"mw-redirect\" title=\"Endocarp\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">endocarp</a>).<sup id=\"cite_ref-4\" class=\"reference\" style=\"line-height: 1; unicode-bidi: isolate; text-wrap: nowrap; font-size: 11.2px;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-4\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[4]</a></sup>&nbsp;Due to their close relatedness, the kernel of a peach stone tastes remarkably similar to almond, and peach stones are often used to make a cheap version of&nbsp;<a href=\"https://en.wikipedia.org/wiki/Marzipan\" title=\"Marzipan\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">marzipan</a>, known as&nbsp;<a href=\"https://en.wikipedia.org/wiki/Persipan\" title=\"Persipan\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">persipan</a>.<sup id=\"cite_ref-5\" class=\"reference\" style=\"line-height: 1; unicode-bidi: isolate; text-wrap: nowrap; font-size: 11.2px;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-5\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[5]</a></sup></p>"},{"type":"richText","text":"<h2 linux=\"\" libertine\",=\"\" georgia,=\"\" times,=\"\" \"source=\"\" serif=\"\" pro\",=\"\" serif;=\"\" line-height:=\"\" 1.375;\"=\"\" style=\"font-family: &quot;Helvetica Neue&quot;, Helvetica, Arial, sans-serif; color: rgb(0, 0, 0); font-size: 1.5em; margin: 0.25em 0px; padding-top: 0.5em; padding-bottom: 0.17em; overflow: hidden; border-bottom: 1px solid rgb(162, 169, 177);\"><span class=\"mw-headline\" id=\"History\">History</span></h2><figure class=\"mw-default-size\" typeof=\"mw:File/Thumb\" style=\"display: table; margin-top: 0.5em; margin-bottom: 1.3em; margin-left: 1.4em; text-align: center; border-collapse: collapse; line-height: 0; clear: right; float: right; border-width: 1px 1px 0px; border-top-style: solid; border-right-style: solid; border-left-style: solid; border-top-color: rgb(200, 204, 209); border-right-color: rgb(200, 204, 209); border-left-color: rgb(200, 204, 209); border-image: initial; border-bottom-style: initial; border-bottom-color: initial; background-color: rgb(248, 249, 250); min-width: 100px; color: rgb(32, 33, 34); font-family: sans-serif;\"><a href=\"https://en.wikipedia.org/wiki/File:Dried_date,_peach,_apricot,_and_stones._From_Lahun,_Fayum,_Egypt._Late_Middle_Kingdom._The_Petrie_Museum_of_Egyptian_Archaeology,_London.jpg\" class=\"mw-file-description\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word; display: block; border: 0px;\"><img src=\"https://upload.wikimedia.org/wikipedia/commons/thumb/9/9e/Dried_date%2C_peach%2C_apricot%2C_and_stones._From_Lahun%2C_Fayum%2C_Egypt._Late_Middle_Kingdom._The_Petrie_Museum_of_Egyptian_Archaeology%2C_London.jpg/220px-Dried_date%2C_peach%2C_apricot%2C_and_stones._From_Lahun%2C_Fayum%2C_Egypt._Late_Middle_Kingdom._The_Petrie_Museum_of_Egyptian_Archaeology%2C_London.jpg\" decoding=\"async\" width=\"220\" height=\"159\" class=\"mw-file-element\" srcset=\"//upload.wikimedia.org/wikipedia/commons/thumb/9/9e/Dried_date%2C_peach%2C_apricot%2C_and_stones._From_Lahun%2C_Fayum%2C_Egypt._Late_Middle_Kingdom._The_Petrie_Museum_of_Egyptian_Archaeology%2C_London.jpg/330px-Dried_date%2C_peach%2C_apricot%2C_and_stones._From_Lahun%2C_Fayum%2C_Egypt._Late_Middle_Kingdom._The_Petrie_Museum_of_Egyptian_Archaeology%2C_London.jpg 1.5x, //upload.wikimedia.org/wikipedia/commons/thumb/9/9e/Dried_date%2C_peach%2C_apricot%2C_and_stones._From_Lahun%2C_Fayum%2C_Egypt._Late_Middle_Kingdom._The_Petrie_Museum_of_Egyptian_Archaeology%2C_London.jpg/440px-Dried_date%2C_peach%2C_apricot%2C_and_stones._From_Lahun%2C_Fayum%2C_Egypt._Late_Middle_Kingdom._The_Petrie_Museum_of_Egyptian_Archaeology%2C_London.jpg 2x\" data-file-width=\"4471\" data-file-height=\"3235\" style=\"margin: 3px; border-width: 1px; border-style: solid; border-color: rgb(200, 204, 209); background-image: initial; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial;\"></a><figcaption style=\"display: table-caption; caption-side: bottom; line-height: 1.4em; word-break: break-word; text-align: left; padding: 0px 6px 6px; border-width: 0px 1px 1px; border-right-style: solid; border-bottom-style: solid; border-left-style: solid; border-right-color: rgb(200, 204, 209); border-bottom-color: rgb(200, 204, 209); border-left-color: rgb(200, 204, 209); border-image: initial; border-top-style: initial; border-top-color: initial; font-size: 12.376px;\">Dried date, peach, apricot, and stones from Lahun, Fayum, Egypt, Late Middle Kingdom,&nbsp;<a href=\"https://en.wikipedia.org/wiki/Petrie_Museum_of_Egyptian_Archaeology\" title=\"Petrie Museum of Egyptian Archaeology\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Petrie Museum of Egyptian Archaeology</a>, London</figcaption></figure><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">Although its botanical name&nbsp;<i>Prunus persica</i>&nbsp;refers to Persia, genetic studies suggest peaches originated in China,<sup id=\"cite_ref-14\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-14\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[14]</a></sup>&nbsp;where they have been&nbsp;<a href=\"https://en.wikipedia.org/wiki/Peach_production_in_China\" title=\"Peach production in China\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">cultivated since the Neolithic period</a>. Until recently, cultivation was believed to have started around 2000 BC.<sup id=\"cite_ref-15\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-15\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[15]</a></sup><sup id=\"cite_ref-vau09-82_16-0\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-vau09-82-16\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[16]</a></sup>&nbsp;More recent evidence indicates that domestication occurred as early as 6000 BC in&nbsp;<a href=\"https://en.wikipedia.org/wiki/Zhejiang_Province\" class=\"mw-redirect\" title=\"Zhejiang Province\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Zhejiang Province</a>&nbsp;of China. The oldest archaeological peach stones are from the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Kuahuqiao\" class=\"mw-redirect\" title=\"Kuahuqiao\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Kuahuqiao</a>&nbsp;site near&nbsp;<a href=\"https://en.wikipedia.org/wiki/Hangzhou\" title=\"Hangzhou\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Hangzhou</a>. Archaeologists point to the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Yangtze_River_Valley\" class=\"mw-redirect\" title=\"Yangtze River Valley\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Yangtze River Valley</a>&nbsp;as the place where the early selection for favorable peach varieties probably took place.<sup id=\"cite_ref-YangZheng20142_3-1\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-YangZheng20142-3\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[3]</a></sup>&nbsp;Peaches were mentioned in Chinese writings and literature beginning from the early first millennium BC.<sup id=\"cite_ref-Layne_17-0\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-Layne-17\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[17]</a></sup></p><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">A domesticated peach appeared very early in Japan, in 4700–4400 BC, during the&nbsp;<a href=\"https://en.wikipedia.org/wiki/J%C5%8Dmon_period\" title=\"Jōmon period\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Jōmon period</a>. It was already similar to modern cultivated forms, where the peach stones are significantly larger and more compressed than earlier stones. This domesticated type of peach was brought into Japan from China. Nevertheless, in China itself, this variety is currently attested only at a later date around 3300 to 2300 BC.<sup id=\"cite_ref-YangZheng2014_18-0\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-YangZheng2014-18\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[18]</a></sup></p><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">In India, the peach first appeared by about 1700 BC, during the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Indus_Valley_civilisation\" class=\"mw-redirect\" title=\"Indus Valley civilisation\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Harappan period</a>.<sup id=\"cite_ref-19\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-19\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[19]</a></sup></p><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">It is also found elsewhere in&nbsp;<a href=\"https://en.wikipedia.org/wiki/West_Asia\" title=\"West Asia\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">West Asia</a>&nbsp;in ancient times.<sup id=\"cite_ref-Ensminger_20-0\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-Ensminger-20\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[20]</a></sup>&nbsp;Peach cultivation reached Greece by 300 BC.<sup id=\"cite_ref-vau09-82_16-1\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-vau09-82-16\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[16]</a></sup>&nbsp;Alexander the Great is sometimes said to have introduced them into Greece after conquering Persia,<sup id=\"cite_ref-Ensminger_20-1\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-Ensminger-20\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[20]</a></sup>&nbsp;but no historical evidence for this claim has been found.<sup id=\"cite_ref-Davidson_21-0\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-Davidson-21\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[21]</a></sup>&nbsp;Peaches were, however, well known to the Romans in the first century AD;<sup id=\"cite_ref-vau09-82_16-2\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-vau09-82-16\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[16]</a></sup>&nbsp;the oldest known artistic representations of the fruit are in two fragments of wall paintings, dated to the first century AD, in&nbsp;<a href=\"https://en.wikipedia.org/wiki/Herculaneum\" title=\"Herculaneum\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Herculaneum</a>, preserved due to the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Vesuvius\" class=\"mw-redirect\" title=\"Vesuvius\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Vesuvius</a>&nbsp;eruption of 79 AD, and now held in the National Archaeological Museum in Naples.<sup id=\"cite_ref-22\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-22\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[22]</a></sup>&nbsp;Archaeological finds show that peaches were cultivated widely in Roman northwestern Continental Europe, but production collapsed around the sixth century; some revival of production followed with the&nbsp;<a href=\"https://en.wikipedia.org/wiki/Carolingian_Renaissance\" title=\"Carolingian Renaissance\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Carolingian Renaissance</a>&nbsp;of the ninth century.<sup id=\"cite_ref-23\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-23\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[23]</a></sup></p><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">An article on peach tree cultivation in Spain is brought down in&nbsp;<a href=\"https://en.wikipedia.org/wiki/Ibn_al-%27Awwam\" title=\"Ibn al-''Awwam\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Ibn al-''Awwam</a>''s 12th-century agricultural work,&nbsp;<i>Book on Agriculture</i>.<sup id=\"cite_ref-24\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-24\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[24]</a></sup>&nbsp;The peach was brought to the Americas by Spanish explorers in the 16th century, and eventually made it to England and France in the 17th century, where it was a prized and expensive treat.&nbsp;<a href=\"https://en.wikipedia.org/wiki/Horticulturist\" class=\"mw-redirect\" title=\"Horticulturist\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Horticulturist</a>&nbsp;George Minifie supposedly brought the first peaches from England to its North American colonies in the early 17th century, planting them at his estate of Buckland in Virginia.<sup id=\"cite_ref-25\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-25\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[25]</a></sup>&nbsp;Although Thomas Jefferson had peach trees at Monticello, American farmers did not begin commercial production until the 19th century in Maryland, Delaware, Georgia, South Carolina, and finally Virginia.<sup id=\"cite_ref-26\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-26\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[26]</a></sup></p><p style=\"margin-top: 0.5em; margin-bottom: 0px; padding-bottom: 0.5em; color: rgb(32, 33, 34); font-family: sans-serif;\">The Shanghai honey nectar peach was a key component of both the food culture and agrarian economy the area where the modern megacity of&nbsp;<a href=\"https://en.wikipedia.org/wiki/Shanghai\" title=\"Shanghai\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">Shanghai</a>&nbsp;stands. Peaches were the cornerstone of early Shanghai''s garden culture. As modernization and westernization swept through the city the Shanghai honey nectar peach nearly disappeared completely. Much of modern Shanghai is built over these gardens and peach orchards.<sup id=\"cite_ref-27\" class=\"reference\" style=\"font-size: 11.2px; line-height: 1; unicode-bidi: isolate; text-wrap: nowrap;\"><a href=\"https://en.wikipedia.org/wiki/Peach#cite_note-27\" style=\"color: rgb(51, 102, 204); background-image: none; background-position: initial; background-size: initial; background-repeat: initial; background-attachment: initial; background-origin: initial; background-clip: initial; overflow-wrap: break-word;\">[27]</a></sup></p>"},{"type":"text","text":"The scientific name persica, along with the word \"peach\" itself – and its cognates in many European languages – derives from an early European belief that peaches were native to Persia (modern-day Iran). The Ancient Romans referred to the peach as malum persicum (\"Persian apple\"), later becoming French pêche, whence the English \"peach\".[12] The scientific name, Prunus persica, literally means \"Persian plum\", as it is closely related to the plum."}]}')
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (23, N'Orchard Organic Persimmons', N'Persimmons', N'[{"Name":"3.jpg"},{"Name":"4.jpg"}]', 75.0000, 0, 1, 11, 10, NULL)
GO
INSERT [dbo].[products] ([id], [name], [description], [picture], [price], [isdeleted], [isActive], [version], [priority], [richDescription]) VALUES (24, N'fruits', N'fruits', NULL, 123.9900, 0, 1, 5, 0, NULL)
GO
SET IDENTITY_INSERT [dbo].[products] OFF
GO
SET IDENTITY_INSERT [dbo].[orders] ON 
GO
INSERT [dbo].[orders] ([id], [firstName], [lastName], [email], [streetAddress], [city], [state], [zipCode], [subtotal], [datecreated]) VALUES (2, N'Art', N'Vandelay', N'art@example.com', N'Pasadena 12', N'Burbank', N'CA', N'209232', 16108.3200, CAST(N'2024-02-07T08:59:35.267' AS DateTime))
GO
INSERT [dbo].[orders] ([id], [firstName], [lastName], [email], [streetAddress], [city], [state], [zipCode], [subtotal], [datecreated]) VALUES (3, N'Elaine', N'Benace', N'ela@aol.com', N'5th ave', N'New York', N'NY', N'121345', 7590.0000, CAST(N'2024-02-17T12:36:07.830' AS DateTime))
GO
INSERT [dbo].[orders] ([id], [firstName], [lastName], [email], [streetAddress], [city], [state], [zipCode], [subtotal], [datecreated]) VALUES (4, N'Art', N'Corvelay', N'acorv@aol.com', N'Import str. 5', N'New York', N'NY', N'112345', 21169.0000, CAST(N'2024-02-17T13:34:07.377' AS DateTime))
GO
SET IDENTITY_INSERT [dbo].[orders] OFF
GO
SET IDENTITY_INSERT [dbo].[orderItems] ON 
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (12, 2, 16, 10, 35.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (13, 2, 6, 1, 370.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (14, 2, 5, 14, 35.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (15, 2, 17, 11, 102.1200)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (16, 2, 13, 2, 320.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (17, 2, 15, 5, 5.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (18, 2, 14, 1, 280.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (19, 2, 8, 4, 1500.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (20, 2, 12, 13, 500.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (21, 2, 1, 1, 100.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (22, 2, 7, 1, 230.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (23, 3, 18, 5, 1231.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (24, 3, 22, 7, 55.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (25, 3, 5, 30, 35.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (26, 4, 11, 7, 159.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (27, 4, 22, 2, 55.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (28, 4, 18, 16, 1231.0000)
GO
INSERT [dbo].[orderItems] ([id], [orderId], [productId], [quantity], [unitPrice]) VALUES (29, 4, 20, 5, 50.0000)
GO
SET IDENTITY_INSERT [dbo].[orderItems] OFF
GO
INSERT [dbo].[appInfos] ([id], [productsListVersion]) VALUES (1, 10)
GO
SET IDENTITY_INSERT [dbo].[contactusMessages] ON 
GO
INSERT [dbo].[contactusMessages] ([id], [email], [message], [dateCreated], [isRead]) VALUES (1, N'adfaf@asdfadsf.com', N'asljas dljas ldjiowq eoiquwe oiquwe oqweo ioweq iweioq we<br/>asd asd jaslk d', CAST(N'2024-02-12T09:20:51.553' AS DateTime), 1)
GO
INSERT [dbo].[contactusMessages] ([id], [email], [message], [dateCreated], [isRead]) VALUES (2, N'fasfaf@asdfasfd.com', N'as qwe qwe qweq weqwe qwe qwe q', CAST(N'2024-02-12T15:08:26.963' AS DateTime), 1)
GO
INSERT [dbo].[contactusMessages] ([id], [email], [message], [dateCreated], [isRead]) VALUES (3, N'adasadasd@asdfaf.com', N'asdada qweqw eqwe qwe qweqwe qwe qweq weqwe qwe q qweq weq weq', CAST(N'2024-02-12T18:19:32.190' AS DateTime), 1)
GO
INSERT [dbo].[contactusMessages] ([id], [email], [message], [dateCreated], [isRead]) VALUES (4, N'asdasdads@aadfas.com', N'qwe qwe qweq weq w asdasdasd as dasd', CAST(N'2024-02-12T19:15:24.670' AS DateTime), 1)
GO
SET IDENTITY_INSERT [dbo].[contactusMessages] OFF
GO
SET IDENTITY_INSERT [dbo].[users] ON 
GO
INSERT [dbo].[users] ([id], [login], [password]) VALUES (5, N'admin', N'eqYo8Yq+HmJeEGMKQzQWv7yHY38+Yqmxjo+uB56w8yI=')
GO
SET IDENTITY_INSERT [dbo].[users] OFF
GO
