namespace Omu.StoreAwesome.WebUI.Core.Data
{
    public static class MemDb
    {
        public record State
        {
            public State(string abbr, string name)
            {
                Abbreviation = abbr;
                Name = name;
            }

            public string Abbreviation { get; set; }

            public string Name { get; set; }
        }

        public static string GetStateName(string abbreviation)
        {
            return States.Where(o => o.Abbreviation == abbreviation).First().Name;
        }

        public static readonly List<State> States = new List<State> {
            new State("AL", "Alabama"),
            new State("AK", "Alaska"),
            new State("AZ", "Arizona"),
            new State("AR", "Arkansas"),
            new State("CA", "California"),
            new State("CO", "Colorado"),
            new State("CT", "Connecticut"),
            new State("DC", "District of Columbia"),
            new State("DE", "Delaware"),
            new State("FL", "Florida"),
            new State("GA", "Georgia"),
            new State("HI", "Hawaii"),
            new State("ID", "Idaho"),
            new State("IL", "Illinois"),
            new State("IN", "Indiana"),
            new State("IA", "Iowa"),
            new State("KS", "Kansas"),
            new State("KY", "Kentucky"),
            new State("LA", "Louisiana"),
            new State("ME", "Maine"),
            new State("MD", "Maryland"),
            new State("MA", "Massachusetts"),
            new State("MI", "Michigan"),
            new State("MN", "Minnesota"),
            new State("MS", "Mississippi"),
            new State("MO", "Missouri"),
            new State("MT", "Montana"),
            new State("NE", "Nebraska"),
            new State("NV", "Nevada"),
            new State("NH", "New Hampshire"),
            new State("NJ", "New Jersey"),
            new State("NM", "New Mexico"),
            new State("NY", "New York"),
            new State("NC", "North Carolina"),
            new State("ND", "North Dakota"),
            new State("OH", "Ohio"),
            new State("OK", "Oklahoma"),
            new State("OR", "Oregon"),
            new State("PA", "Pennsylvania"),
            new State("RI", "Rhode Island"),
            new State("SC", "South Carolina"),
            new State("SD", "South Dakota"),
            new State("TN", "Tennessee"),
            new State("TX", "Texas"),
            new State("UT", "Utah"),
            new State("VT", "Vermont"),
            new State("VA", "Virginia"),
            new State("WA", "Washington"),
            new State("WV", "West Virginia"),
            new State("WI", "Wisconsin"),
            new State("WY", "Wyoming"),
            new State("AS", "American Samoa"),
            new State("GU", "Guam"),
            new State("MP", "Northern Mariana Islands"),
            new State("PR", "Puerto Rico"),
            new State("UM", "United States Minor Outlying Islands"),
            new State("VI", "Virgin Islands")
      };
    }
}