using Microsoft.EntityFrameworkCore;
using MongoDB.EntityFrameworkCore.Extensions;
using Omu.StoreAwesome.WebUI.Core.Model;

namespace Omu.StoreAwesome.WebUI.Core.Data.Mongo
{
    public class MongoDbContext : DbContext
    {
        public DbSet<Product> Products { get; init; }

        public DbSet<AppInfo> AppInfos { get; init; }

        public DbSet<Order> Orders { get; init; }

        public DbSet<OrderItem> OrderItems { get; init; }

        public DbSet<ContactUsMessage> ContactUsMessages { get; init; }

        public DbSet<User> Users { get; init; }

        public MongoDbContext(DbContextOptions<MongoDbContext> options)
            : base(options)
        {
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            base.OnModelCreating(modelBuilder);

            modelBuilder.Entity<Product>().ToCollection("Products");
            modelBuilder.Entity<AppInfo>().ToCollection("AppInfos");
            modelBuilder.Entity<ContactUsMessage>().ToCollection("ContactUsMessages");
            modelBuilder.Entity<OrderItem>().ToCollection("OrderItems");
            modelBuilder.Entity<User>().ToCollection("Users");
        }
    }
}