using Microsoft.EntityFrameworkCore;
using Omu.StoreAwesome.WebUI.Core.Model;

namespace Omu.StoreAwesome.WebUI.Core.Data
{
    public class SqlDbContext : DbContext
    {
        public SqlDbContext(DbContextOptions<SqlDbContext> dbContextOptions) : base(dbContextOptions)
        {
        }

        protected override void OnModelCreating(ModelBuilder modelBuilder)
        {
            base.OnModelCreating(modelBuilder);
        }

        public IQueryable<Product> ActiveProducts => Products.Where(o => o.IsActive);

        public DbSet<Product> Products { get; set; }

        public DbSet<Order> Orders { get; set; }

        public DbSet<OrderItem> OrderItems { get; set; }

        public DbSet<ContactUsMessage> ContactUsMessages { get; set; }

        public DbSet<User> Users { get; set; }

        public DbSet<AppInfo> AppInfos { get; set; }
    }
}