using Microsoft.EntityFrameworkCore;
using MongoDB.Driver;
using Omu.StoreAwesome.WebUI.Core.Model;

namespace Omu.StoreAwesome.WebUI.Core.Repo
{
    public class AppInfoRepo : IAppInfoRepo
    {
        private readonly GenericBaseRepo<AppInfo> repo;

        public AppInfoRepo(GenericBaseRepo<AppInfo> repo)
        {
            this.repo = repo;
        }

        public async Task<AppInfo> GetAsync()
        {
            var appInfo = await repo.GetAll().FirstOrDefaultAsync();
            return appInfo ?? new AppInfo();
        }

        public async Task<AppInfo> IncProductsListVersion()
        {
            var appInfo = await repo.GetAll().FirstOrDefaultAsync();

            if (appInfo == null)
            {
                appInfo = new AppInfo() { Id = 1 };
                appInfo = await repo.AddAsync(appInfo);
            }

            appInfo = await repo.UpdateAsync(1, ai =>
            {
                ai.ProductsListVersion++;
            });

            return appInfo;
        }
    }
}