using Microsoft.EntityFrameworkCore;
using Omu.StoreAwesome.WebUI.Core.Model;
using Omu.StoreAwesome.WebUI.Utils;

namespace Omu.StoreAwesome.WebUI.Core.Repo
{
    public class ProdRepo
    {
        protected virtual DbContext DbCx { get; set; }

        public virtual async Task<IEnumerable<Product>> GetProductsByWords(string[] words)
        {
            var coll = DbCx.Set<Product>().AsQueryable();
            var res = await coll.FilterByWordsAnd(p => p.Name, words).ToArrayAsync();

            return res;
        }
    }
}