using Microsoft.AspNetCore.Html;
using Microsoft.AspNetCore.Mvc.Rendering;
using Microsoft.AspNetCore.Mvc.Routing;
using Microsoft.AspNetCore.Mvc;

namespace Omu.StoreAwesome.WebUI.Helpers
{
    public static class CookieHelpers
    {
        private static IUrlHelper GetUrlHelper(IHtmlHelper html)
        {
            return ((IUrlHelperFactory)html.ViewContext.HttpContext.RequestServices
                .GetRequiredService(typeof(IUrlHelperFactory)))
                .GetUrlHelper(html.ViewContext);
        }

        public static IHtmlContent CookieMsg(this IHtmlHelper html)
        {
            var url = GetUrlHelper(html);
            var result = string.Empty;

            var cname = "CookieMsg";

            var cookies = html.ViewContext.HttpContext.Request.Cookies;

            if (!cookies.ContainsKey(cname))
            {
                var cpUrl = "https://www.aspnetawesome.com/Company/CookiePolicy";
                var ppUrl = "https://www.aspnetawesome.com/Company/PrivacyPolicy";

                var mainMsg = @"By accessing this site, you agree to store cookies on your device and disclose information in accordance with our ";
                result +=
                "<div id=\"cookieMsg\">" +
                mainMsg +
                $"<a href='{cpUrl}'>cookie policy</a> and <a href='{ppUrl}'>privacy policy</a>. " +
                "<button type=\"button\" class=\"awe-btn\" id=\"btnCookie\">OK</button></div>" +
                "<script>$(function () {$('#btnCookie').click(function () {" +
                "$('#cookieMsg').hide();awe.ajx('" + url.Action("RemCookMsg", "Company") + "');});});</script>";
            }

            return new HtmlString(result);
        }
    }
}