namespace Omu.StoreAwesome.WebUI.Models
{
    public static class AdminSiteMap
    {
        private static readonly IList<SiteMapItem> items = new List<SiteMapItem>();

        public static IEnumerable<SiteMapItem> GetAll()
        {
            var panel = new SiteMapItem { Action = "Panel", Controller = "Admin", Name = "Admin Panel", RenderOnlyWhenInChain = true };
            var advanced = new SiteMapItem { Action = "Advanced", Controller = "Admin", Name = "Advanced", Parent = panel };
            var products = new SiteMapItem { Action = "Index", Controller = "AdminProducts", Parent = panel, Name = "Products" };
            var orders = new SiteMapItem { Action = "Index", Controller = "AdminOrders", Parent = panel, Name = "Orders" };
            var contactUsMsg = new SiteMapItem { Action = "Index", Controller = "AdminContactUsMessages", Parent = panel, Name = "Contact us messages" };
            var logs = new SiteMapItem { Action = "Index", Controller = "AdminLogs", Parent = panel, Name = "Application logs" };
            
            items.Add(advanced);
            items.Add(panel);
            items.Add(products);
            items.Add(orders);
            items.Add(contactUsMsg);
            items.Add(logs);

            items.Add(new SiteMapItem { Action = "Edit", Controller = "AdminProducts", Parent = products, Name = "Product Details", IsText = true });
            items.Add(new SiteMapItem { Action = "Pictures", Controller = "AdminProducts", Parent = products, Name = "Product Pictures", IsText = true });
            items.Add(new SiteMapItem { Action = "RichDescription", Controller = "AdminProducts", Parent = products, Name = "Product Rich Text Description", IsText = true });
            items.Add(new SiteMapItem { Action = "Add", Controller = "AdminProducts", Parent = products, Name = "Add Product", IsText = true });

            return items;
        }
    }
}