var aweGridRender = function ($) {
    function prodUrl(item, k, page) {        
        var res = "/" + item.UrlName + "/prod/" + item.Id;
        var qs = '';

        if (k) {
            qs += '?k=' + k;
        }

        if (page && page > 1) {
            qs += qs ? '&' : '?';
            qs += 'page=' + page;
        }

        return res + qs;
    }

    function prodPrice(item) {
        var res = '<div class="a-price"><span class="a-price-symbol">$</span><span class="a-price-whole">' +
            item.Pricew + '</span><span class="a-price-fraction">' +
            item.Pricef + '</span></div>';
        return res;
    }
    
    return {
        productItem: function (o) {
            var api = o.api;

            // render item (row)
            api.itmf = function (opt) {
                var page = site.resPage;
                var keyword = site.resKeyword;                

                var content = '';
                // content already set (group header)
                if (opt.con) {
                    content = opt.con;
                } else {
                    var item = opt.itm;
                    content +=
                        '<a class="prodImga" href="' + prodUrl(item, keyword, page) + '">'
                        + (item.Picture ? '<img src="/pictures/Products/' + item.Picture + '" alt="' + item.Name + '" />' : '') +
                        '</a><div class="prodDetail">' +
                        '<h2 class="prodName"><a class="prodLink" href="' + prodUrl(item, keyword, page) + '">'
                        + item.Name +
                        '</a></h2>' +
                        prodPrice(item) + '</div>';
                }

                // has collapse button
                if (opt.ceb) {
                } else {
                    opt.clss += ' prodItem';
                }

                var attr = opt.attr;
                attr += ' class="' + opt.clss + '"';
                opt.style && (attr += ' style="' + opt.style + '"');

                return '<div ' + attr + '>' + content + '</div>';
            };

            // ignore columns width for grid content
            o.syncon = 0;

            // no alt rows
            o.alt = 0;
        },

        cartItem: function (o) {
            var api = o.api;

            // render item (row)
            api.itmf = function (opt) {
                var content = '';

                // find column by Bind
                var colByBind = aweUtils.columnByBind;

                // get column value
                function val(col, cls) {
                    return aweUtils.gcvw(api, col, opt, cls);
                }

                var item = opt.itm;

                var colPic = colByBind(o, 'Picture');

                if (item.Removed) {
                    content += "<div><span class='crtItmName'>" + item.Name + "</span> has been removed from your cart because it isn't available at this moment.</div>";
                }
                else if (item.Price) {
                    content += "<div class='crtImg'>" + val(colPic) + "</div>" +

                        "<div><p><a class='crtItmName' href='" + prodUrl(item) + "'>" +
                        item.Name + "</a></p>" +
                        "<p class='crtItmSmallPrice'> $" + item.Price + "</p>" +
                        "<div class='crtActions'> <div>Qty:</div><div>" + val(colByBind(o, 'Quantity')) + "</div>" +
                        "<i class='separator'>|</i><button type='button' class='awe-btn crtDel'>Delete</button>" +
                        "</div>" +

                        "</div>" +

                        "<div class='crtItmPrice'> $" + item.PriceStr + "</div>";
                    opt.clss += ' cartItem';
                }
                else {
                    // footer
                    content += item.Total;
                    opt.clss += ' crtTotal';
                }

                var attr = opt.attr;
                attr += ' class="' + opt.clss + '"';
                opt.style && (attr += ' style="' + opt.style + '"');

                return '<div ' + attr + '>' + content + '</div>';
            };

            // ignore columns width for grid content
            o.syncon = 0;
            // no alt rows
            o.alt = 0;
        },

        checkoutItem: function (o) {
            var api = o.api;

            // render item (row)
            api.itmf = function (opt) {
                var content = '';

                // get column value
                function val(col, cls) {
                    return aweUtils.gcvw(api, col, opt, cls);
                }

                var item = opt.itm;

                var colPic = aweUtils.columnByBind(o, 'Picture');
                if (item.Removed) {
                    content += "<div><span class='crtItmName'>" + item.Name + "</span> has been removed from your cart because it isn't available at this moment.</div>";
                }
                else {
                    content += "<div class='crtImg'>" + val(colPic) + "</div>" +
                        "<input type='hidden' name='[" + opt.rowIndex + "].ItemId' value='" + item.Id + "' />" +
                        "<input type='hidden' name='[" + opt.rowIndex + "].Quantity' value='" + item.Quantity + "' />" +
                        "<input type='hidden' name='[" + opt.rowIndex + "].Price' value='" + item.Price + "' />" +
                        "<div><p class='crtItmName'>" + item.Name + "</p>" +
                        "<p class='crtItmSmallPrice'> $" + item.Price + "</p>" +
                        "Quantity: " + item.Quantity +
                        "</div>" +

                        "<div class='crtItmPrice'> $" + item.PriceStr + "</div>";
                    opt.clss += ' cartItem';
                }


                var attr = opt.attr;
                attr += ' class="' + opt.clss + '"';
                opt.style && (attr += ' style="' + opt.style + '"');

                return '<div ' + attr + '>' + content + '</div>';
            };

            // ignore columns width for grid content
            o.syncon = 0;
            // no alt rows
            o.alt = 0;
        }
    };
}(jQuery);