var prodPg = function () {    

    function init() {
        var mainImg = $('#mainImg');
        var pgMainImg = $('.pd-pgMainImg');
        var screen = $('.pd-zoomScreen');
        var details = $('.pd-details');
        var pdzoom = $('.pd-zoom');
        var popScreen = $('.pd-popZoomScreen');
        var mlens = $('#magnifierLens');

        function changeMainImg() {
            var thumb = $(this);
            var dtimg = thumb.data('img');
            $('.mainImg').attr('src', dtimg);
            $('.pd-thumb').removeClass('awe-focus');
            $('.pd-thumb[data-img="' + dtimg + '"]').addClass('awe-focus');
            popScreen.css('background-image', 'url(' + dtimg + ')');
            resetPopupZoomCont();
        }

        function popZoomMouseMove(e) {
            var cpos = popScreen.offset();

            var xi = e.clientX - cpos.left;
            var yi = e.clientY - cpos.top;

            var contw = popScreen.width();
            var conth = popScreen.height();
            var nw = mainImg[0].naturalWidth;
            var nh = mainImg[0].naturalHeight;
            var rt = Math.max(nw / contw, nh / conth);

            var renw = nw / rt;
            var renh = nh / rt;

            var contWidthSpace = (contw - renw) / 2;
            var contHeightSpace = (conth - renh) / 2;

            var bgw = Math.max(nw, contw * 1.1);
            var bgh = bgw * nh / nw;

            var maxX = bgw - contw;
            var maxY = bgh - conth;

            var snapLimW = renw / bgw * 200;
            var snapLimH = renh / bgh * 200;
            var zoomRtx = maxX / (contw - snapLimW * 2);


            var zoomRty = maxY / (conth - snapLimH * 2);

            xi -= snapLimW;
            yi -= snapLimH;

            var bx = xi * zoomRtx;

            var by = yi * zoomRty;

            // limit background x y
            if (bx < 0) bx = 0;
            if (by < 0) by = 0;

            if (bx > maxX) bx = Math.max(maxX, 0);

            if (by > maxY) by = Math.max(maxY, 0);

            popScreen.css('background-position-x', -bx);
            popScreen.css('background-position-y', -by);
            popScreen.css('background-size', bgw);
        }

        function resetPopupZoomCont() {
            popScreen.css('background-size', 'contain');
            popScreen.css('background-position-x', '');
            popScreen.css('background-position-y', '');

            popScreen.removeClass('zoomed');
            popScreen.off('mousemove', popZoomMouseMove);
        }

        function calcPopZoom(e) {
            popScreen.toggleClass('zoomed');
            if (!popScreen.hasClass('zoomed')) {
                resetPopupZoomCont();
                return;
            }

            popScreen.on('mousemove', popZoomMouseMove)

            popZoomMouseMove(e);
        }

        var imgRoll = $('.imgRoll');
        var imgClick = $('.imgClick').hide();

        $(document).on('click', '.pd-thumb', changeMainImg);
        $(document).on('mousemove', '.pd-thumb.onmove', changeMainImg);
        var isOpen = 0;

        function openZoom() {
            if ($(window).width() < 700) return;
            if (isOpen) return;
            pdzoom.addClass('visib');
            mlens.addClass('visib');

            $(document).on('mousemove click keydown', outActCloseZoom);
            imgClick.show();
            imgRoll.hide();
        }

        function outActCloseZoom(e) {
            if ($(e.target).is(mainImg)) return;
            if ($(e.target).is(mlens)) return;

            closeZoom();
        }

        function closeZoom() {
            pdzoom.removeClass('visib');
            mlens.removeClass('visib');

            $(document).off('mousemove click keydown', outActCloseZoom);

            imgClick.hide();
            imgRoll.show();
        }

        popScreen.on('click', calcPopZoom);

        mlens.on('mousemove', mainImgHover);
        pgMainImg.on('mousemove', mainImgHover);

        function mainImgHover(e) {
            openZoom();

            var dpos = details.position();
            var win = $(window);
            var screenw = win.width() - dpos.left - 30;

            var contw = mainImg.width();
            var conth = mainImg.height();
            var nw = mainImg[0].naturalWidth;
            var nh = mainImg[0].naturalHeight;
            var rt = Math.max(nw / contw, nh / conth);

            var renw = nw / rt;
            var renh = nh / rt;
            var imgRt = nh / nw;

            var screenh = Math.min(screenw * imgRt, win.height() - dpos.top) - 100;

            var contWidthSpace = (contw - renw) / 2;
            var contHeightSpace = (conth - renh) / 2;

            var mpos = mainImg.offset();

            var x0 = mpos.left + contWidthSpace;
            var x1 = mpos.left + contw - contWidthSpace;
            var y0 = mpos.top + contHeightSpace;
            var y1 = mpos.top + conth - contHeightSpace;

            var xi = e.clientX - x0;
            var yi = e.clientY - y0;

            if (xi < 0 || e.clientX > x1 || yi < 0 || e.clientY > y1) {
                closeZoom();
                return;
            }

            pdzoom.css('top', dpos.top);
            pdzoom.css('left', dpos.left);
            pdzoom.css('width', screenw);
            pdzoom.css('height', screenh);


            var bgw = Math.max(nw, screenw * 1.3);
            var bgh = bgw * nh / nw;

            var screenRt = renw / bgw;


            var maxX = bgw - screenw;
            var maxY = bgh - screenh;

            var snapLimW = renw / bgw * screenw / 2;
            var snapLimH = renh / bgh * screenh / 2;
            var zoomRtx = maxX / (renw - snapLimW * 2);
            var zoomRty = maxY / (renh - snapLimH * 2);

            xi -= snapLimW;
            yi -= snapLimH;

            var bx = xi * zoomRtx;
            var by = yi * zoomRty;

            // limit background x y
            if (bx < 0) bx = 0;
            if (by < 0) by = 0;

            if (bx > maxX) bx = Math.max(maxX, 0);

            if (by > maxY) by = Math.max(maxY, 0);

            mlens.css('top', by / zoomRty + contHeightSpace);
            mlens.css('left', bx / zoomRtx + contWidthSpace);

            mlens.css('width', screenw * screenRt);
            mlens.css('height', screenh * screenRt);

            screen.css('background-image', 'url(' + mainImg.attr('src') + ')');
            screen.css('background-position-x', -bx);
            screen.css('background-position-y', -by);
            screen.css('background-size', bgw);
        }

        function mainImgClick() {
            if ($(window).width() < 700) return;
            var viewPics = $('.pd-viewPics');
            awe.open({
                popupClass: 'popupImgZoom',
                setCont: function (sp, o) {
                    o.scon.append(viewPics);
                },
                close: function () {
                    $('#pd').prepend(viewPics);
                },
                modal: true,
                outClickClose: true
            });
        }

        mlens.on('click', mainImgClick);
        pgMainImg.on('click', mainImgClick);
    }

    function initRichDesc(opt) {
        //var url = '@Url.Action("GetRichDescModel")';
        var productId = opt.id;
        $.get(opt.url, { id: productId }, function (res) {
            mainNode = res ? JSON.parse(res) : { type: 'cont', children: [] };
            
            var res = richTextRenderer({ productId: productId }).renderNode({ node: mainNode, n: 1 });

            $('#richDescription').html(res);
        });
    }

    return {
        init: init,
        initRichDesc: initRichDesc
    };
}();

$(function () {
    prodPg.init();
});