var richTextRenderer = function (mainOpt) {    
    var renderers = mainOpt.renderers || {
        'cont': function (opt) {
            var node = opt.node;
            var res = '<div class="edcont">'            

            if (node.children) {
                awef.loop(node.children, function (childNode) {
                    res += opt.renderNode({ node: childNode, parent: node, n: ++opt.n });
                });
            }

            res += '</div>';

            return res;
        },
        'text': function (opt) {
            return awef.encode(opt.node.text).replaceAll('\n', '<br/>');
        },
        'richText': function (opt) {            
            return opt.node.text;
        }, 
        'img': function (opt) {            
            var url = sitePictures.prodPicUrl(mainOpt.productId, opt.node.opt.name);
            return '<div class="richImgCont"><img class="richImg" src="' + url + '" /></div>';
        },
        'htmlyt': function (opt) {
            return '<div class="richYTHtmlCont">'+ opt.node.text + '</div>';
        }
    };

    function renderNode(opt) {        
        opt.renderNode = renderNode;
        var renderer = renderers[opt.node.type];
        var res = renderer(opt);
        return res;
    }

    return {
        renderNode: renderNode
    };
};