var sitePictures = function () {
    var picsUrl;
    var saveUrl;
    var deleteUrl;
    var cdata;

    function prodPicUrl(productId, name) {
        return '/pictures/Products/' + productId + '/' + name;
    }

    function updateUplGrid() {
        $('#picsGrid').data('api').load();
    }

    function getUplIndexByName(name) {
        var res;
        awef.loop(cdata, function (pic, i) {
            if (pic.name == name) {
                res = i;

                return false;
            }
        });

        return res;
    }

    function getPicsData(sgp) {
        var gp = aweUtils.getGridParams(sgp);

        function map(o) {
            var res = {
                url: o.url,
                size: o.file ? o.file.size : o.Size || '',
                name: o.name || o.Name,
                isNew: !!o.origName,
                cropUrl: o.cropUrl,
                crop: o.crop
            };

            return res;
        };

        if (cdata) return build();

        return $.when(awe.ajx({ url: picsUrl, data: sgp }))
            .then(function (res) {
                awef.loop(res, function (ritm) {
                    ritm.url = prodPicUrl(gp.productId, ritm.Name);
                    ritm.saved = 1;
                    ritm.name = ritm.Name;
                });

                cdata = res;

                return build();
            });

        function build() {
            return aweUtils.gridModelBuilder(
                {
                    gp: gp,
                    items: cdata,
                    key: "name",
                    map: map,
                    defaultKeySort: aweUtils.Sort.None
                });
        }
    }


    function init(opt) {
        picsUrl = opt.picsUrl;
        saveUrl = opt.saveUrl;
        deleteUrl = opt.deleteUrl;

        var mainCont = $('#mainPicsCont');
        var grid = $('#picsGrid');
        var cropCont = $('#cropCont');
        var editor = $('#cropEditor');
        var cropper;
        var cropId;
        var cropPopup;

        function regCrop() {
            grid.on('click', '.btnCrop', function (e) {
                var row = $(this).closest('.awe-row');
                var model = aweUtils.model(row)
                cropId = model.name;

                // add image to crop div
                var image = new Image();
                image.src = model.url;
                editor.empty().append(image);

                $('#img' + model.name)
                    .css('background-image', 'none')
                    .css('background', 'white');

                cropCont.show();

                if (mainCont.width() < 1000) {
                    cropPopup = awe.open({
                        setCont: function (sp, o) {
                            o.scon.append(cropCont);
                        },
                        close: function () {
                            mainCont.append(cropCont);
                            cropClose();
                        },
                        dropdown: 1,
                        modal: 1,
                        outClickClose: 1
                    });
                }

                cropper = new Cropper(
                    image,
                    {
                        viewMode: 2,
                        autoCropArea: 1,
                        preview: '#img' + model.name
                    });
            });

            sitePictures.setAspectRatio = function (ratio) {
                cropper.setAspectRatio(ratio);
            }

            $('#btnExecCrop').on('click', function () {
                var i = getUplIndexByName(cropId);

                if (!i) {
                    cropClose();
                    return;
                }

                var model = cdata[i];
                model.crop = cropper.getData();

                var canvas = cropper.getCroppedCanvas({
                    width: 120,
                    height: 120,
                    imageSmoothingEnabled: true,
                    imageSmoothingQuality: 'high',
                    fillColor: '#fff'
                });

                canvas.toBlob(function (blob) {
                    model.cropUrl = URL.createObjectURL(blob);

                    cropClose();

                    updateUplGrid();
                });
            });

            $('#btnCancelCrop').on('click', cropClose);

            function cropClose() {
                cropper.destroy();
                editor.empty();
                cropCont.hide();
                cropPopup && cropPopup.data('api').close();
                cropPopup = null;
            }
        }

        function regReorder() {
            grid.on('awedrop', function (e, data) {
                var row = $(e.target);

                var keys = grid.find('.awe-row').map(function () {
                    return $(this).data('k');
                }).get();

                var kdata = {};
                awef.loop(cdata, function (itm) {
                    kdata[itm.name] = itm;
                })

                cdata.length = 0;
                awef.loop(keys, function (key) {
                    cdata.push(kdata[key]);
                });
            });
        }

        var uplinp = $('#picFiles');

        var uid = 1;

        function addFiles(files) {
            awef.loop(files, function (file) {
                var res = { file: file, name: 'new' + uid++, origName: file.name };
                var imgurl = URL.createObjectURL(file);
                res.url = imgurl;

                cdata.push(res);
                updateUplGrid();
            });
        }

        function bindManualUpload(uplinp) {
            uplinp.on('change', function (e) {
                var uplElm = uplinp[0];

                if (!uplElm.files) return;

                addFiles(uplElm.files);

                uplinp.val('');
            });
        }

        bindManualUpload($('#file'));
        bindManualUpload(uplinp);

        function regDragUpload() {
            var isAdvancedUpload = function () {
                var div = document.createElement('div');
                return (('draggable' in div) || ('ondragstart' in div && 'ondrop' in div)) && 'FormData' in window && 'FileReader' in window;
            }();

            if (isAdvancedUpload) {
                var $form = $('#myDropCont');
                var dropReg = $('.fdropCont');

                dropReg.addClass('has-advanced-upload');

                var droppedFiles = false;

                $form.on('drag dragstart dragend dragover dragenter dragleave drop', function (e) {
                    e.preventDefault();
                    e.stopPropagation();
                })
                    .on('dragover dragenter', function () {
                        $form.addClass('awe-highlight');
                    })
                    .on('dragleave dragend drop', function () {
                        $form.removeClass('awe-highlight');
                    })
                    .on('drop', function (e) {
                        droppedFiles = e.originalEvent.dataTransfer.files;
                        addFiles(droppedFiles);
                    });
            }

            $('#btnUpload').on('click', function () {
                uplinp.trigger('click');
            });
        }


        regDragUpload();

        regCrop();

        regReorder();


        $('#btnSavePics').on('click', function () {
            var formData = new FormData();
            formData.append('productId', $('#productId').val());

            awef.loop(cdata, function (pic, i) {
                formData.append('[' + i + '].File', pic.file);
                formData.append('[' + i + '].OrigName', pic.origName);
                if (pic.saved) {
                    formData.append('[' + i + '].Name', pic.name);
                }

                if (pic.crop) {
                    formData.append('[' + i + '].CropHeight', Math.round(pic.crop.height));
                    formData.append('[' + i + '].CropWidth', Math.round(pic.crop.width));
                    formData.append('[' + i + '].CropX', Math.round(pic.crop.x));
                    formData.append('[' + i + '].CropY', Math.round(pic.crop.y));
                }
            });

            awe.ajx({
                url: saveUrl,
                data: formData,
                success: function (data) {
                    console.log('saved', data);
                    cdata = null;
                    updateUplGrid();

                    awem.notif('pictures have been saved', 5000);

                    if (data.errors) {
                        var msg = '';
                        awef.loop(data.errors, function (err) {
                            msg += err + '<br/>';
                        })

                        msg && awem.notif(msg, 0, 'err');
                    }
                },

                // for jquery not to stringify formdata
                contentType: false,
                processData: false
            });
        });
    }

    return {
        init: init,
        getPicsData: getPicsData,
        deleteUplImg: function (name) {
        var i = getUplIndexByName(name);
        var pic = cdata[i];

        awe.open(
            {
                setCont: function (sp, o) {
                    var cont = $('<div style="padding: 0 3em;">Are you sure you want to delete this picture ?</div>');
                    o.scon.html(cont);
                },
                btns: [
                    {
                        text: 'Yes',
                        ok: 1, // add okbtn class
                        action: function () {
                            $(this).data('api').close();

                            execDelete();
                        }
                    },
                    {
                        text: 'No',
                        action: function () {
                            $(this).data('api').close();
                        }
                    }],
                height: 200,
                width: 500,
                title: 'please confirm',
                modal: true
            });

        function execDelete() {
            if (pic.saved) {
                awe.ajx({
                    url: deleteUrl,
                    data: { name: name, productId: $('#productId').val() }
                })
                    .done(function () {
                        awem.notif('deleted picture ' + name + ' from server', 3);
                    });
            }
            else {
                URL.revokeObjectURL(pic.url);
                URL.revokeObjectURL(pic.cropUrl);
            }

            cdata.splice(i, 1);
            updateUplGrid();
        }
    },
        uplImg: function (model) {
            if (!model.url) return;

            var res = '<div class="uplImgCont" id="img' + model.name + '"><img  src="' + (model.cropUrl || model.url) + '" /></div>';

            if (model.isNew) {
                res += '<div class="cropBtnCont"><button type="button" class="btnCrop awe-btn">Crop</button></div>';
            } else {

            }

            return res;
        },

        uplSize: function (picSelector) {
            return function (model) {
                var res = '';

                if (picSelector) {
                    if (model.isNew) {
                        res += '(click Save Pictures before selecting)</br>';
                    }
                    else {
                        res += '<button type="button" class="awe-btn btnSelectPic">Select</button></br>';
                    }
                    
                }

                res += model.name + '</br>';

                res += model.size / 1000 + ' KB';
                if (model.isNew) {
                    res += ' (browser)';
                }

                return res;
            }
        },

        dragColumn: function (model) {
            return '<div><span class="rowDragHandle"><i class="gg-menu-grid-o"></i></span></div>';
        },
        prodPicUrl: prodPicUrl
    };
}();