﻿<%@ Page Title="Home Page" Language="C#" MasterPageFile="~/Site.Master" AutoEventWireup="true" CodeBehind="Default.aspx.cs" Inherits="WebFormsMinSetupDemo._Default" %>
<asp:Content ID="BodyContent" ContentPlaceHolderID="MainContent" runat="server">

    <h1>Grid Crud Demo - ASP.net Web-Forms Awesome</h1>
    <% var grid = DinnersGrid.ClientID; %>
    <%=Page.InitCrudPopupsForGrid(grid, "DinnersGridCrud") %>
    
    <div class="bar">
        <button type="button" onclick="awe.open('create<%=grid %>')" class="awe-btn">Create</button>
    </div>

    <% DinnersGrid.Grid()
           .Mod(o => o.Main().ColumnsAutohide())
           .Url(Page.Url().Action("GridGetItems", "DinnersGridCrud"))
           .Resizable()
           .Reorderable()
           .Height(350)
           .Columns(
               new Column{Name = "Id", Width = 100 },
               new Column{Name = "Name"}.Mod(o => o.Nohide()),
               new Column{Name = "Date"},
               new Column{Name = "Chef.FirstName,Chef.LastName", ClientFormat = ".(ChefName)", Header = "Chef"},
               new Column{ClientFormat = ".(Meals)", Header = "Meals"},
               Page.EditColumnForGrid(grid),
               Page.DeleteColumnForGrid(grid)
               ); %>
    <awe:Ocon runat="server" ID="DinnersGrid" />
    <br/>
<div style="width: 100%; overflow: auto;">
    Grid crud, built using the Grid and PopupForm helpers called via InitCrudPopupsForGrid, <br />
    each PopupForm has Success js function assigned, these functions are located in aweUtils.js.
    Create post action returns the grid model for the new Item so the js func will render and append it.<br />
    Post actions return a json object which tells the PopupForm that the result is a success, that json object contains the id property which is used to flash the row.
    <br />
    Delete PopupForm has OnLoad js func used to animate the row that is about to be deleted.    
    <br />
    <br />
    Make sure to use "return PartialView" for PopupForm/Popup views this will ignore _viewstart.cshtml so that you don't use the _Layout.cshtml and realod all the scripts, and as a result break the js.
</div>
<br />
<br />
<br />
</asp:Content>