import { Component, OnInit } from '@angular/core';
import { awe, awem, aweui, aweUtils } from 'src/js/aweui/all.js';
import { site } from 'src/js/site.js';
import * as $ from 'jquery';

@Component({
  selector: 'app-root',
  templateUrl: './app.component.html',
  styleUrls: ['./app.component.css']
})

export class AppComponent implements OnInit {
  downloadsOpt = {
    func: aweui.radioList,
    opt: {
      dataFunc: site.getDownloads,
      menuDropdown: {
        caption: 'downloads',
        autoSearch: false,
        popupClass: 'downlMenu',
        popupMaxHeight: 0,
        openOnHover: true
      }
    }
  };


  ngOnInit(): void {
    // begin init aweui
    awem.isMobileOrTablet = function () { return !!0; };

    // first day of week
    awem.fdw = 0;

    // set date format, isMobile, decimal separator
    aweUtils.init('MM/d/yyyy', 0, '.');

    // sets default dictionary
    aweui.init();

    // so we could call aweui, awe outside angular, used for popups
    window["aweui"] = aweui;
    window["awe"] = awe;
    window["$"] = $;
    // end init aweui

    site.documentReady();

  }
}