import { BrowserModule } from '@angular/platform-browser';
import { NgModule } from '@angular/core';
import { RouterModule } from '@angular/router';
import { ReactiveFormsModule } from '@angular/forms';

//import { AppRoutingModule } from './app-routing.module';
import { AweInputComponent } from './aweui/awe-input/awe-input.component';
import { AweGridComponent } from './aweui/awe-grid/awe-grid.component';
import { PopupContComponent } from './popupCont/popupCont.component';

import { AppComponent } from './app.component';
import { AboutComponent } from './about/about.component';
import { MainComponent } from './main/main.component';
import { GridInlineEditComponent } from './grid-inline-edit/grid-inline-edit.component';
import { GridDemoComponent } from './grid-demo/grid-demo.component';
import { GridCrudComponent } from './grid-crud/grid-crud.component';
import { DragAndDropComponent } from './drag-and-drop/drag-and-drop.component';
import { FormsModule } from '@angular/forms';
import { FormInputsComponent } from "./form-inputs/form-inputs.component";
import { PopupComponent } from './popup/popup.component';


@NgModule({
  imports: [
    FormsModule,
    BrowserModule,
    ReactiveFormsModule,
    RouterModule.forRoot([
      { path: '', component: MainComponent },
      { path: 'form-inputs', component: FormInputsComponent },
      { path: 'grid-inline-edit', component: GridInlineEditComponent },
      { path: 'grid-crud', component: GridCrudComponent },
      { path: 'grid-demo', component: GridDemoComponent },
      { path: 'popup', component: PopupComponent },
      { path: 'drag-and-drop', component: DragAndDropComponent },
      { path: 'about', component: AboutComponent },
    ])
  ],
  declarations: [
    AppComponent,
    AboutComponent,
    MainComponent,
    FormInputsComponent,    
    GridInlineEditComponent,
    GridDemoComponent,
    GridCrudComponent,
    DragAndDropComponent,
    AweInputComponent,
    PopupComponent,
    AweGridComponent,
    PopupContComponent
  ],
  bootstrap: [ AppComponent ]
})
export class AppModule { }