import { Component, AfterViewInit, Input, ViewChild, OnDestroy } from '@angular/core';
import { awe, awem, aweui, aweUtils } from 'src/js/aweui/all.js';
import * as $ from 'jquery';

@Component({
  selector: 'awe-grid',
  templateUrl: './awe-grid.component.html',
  styleUrls: ['./awe-grid.component.css']
})
export class AweGridComponent implements AfterViewInit, OnDestroy {

  // used to generate unique ids
  static autoinc: number = 1;

  // component options    
  @Input() copt;

  @ViewChild('location') location;
  
  private o;

  constructor() { }

  ngAfterViewInit(): void {
    var compOpt = this.copt;
    if (!compOpt) {
      console.warn('grid [copt] component options not specified');
      return;
    }

    if (!compOpt.id) {
      compOpt.id = 'aweGrid' + AweGridComponent.autoinc++;
    }

    var $div = $(this.location.nativeElement);

    $div.attr('id', compOpt.id);

    var self = this;
    setTimeout(function () {
      aweui.grid(compOpt);
      self.o = $div.data('o');
    });
  }

  ngOnDestroy(): void {
    awe.destroy(this.o);
  }
}