import { Component, OnInit } from '@angular/core';
import { awe, awem, aweui, aweUtils } from 'src/js/aweui/all.js';
import { site } from 'src/js/site.js';
import * as $ from 'jquery';

@Component({
  selector: 'app-drag-and-drop',
  templateUrl: './drag-and-drop.component.html',
  styleUrls: ['./drag-and-drop.component.css']
})
export class DragAndDropComponent implements OnInit {

  constructor() { }

  ngOnInit(): void {
    awem.dragAndDrop({
      from: $('.dropZone'),
      sel: '.dragItem', // what we can drag
      dropSel: '.dropZone', // where we can drop
      //tof: function() {
      //    // alternative way to determine where we are allowed to drop
      //    // evaluated when we start dragging
      //    return $('.dropZone').map(function (i, el) { return $(el); }).get();
      //},
      hover: function (cx) {
        cx.cont.addClass('awe-highlight');
      },
      drop: function (cx) {
        cx.cont.append(cx.drgo);
      },
      reshov: function () {
        $('.dropZone').removeClass('awe-highlight');
      },
      hide: 1 // hide drag object while dragging
    });


    // cards and items

    awem.dragReor({ from: $('#board1 .card'), to: '#board1 .card', sel: '.item' });

    // don't drag board when mouse down on .item
    function cancel(cx) { return $(cx.e.target).closest('.item').length; }

    awem.dragReor({ from: $('#board1'), to: '#board1', sel: '.card', cancel: cancel });

    // write to log
    $('#board1').on('awedrop',
      function (e, data) {
        var o = $(e.target);
        var msg = name(o) +
          ' moved from ' +
          name(data.from) +
          ' to ' +
          name(o.parent()) +
          ' | previ = ' +
          data.previ +
          ' newi = ' +
          o.index();
        $('#logci').html(msg + '</br>');
      });

    function name(o) {
      var r = o.attr('class');
      if (o.data('k')) r += ' ' + o.data('k');
      if (o.hasClass('item')) r = o.html();
      return r;
    }
  }
}