import { Component, OnInit } from '@angular/core';
import { awe, awem, aweui, aweUtils } from 'src/js/aweui/all.js';
import { gridUtils } from 'src/js/infra/gridUtils.js';
import { dinnersInlCrudCon } from 'src/js/cons/dinnersInlCrudCon.js';
import { dinnersCrudCon } from 'src/js/cons/dinnersCrudCon.js';
import { dataCon } from 'src/js/cons/dataCon.js';
import * as $ from 'jquery';

@Component({
  selector: 'app-grid-crud',
  templateUrl: './grid-crud.component.html',
  styleUrls: ['./grid-crud.component.css']
})
export class GridCrudComponent implements OnInit {
  gridCrudId = 'GridCrud1';
  gridCrudCopt = {
    id: this.gridCrudId,
    dataFunc: dinnersCrudCon.grid,
    height: 350,
    columns: [
      { bind: 'id', width: 75, groupable: false },
      { bind: 'name' },
      { bind: 'date', width: 120 },
      {
        bind: "chef.firstName,chef.lastName",
        clientFormat: ".(chefName)",
        header: "chef"
      },
      { clientFormat: '.(meals)', header: 'meals', mod: { autohide: true } },
      {
        bind: 'bonusMeal.name',
        clientFormat: '.(bonusMeal)',
        header: 'bonus meal',
        width: 150
      },
      { bind: 'organic', width: 100 },
      { clientFormat: gridUtils.editFormatForGrid({ gridId: this.gridCrudId }), width: 70 },
      { clientFormat: gridUtils.inlineDeleteFormatForGrid(this.gridCrudId), width: 70 }
    ],
    parents: [
      { id: 'gridCrudSearch1', name: 'search', load: false }
    ],
    mod: {
      pageSize: true,
      columnsSelector: true,
      pageInfo: true
    }
  };

  onGridSearch(event) {
    $('#' + this.gridCrudId).data('api').load();
  }

  ngOnInit(): void {
    var gridCrudId = 'GridCrud1';
    gridUtils.initCrudPopupsForGrid({
      gridId: gridCrudId,
      createCont: dinnersCrudCon.create,
      createPost: dinnersCrudCon.createPost,
      editCont: dinnersCrudCon.edit,
      editPost: dinnersCrudCon.editPost,
      deleteDataFunc: dinnersInlCrudCon.confirmDelete,
      deletePostFunc: dinnersInlCrudCon.del
    });

    $('#gridCrudSearch1').on('keyup',
      function () {
        $('#' + gridCrudId).data('api').load();
      });
  }
}