import { Component, OnInit } from '@angular/core';
import { dataCon } from 'src/js/cons/dataCon.js';
import * as $ from 'jquery';

@Component({
  selector: 'app-grid-demo',
  templateUrl: './grid-demo.component.html',
  styleUrls: ['./grid-demo.component.css']
})
export class GridDemoComponent implements OnInit {

  gridOpt = {
    id: 'grid1',
    dataFunc: dataCon.lunchGrid,
    height: 350,
    reorderable: true,
    columns: [
      { bind: 'id', width: 75, groupable: false },
      { bind: 'person' },
      { bind: 'food' },
      { bind: 'organic'},
      { bind: 'country.name', clientFormat: '.(countryName)', header: 'country' },
      { bind: 'date', width: 120 },
      { bind: 'location', mod: { autohide: true } },
      { bind: "chef.firstName,chef.lastName", clientFormat: ".(chefName)", header: "chef" }
    ],
    mod: {
      pageSize: true, // page size dropdown
      columnsSelector: true, // show/hide columns from dropdown in bottom right corner 
      pageInfo: true, 
      loading: true, // loading animation 
      
      // columns will show/hide automatically based on available width and what columns the user has hidden/shown from the columnsSelector
      // you can also set autohide:true/false for each column
      //columnsAutohide: true,       
      
      freeze: { left: 2, right: 1}
    }
  };

  onGridSearch(event) {
     $('#grid1').data('api').load({params: { search: event.target.value }});
  }

  ngOnInit(): void {
  }
}