/* eslint-disable */
import * as jQuery from 'jquery';
import { awef, awe, aweui, aweUtils } from './aweui/all.js';

var site = function ($) {
  var root;
  var foodDir = 'assets/pictures/Food/';

  function documentReady() {
    $('body').addClass('gui3');
    root = document.root || '';

    setupFmwPicker();

    layPage();
    $(window).on('resize', layPage);

    $('#btnMenuToggle').click(function () {
      menuToggle($('#demoMenu').is(':visible'));
    });

    var lastw = 0;
    function layPage() {
      var ww = $(window).width();

      $("#main").css("min-height", ($(window).height() - 120) + "px");
      $("#demoMenu").css("min-height", ($(window).height()) + "px");
      $('#maincont').css("min-height", $(window).height() - ($('#header').outerHeight() + 110));
      if (lastw !== ww) {
        menuToggle(ww < 1050);
      }

      lastw = ww;
    }
  }

  function setupFmwPicker() {
    var lastw = 1001;
    function setFmwPicker(ww) {
      awe.destroy($('#ddlFmw').data('o'));
      var cfg = {
        id: 'ddlFmw',
        dataFunc: function () {
          return [
            { c: 'aweui (Angular, React, Vue)', k: 'https://aweui.aspnetawesome.com' },
            { c: 'ASP.net Core/MVC', k: 'https://demo.aspnetawesome.com' },
            { c: 'Angular demo', k: 'https://angular.aspnetawesome.com' },
            { c: 'ProDinner Demo (ASP.net Core, EFCore)', k: 'https://prodinner.aspnetawesome.com' },
            { c: 'ASP.net Web-Forms', k: 'https://demowf.aspnetawesome.com' },
            { k: "", c: "", cs: "o-litm", nv: 1 },
            { c: 'See downloads list', k: 'https://www.aspnetawesome.com/#All-Downloads' },
          ];
        }
      };

      if (ww > 1000) {
        cfg.odropdown = {
          favCount: 2,
          openOnHover: true,
          asmi: -1, // no autosearch
        };
      } else {
        cfg.odropdown =
        {
          openOnHover: true
        }
      }

      aweui.radioList(cfg);

      lastw = ww;
    }

    setFmwPicker($(window).width());
    $(window).on('resize', function () {
      var ww = $(window).width();

      if (lastw > 1000 && ww < 1000 || lastw < 1000 && ww > 1000) {
        setFmwPicker(ww);
      }
    });

    $('#ddlFmw').on('change', function () {
      window.location.href = $(this).val();
    });
  }

  function menuToggle(hide) {
    var page = $('#demoPage').show();
    var menu = $('#demoMenu').css('width', '').css('position', '');

    if (hide) {
      menu.hide();
      page.css('margin-left', "0");
      $('#btnMenuToggle').show().removeClass('on');
      $('body').trigger('awedomlay');
    } else {
      menu.show();

      page.css('margin-left', "14.5em");

      if (page.width() < 200) {
        page.hide();
        menu.css('width', '100%');
        menu.css('position', 'static');
      }

      $('#btnMenuToggle').addClass('on');

      $('body').trigger('awedomlay');
    }
  }

  function slide(popup) {
    var o = popup.data('o');
    var maxtop = $(window).height();
    var div = popup.closest('.o-pmc');

    o.nolay = 1;

    div.css('transform', 'translateY(' + maxtop + 'px)');

    setTimeout(function () {
      div.css('transition', '.5s');
      div.css('transform', 'translateY(0)');
      setTimeout(function () {
        o.nolay = 0;
        div.css('transition', '');
        div.css('transform', '');
        o.cx.api.lay();
      }, 500);
    }, 30);
  }

  return {
    imgItem: function (itm) {
      return '<div class="o-igit">' +
        (itm.url ? '<img width="45" height="33" alt="item" src="' + itm.url + '"/>' : '')
        + awef.encode(itm.c) + '</div>';
    },
    imgFood: function (itm) {
      var img = itm.FoodPic
        ? '<img src="' + root + foodDir + itm.FoodPic + '" class="food" />'
        : '';

      return img + awef.encode(itm.Food);
    },
    imgFoodCaption: function (itm) {
      return '<img class="cthumb" src="' + root + foodDir + itm.url + '" />' + awef.encode(itm.c);
    },
    imgFoodItem: function (itm) {
      return '<div class="o-igit"><img src="' + root + foodDir + itm.url + '"/>' + awef.encode(itm.c) + '</div>';
    },
    documentReady: documentReady,
    slide: slide,
    getDownloads: function () {
      return [
        { k: "https://www.aspnetawesome.com/Download/AweuiAngularDemo", c: "Angular demo (this demo)" },
        { k: "https://www.aspnetawesome.com/Download/AweuiDemo", c: "aweui demo (html/js/css only)" },
        { k: "https://www.aspnetawesome.com/Download/AweuiAspDemo", c: "aweui demo (asp.net core solution)" },
        { k: "https://www.aspnetawesome.com/Download/AweuiReactDemo", c: "React.js demo" },
        { k: "https://www.aspnetawesome.com/Download/AweuiVueDemo", c: "Vue.js demo" },
        { k: "https://www.aspnetawesome.com/Download/AweuiTrial", c: "aweui library (js/css)" },
        { k: "", c: "", cs: "o-litm", nv: 1 },
        { k: "", c: "See also:", cs: "citm", nv: 1 },
        { k: "https://demo.aspnetawesome.com", c: "ASP.net Core Awesome demo" }
      ];
    },
  };
}(jQuery);

export { site };