import React from 'react';
import $ from 'jquery';
import { awe, aweui } from '../aweui/all';

export default class Aweinp extends React.Component {
  componentDidMount() {
    this.$el = $(this.el);
    this.handleChange = this.handleChange.bind(this);
    var self = this;

    this.$el.on('change', function (event, data) {
      // ignore change when we triggered it from componentDidUpdate, and not a parent change load
      if (data == null || data.ign !== true) {
        self.handleChange(event);
      }
    });

    var opt = this.props.opt;
    opt.elm = this.el;
    opt.func && opt.func(opt);    
  }

  componentDidUpdate(prevProps, prevState) {
    console.log('component did update', this.props.opt.id, prevProps.value, this.props.value);
    if (prevProps.value !== this.props.value) {
      var api = $(this.el).data('api');
      if (api) api.render();

      // trigger change, needed when this component is used as a Parent
      $(this.el).trigger('change', { ign: true });
    }
  }
  
  componentWillUnmount(){
    awe.destroy($(this.el).data('o'));
  }

  handleChange(e) {
    if (this.props.onChange) {
      this.props.onChange(e.target.value);
    }
  }

  render() {

    var type = 'hidden';

    if (this.props.opt.func === aweui.datepicker
      || this.props.opt.func === aweui.autocomplete) {
      type = 'text';
    }

    return (      
        <input ref={el => this.el = el} type={type} id={this.props.opt.id} name={this.props.opt.name} value={this.props.value} />      
    );
  }
}