import React from 'react';
import { gridUtils } from '../infra/gridUtils';
import { dinnersCrudCon } from '../cons/dinnersCrudCon';
import { dinnersInlCrudCon } from '../cons/dinnersInlCrudCon';
import AweGrid from '../awecomp/AweGrid';

export default class GridPopupCrud extends React.Component {
    constructor(props) {
        super(props);

        // grid poup crud 
        const gridCrudId = 'gridCrud1';
        gridUtils.initCrudPopupsForGrid({
            gridId: gridCrudId,
            createCont: dinnersCrudCon.create,
            createPost: dinnersCrudCon.createPost,
            editCont: dinnersCrudCon.edit,
            editPost: dinnersCrudCon.editPost,
            deleteDataFunc: dinnersInlCrudCon.confirmDelete,
            deletePostFunc: dinnersInlCrudCon.del
        });
    }

    componentDidMount() {
    }

    render() {
        const gridCrudId = 'gridCrud1';
        const gridCrud1Opt = {
            id: gridCrudId,
            dataFunc: dinnersCrudCon.grid,
            height: 350,
            columns: [
                { bind: 'id', width: 75, groupable: false },
                { bind: 'name' },
                { bind: 'date', width: 120 },
                {
                    bind: "chef.firstName,chef.lastName",
                    clientFormat: ".(chefName)",
                    header: "chef"
                },
                { clientFormat: '.(meals)', header: 'meals', mod: { autohide: true } },
                {
                    bind: 'bonusMeal.name',
                    clientFormat: '.(bonusMeal)',
                    header: 'bonus meal',
                    width: 150
                },
                { bind: 'organic', width: 100 },
                { clientFormat: gridUtils.editFormatForGrid({ gridId: gridCrudId }), width: 70 },
                { clientFormat: gridUtils.inlineDeleteFormatForGrid(gridCrudId), width: 70 }
            ],
            parents: [
                { id: 'gridCrusSearch1', name: 'search', load: false }
            ],
            mod: {
                pageSize: true,
                columnsSelector: true,
                pageInfo: true
            }
        };

        return (
            <div className="example">
                <h2>Grid Popup Crud</h2>
                <AweGrid opt={gridCrud1Opt} syncg="dinner" />
            </div>
        );
    }
}