/* eslint-disable */
var cstorg = function () {
    var prefix = "awed.";
    var version = 1;
    var data = {};

    var prsStorg = sessionStorage || {};

    if (document.ver) {        
        init(document.ver, document.dev);
    }

    function init(v, dev) {
        version = v || version;

        if (dev) {
            prsStorg = {};
        }

        // remove storage keys from older versions; current value is "awed.oldversion"
        try {
            for (var key in prsStorg) {
                if (key.indexOf(prefix) === 0) {
                    if (key.indexOf(prefix + version) !== 0) {
                        prsStorg.removeItem(key);
                    }
                }
            }
        } catch (err) {
            /*empty*/
        }
    }

    function getKey(key, sd) {
        var prm = sd ? JSON.stringify(sd) : '';
        return prefix + version + key + prm;
    }

    return {
        init: init,
        get: function (url, sd) {
            return this.getf(url, sd)();
        },
        set: function (key, ndata) {
            var pkey = getKey(key);
            data[pkey] = ndata;
            prsStorg[pkey] = JSON.stringify(data[pkey]);
        },
        getk: function (key) {
            var pkey = getKey(key);

            if (data[pkey]) {
                return data[pkey];
            }
            else if (prsStorg[pkey]) {
                var res = data[pkey] = JSON.parse(prsStorg[pkey]);
                return res;
            }
        },
        getf: function (url, sd, customKey, dataVersion) {
            return function () {
                var pkey = getKey(customKey || url, sd);

                var dobj = data[pkey];

                if (dobj) {
                    if (dataVersion) {
                        if (dobj.version == dataVersion) {
                            return dobj.data;
                        }
                    } else {
                        return dobj;
                    }
                }
                
                if (prsStorg[pkey]) {
                    var res = data[pkey] = JSON.parse(prsStorg[pkey]);

                    if (dataVersion) {
                        if (res.version == dataVersion) {
                            return res.data;
                        }
                    }
                    else {
                        return res;
                    }                    
                }

                var attempts = 1;
                function getData() {
                    return $.get(url, sd)
                        .then(
                            // done filter
                            function (rs) {
                                if (dataVersion) {
                                    rs = { data: rs, version: dataVersion };
                                }

                                data[pkey] = rs;
                                prsStorg[pkey] = JSON.stringify(rs);
                                return dataVersion ? rs.data : rs;
                            },
                            // fail filter
                            async function (rs) {
                                if (attempts > 5) return rs;

                                console.log('try again ' + attempts);
                                attempts++;
                                await new Promise(r => setTimeout(r, 30));
                                return getData();
                            }
                        );
                }

                var xhr = getData();
                data[pkey] = xhr;
                return xhr;
                
            }
        }
    };
}();

export {cstorg};